/*------------------------------------------------------------------------------
	インクルード
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <stdarg.h>

/*------------------------------------------------------------------------------
	デファイン
------------------------------------------------------------------------------*/
#define CNT   305
#define OUT   7
#define DAYS  21
#define MAX   34500
#define MIN   29500
#define RANGE 5000

/*------------------------------------------------------------------------------
	マクロ
------------------------------------------------------------------------------*/
#define PRINT(x, ...)  fprintf_crlf((char *)x, ##__VA_ARGS__)

/*------------------------------------------------------------------------------
	型定義
------------------------------------------------------------------------------*/
typedef char INT8;
typedef int  INT32;

/*------------------------------------------------------------------------------
	構造体
------------------------------------------------------------------------------*/
typedef struct Field {
	INT32  date;
	double sta;
	double max;
	double min;
	double end;
	double ratio;
	double trade;
} Field;

/*------------------------------------------------------------------------------
	ローカル変数
------------------------------------------------------------------------------*/
FILE *fp;

/*------------------------------------------------------------------------------
	内部参照
------------------------------------------------------------------------------*/
extern Field field[CNT];

/*------------------------------------------------------------------------------
	プロトタイプ
------------------------------------------------------------------------------*/
void difinition(void);
void fixed(void);
void value(void);
void fprintf_crlf(char *pStr, ...);

/*------------------------------------------------------------------------------
	書式：int main(void)
	引数：-
	戻値：int  -
	機能：スタートアップ
------------------------------------------------------------------------------*/
int main(void)
{
	fp = fopen("full.txt", "wb");
	if (fp == NULL) {printf("open error\r\n");}
	
	difinition();
	fixed();
	value();
	
	fclose(fp);
}

/*------------------------------------------------------------------------------
	書式：void difinition(void)
	機能：定義部分を出力
------------------------------------------------------------------------------*/
void difinition(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  色");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, RGB_BLACK,  000000");
	PRINT("DEFINE, RGB_GRAY,   C0C0C0");
	PRINT("DEFINE, RGB_RED,    F00000");
	PRINT("DEFINE, RGB_GREEN,  00F000");
	PRINT("DEFINE, RGB_BLUE,   0000F0");
	PRINT("DEFINE, RGB_MAZENTA,F000F0");
	PRINT("DEFINE, RGB_YELLOW, F0F000");
	PRINT("DEFINE, RGB_CYAN,   00F0F0");
	PRINT("DEFINE, RGB_AVE100, F0F0F0");
	PRINT("DEFINE, RGB_AVE75,  A0A0F0");
	PRINT("DEFINE, RGB_AVE25,  F0A0A0");
	PRINT("DEFINE, RGB_AVE5,   A0F0A0");
	PRINT("");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  座標");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, DAYS,      %d", DAYS);
	PRINT("DEFINE, MAX,       %d", MAX);
	PRINT("DEFINE, MIN,       %d", MIN);
	PRINT("DEFINE, RANGE,     %d", RANGE);
	PRINT("DEFINE, X1,        77");
	PRINT("DEFINE, Y1,        255");
	PRINT("DEFINE, X2,        767");
	PRINT("DEFINE, Y2,        863");
	PRINT("DEFINE, W,         (X2-X1)");
	PRINT("DEFINE, H,         (Y2-Y1)");
	PRINT("DEFINE, X_SCALE,   20");
	PRINT("DEFINE, Y_WEEKEND, (Y2+5)");
	PRINT("DEFINE, Y_34500,   (((H* 0)/10)+Y1)");
	PRINT("DEFINE, Y_34000,   (((H* 1)/10)+Y1)");
	PRINT("DEFINE, Y_33500,   (((H* 2)/10)+Y1)");
	PRINT("DEFINE, Y_33000,   (((H* 3)/10)+Y1)");
	PRINT("DEFINE, Y_32500,   (((H* 4)/10)+Y1)");
	PRINT("DEFINE, Y_32000,   (((H* 5)/10)+Y1)");
	PRINT("DEFINE, Y_31500,   (((H* 6)/10)+Y1)");
	PRINT("DEFINE, Y_31000,   (((H* 7)/10)+Y1)");
	PRINT("DEFINE, Y_30500,   (((H* 8)/10)+Y1)");
	PRINT("DEFINE, Y_30000,   (((H* 9)/10)+Y1)");
	PRINT("DEFINE, Y_29500,   (((H*10)/10)+Y1)");
	PRINT("DEFINE, gX,        (X1+18)");
	PRINT("DEFINE, gW,        (W-18*2)");
	PRINT("DEFINE, tX1,       X1");
	PRINT("DEFINE, tY1,       910");
	PRINT("DEFINE, tX2,       X2");
	PRINT("DEFINE, tY2,       1030");
	PRINT("DEFINE, tW,        W");
	PRINT("DEFINE, tH,        (tY2-tY1)");
	PRINT("DEFINE, tMAX,      300000");
	PRINT("DEFINE, tMIN,      0");
	PRINT("DEFINE, tRANGE,    3000000000");
	PRINT("DEFINE, tX_SCALE,  12");
	PRINT("DEFINE, tY_300000, (((tH*0)/6)+tY1)");
	PRINT("DEFINE, tY_250000, (((tH*1)/6)+tY1)");
	PRINT("DEFINE, tY_200000, (((tH*2)/6)+tY1)");
	PRINT("DEFINE, tY_150000, (((tH*3)/6)+tY1)");
	PRINT("DEFINE, tY_100000, (((tH*4)/6)+tY1)");
	PRINT("DEFINE, tY_050000, (((tH*5)/6)+tY1)");
	PRINT("DEFINE, tY_000000, (((tH*6)/6)+tY1)");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void fixed(void)
	機能：固定部分を出力
------------------------------------------------------------------------------*/
void fixed(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  固定");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 0, 0, 840, 1050, 000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("");
	PRINT("RECT, 45,  70,  250, 120, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 49,  74,  242, 112, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("");
	PRINT("LINE, X1, Y1, X2, Y1, RGB_BLACK, 1");
	PRINT("LINE, X1, Y1, X1, Y2, RGB_BLACK, 1");
	PRINT("LINE, X2, Y1, X2, Y2, RGB_BLACK, 1");
	PRINT("LINE, X1, Y2, X2, Y2, RGB_BLACK, 1");
	PRINT("");
	PRINT("LINE, X1+1, Y_34000, X2-1, Y_34000, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_33000, X2-1, Y_33000, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_32000, X2-1, Y_32000, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_31000, X2-1, Y_31000, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_30000, X2-1, Y_30000, RGB_GRAY, 1");
	PRINT("");
	PRINT("LINE, X1, Y_33500, X1+4, Y_33500, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_32500, X1+4, Y_32500, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_31500, X1+4, Y_31500, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_30500, X1+4, Y_30500, RGB_BLACK, 1");
	PRINT("");
	PRINT("LINE, X2-4, Y_33500, X2, Y_33500, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_32500, X2, Y_32500, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_31500, X2, Y_31500, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_30500, X2, Y_30500, RGB_BLACK, 1");
	PRINT("");
	PRINT("TEXT, X_SCALE,(Y_34000-10),34000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 20, FALSE");
	PRINT("TEXT, X_SCALE,(Y_33000-10),33000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 20, FALSE");
	PRINT("TEXT, X_SCALE,(Y_32000-10),32000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 20, FALSE");
	PRINT("TEXT, X_SCALE,(Y_31000-10),31000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 20, FALSE");
	PRINT("TEXT, X_SCALE,(Y_30000-10),30000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 20, FALSE");
	PRINT("");
	PRINT("LINE, X1,   tY_300000, X2,   tY_300000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_200000, X2,   tY_200000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_100000, X2,   tY_100000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_000000, X2,   tY_000000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_250000, X1+4, tY_250000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_150000, X1+4, tY_150000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_050000, X1+4, tY_050000, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_250000, X2,   tY_250000, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_150000, X2,   tY_150000, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_050000, X2,   tY_050000, RGB_GRAY, 1");
	PRINT("");
	PRINT("TEXT, tX_SCALE,    (tY_300000-10),300000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_200000-10),200000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_100000-10),100000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE+45, (tY_000000-10),0,      RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void value(void)
	機能：値部分を出力
------------------------------------------------------------------------------*/
void value(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  値");
	PRINT(":-------------------------------------------------------------------------------");
	
	INT32 i, j;
	INT32 cnt;
	double ave5 [CNT];
	double ave25[CNT];
	double ave75[CNT];
	double ave100[CNT];
	Field tmp[CNT];
	
	for (i = 0; i < CNT; i++) {tmp[i] = field[CNT-1-i];}
	
	for (i = 0; i < CNT; i++) {
		ave5 [i] = 0.0;
		ave25[i] = 0.0;
		ave75[i] = 0.0;
		ave100[i] = 0.0;
		
		if (4 <= i) {
			for (j = 0; j < 5; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= 5;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= cnt;
		}
		
		if (24 <= i) {
			for (j = 0; j < 25; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= 25;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= cnt;
		}
		
		if (74 <= i) {
			for (j = 0; j < 75; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= 75;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= cnt;
		}
		
		if (99 <= i) {
			for (j = 0; j < 100; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= 100;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= cnt;
		}
	}
	
	char fmt1_1[100+1] = "TEXT, 340, 25 ,日経平均 20%02X年%2X月,   RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_2[100+1] = "TEXT, 82,  95 ,%.2f,              RGB_BLACK, 000000, TRUE, Arial, 50, FALSE";
	char fmt1_3[100+1] = "TEXT, 75,  152,20%02X/%02X/%02X 15:00 現在, RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	
	if (tmp[CNT-1].end == 0) {printf("0 div error\r\n");}
	
	PRINT(fmt1_1, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8);
	PRINT(fmt1_2, tmp[CNT-1].end);
	PRINT(fmt1_3, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8,
	              (tmp[CNT-1].date & 0x000000FF)>> 0);
	
	PRINT("");
	
	INT8 fmt2_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE), %s";
	INT8 fmt2_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE)";
	INT8 fmt2_3[150+1] = "DEFINE, GY%02X_%s, (Y2-((H*(%.1f-MIN))/RANGE))";
	INT8 fmt2_4[150+1] = "DEFINE, GH%02X,     ((H*(%.1f-%.1f))/RANGE)";
	INT8 fmt2_5[150+1] = "DEFINE, GH%02X,     %d";
	INT8 fmt2_6[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), GY%02X_%s, 7, GH%02X, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT8 fmt2_7[150+1] = "LINE, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MAX, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MIN, %s 1";
	INT8 fmt2_8[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), tY2, 6, -(tH*%10.0f)/tRANGE, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT32 dt;
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave100[i], "RGB_AVE100, 7");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave100[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave75[i], "RGB_AVE75, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave75[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave25[i], "RGB_AVE25, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave25[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave5[i], "RGB_AVE5, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave5[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			PRINT(fmt2_3, dt, "STA", tmp[i].sta);
			PRINT(fmt2_3, dt, "MAX", tmp[i].max);
			PRINT(fmt2_3, dt, "MIN", tmp[i].min);
			PRINT(fmt2_3, dt, "END", tmp[i].end);
			
			if (tmp[i].end >= tmp[i].sta) {
				if ((INT32)((608*(tmp[i].end-tmp[i].sta))/RANGE) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].end, tmp[i].sta);
				}
			}
			else {
				if ((INT32)((608*(tmp[i].sta-tmp[i].end))/RANGE) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].sta, tmp[i].end);
				}
			}
			PRINT("");
		}
	}
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "END", dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "STA", dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (tmp[i].ratio > 0) {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_RED, ");
			}
			else {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_BLUE,");
			}
		}
	}
//	PRINT("");
//	
//	INT32 rate[11] = {0};
//	INT32 pos;
//	INT32 max = 0;
//	INT8 fmt3_1[200] = "RECT, 62+6-%d, (Y_%d-%d), %d*2, %d*2, 000000, RGB_BLACK, 1, 0, FALSE, TRUE, TRUE, FALSE";
//	
//	for (i = 0; i < CNT; i++) {
//		pos = (tmp[i].end - 400) / 5;
//		
//		if (pos < 0)  {continue;}
//		if (pos > 60) {continue;}
//		
//		rate[pos]++;
//	}
//	
//	for (i = 0; i < 61; i++) {
//		if (rate[i] >max) {max = rate[i];}
//	}
//	
//	for (i = 0; i < 61; i++) {
//		pos = 400+i*5;
//		
//		if (rate[i] == 0) {
//		}
//		else if (rate[i] <= ((max*1)/5)) {
//			PRINT(fmt3_1, 1, pos, 1, 1, 1);
//		}
//		else if (rate[i] <= ((max*2)/5)) {
//			PRINT(fmt3_1, 2, pos, 2, 2, 2);
//		}
//		else if (rate[i] <= ((max*3)/5)) {
//			PRINT(fmt3_1, 3, pos, 3, 3, 3);
//		}
//		else if (rate[i] <= ((max*4)/5)) {
//			PRINT(fmt3_1, 4, pos, 4, 4, 4);
//		}
//		else if (rate[i] <= ((max*5)/5)) {
//			PRINT(fmt3_1, 5, pos, 5, 5, 5);
//		}
//	}
	PRINT("");
	
	INT8 fmt4_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f* 1-MIN))/RANGE), %s";
	INT8 fmt4_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f*%2d-MIN))/RANGE)";
	
	PRINT(fmt4_1, OUT+1, ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], "RGB_AVE100, 7");
	PRINT(fmt4_2, DAYS,  ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], "RGB_AVE75, 2");
	PRINT(fmt4_2, DAYS,  ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], "RGB_AVE25, 2");
	PRINT(fmt4_2, DAYS,  ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], "RGB_AVE5, 2");
	PRINT(fmt4_2, DAYS,  ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], DAYS-OUT);
}

/*------------------------------------------------------------------------------
	書式：void fprintf_crlf(char *pStr, ...)
	引数：char *  -
	      ...     -
	機能：出力
------------------------------------------------------------------------------*/
void fprintf_crlf(char *pStr, ...)
{
	va_list args;
	
	va_start(args, pStr);
	
	vfprintf(fp, pStr, args);
	fprintf(fp, "\r\n");
	
	va_end(args); 
}

/*------------------------------------------------------------------------------
	実体
------------------------------------------------------------------------------*/
Field field[CNT] = {
	{0x231110,	32491.24,	32598.93,	32248.24,	32568.11,	 -78.35,	1638422000,},
	{0x231109,	32316.39,	32723.71,	32193.20,	32646.46,	+479.98,	1678379700,},
	{0x231108,	32457.23,	32512.17,	32049.34,	32192.61,	 -79.21,	1836008800,},
	{0x231107,	32551.77,	32591.11,	32250.93,	32271.82,	-436.66,	1592809400,},
	{0x231106,	32450.82,	32766.54,	32395.50,	32708.48,	+758.59,	2044760700,},
	{0x231102,	31987.02,	32087.13,	31878.36,	31949.89,	+348.24,	1770070000,},
	{0x231101,	31311.22,	31601.65,	31301.51,	31601.65,	+742.80,	1943960000,},
	{0x231031,	30694.96,	30973.66,	30552.65,	30858.85,	+161.89,	1984780000,},
	{0x231030,	30663.48,	30762.50,	30538.29,	30696.96,	-294.73,	2905170000,},
	{0x231027,	30713.79,	31081.48,	30687.33,	30991.69,	+389.91,	1380260000,},
	{0x231026,	30902.92,	30943.33,	30567.61,	30601.78,	-668.14,	1331970000,},
	{0x231025,	31302.51,	31466.92,	31195.58,	31269.92,	+207.57,	1263620000,},
	{0x231024,	31157.01,	31210.26,	30551.67,	31062.35,	 +62.80,	1484700000,},
	{0x231023,	31151.98,	31177.41,	30974.26,	30999.55,	-259.81,	1164060000,},
	{0x231020,	31164.89,	31428.97,	31093.90,	31259.36,	-171.26,	1257620000,},
	{0x231019,	31579.54,	31669.42,	31399.17,	31430.62,	-611.63,	1234630000,},
	{0x231018,	32033.81,	32101.47,	31866.95,	32042.25,	  +1.96,	1261700000,},
	{0x231017,	32063.79,	32260.77,	31901.39,	32040.29,	+381.26,	1191180000,},
	{0x231016,	31983.04,	31999.79,	31564.31,	31659.03,	-656.96,	1354530000,},
	{0x231013,	32328.39,	32533.08,	32249.03,	32315.99,	-178.67,	1414130000,},
	{0x231012,	32120.94,	32494.66,	32120.94,	32494.66,	+558.15,	1471180000,},
	{0x231011,	31847.10,	32037.07,	31804.09,	31936.51,	+189.98,	1320600000,},
	{0x231010,	31314.67,	31818.26,	31314.67,	31746.53,	+751.86,	1484690000,},
	{0x231006,	31003.95,	31160.45,	30928.16,	30994.67,	 -80.69,	1437210000,},
	{0x231005,	30733.65,	31083.90,	30565.32,	31075.36,	+548.48,	1652380000,},
	{0x231004,	30765.03,	30830.85,	30487.67,	30526.88,	-711.06,	2029670000,},
	{0x231003,	31607.97,	31607.97,	31157.40,	31237.94,	-521.94,	1631260000,},
	{0x231002,	32101.97,	32401.58,	31759.88,	31759.88,	 -97.74,	1550610000,},
	{0x230929,	32018.64,	32027.46,	31717.74,	31857.62,	 -14.90,	1885890000,},
	{0x230928,	32119.37,	32164.45,	31674.42,	31872.52,	-499.38,	1661470000,},
	{0x230927,	32023.37,	32371.90,	31960.32,	32371.90,	 +56.85,	1586060000,},
	{0x230926,	32640.05,	32643.41,	32315.05,	32315.05,	-363.57,	1318560000,},
	{0x230925,	32517.26,	32722.22,	32388.28,	32678.62,	+276.21,	1269350000,},
	{0x230922,	32189.32,	32535.67,	32154.53,	32402.41,	-168.62,	1608730000,},
	{0x230921,	32865.56,	32939.89,	32550.65,	32571.03,	-452.75,	1567580000,},
	{0x230920,	33261.35,	33267.14,	32988.65,	33023.78,	-218.81,	1674530000,},
	{0x230919,	33296.23,	33337.23,	33128.86,	33242.59,	-290.50,	1716130000,},
	{0x230915,	33428.44,	33634.31,	33391.46,	33533.09,	+364.99,	2390540000,},
	{0x230914,	32925.54,	33244.45,	32851.24,	33168.10,	+461.58,	1608170000,},
	{0x230913,	32742.29,	32872.44,	32616.65,	32706.52,	 -69.85,	1475890000,},
	{0x230912,	32629.16,	32799.69,	32486.48,	32776.37,	+308.61,	1368230000,},
	{0x230911,	32690.54,	32746.14,	32391.69,	32467.76,	-139.08,	1293460000,},
	{0x230908,	32916.25,	32920.43,	32512.80,	32606.84,	-384.24,	1638070000,},
	{0x230907,	33118.55,	33322.45,	32986.35,	32991.08,	-249.94,	1454990000,},
	{0x230906,	33115.06,	33282.15,	33088.22,	33241.02,	+204.26,	1404660000,},
	{0x230905,	32941.41,	33036.76,	32784.32,	33036.76,	 +97.58,	1347790000,},
	{0x230904,	32797.32,	32939.18,	32714.94,	32939.18,	+228.56,	1336310000,},
	{0x230901,	32521.15,	32845.46,	32499.44,	32710.62,	 +91.28,	1318190000,},
	{0x230831,	32361.02,	32692.76,	32359.15,	32619.34,	+285.88,	1664280000,},
	{0x230830,	32432.95,	32557.45,	32300.56,	32333.46,	+106.49,	1350120000,},
	{0x230829,	32280.57,	32389.12,	32186.57,	32226.97,	 +56.98,	1195090000,},
	{0x230828,	31915.68,	32205.48,	31881.93,	32169.99,	+545.71,	1098060000,},
	{0x230825,	31840.91,	31885.53,	31572.06,	31624.28,	-662.93,	1021750000,},
	{0x230824,	32130.52,	32297.91,	32063.14,	32287.21,	+276.95,	1110500000,},
	{0x230823,	31717.91,	32039.60,	31717.91,	32010.26,	+153.55,	1006510000,},
	{0x230822,	31792.60,	31906.10,	31693.76,	31856.71,	+291.07,	1085070000,},
	{0x230821,	31552.85,	31758.70,	31409.86,	31565.64,	+114.88,	1100680000,},
	{0x230818,	31321.26,	31644.89,	31275.25,	31450.76,	-175.24,	1197960000,},
	{0x230817,	31621.98,	31704.08,	31309.68,	31626.00,	-140.82,	1373260000,},
	{0x230816,	31965.58,	31997.28,	31766.82,	31766.82,	-472.07,	1331140000,},
	{0x230815,	32372.53,	32403.93,	32217.52,	32238.89,	+178.98,	1283720000,},
	{0x230814,	32456.72,	32613.99,	32031.54,	32059.91,	-413.74,	1557000000,},
	{0x230810,	32015.96,	32504.85,	32015.96,	32473.65,	+269.32,	1653950000,},
	{0x230809,	32346.32,	32407.85,	32175.64,	32204.33,	-172.96,	1593550000,},
	{0x230808,	32430.61,	32539.88,	32238.59,	32377.29,	+122.73,	1445630000,},
	{0x230807,	31921.28,	32306.87,	31830.23,	32254.56,	 +61.81,	1455090000,},
	{0x230804,	32019.06,	32294.70,	31934.35,	32192.75,	 +33.47,	1586090000,},
	{0x230803,	32375.85,	32467.06,	32142.25,	32159.28,	-548.41,	1794630000,},
	{0x230802,	33123.12,	33158.58,	32628.29,	32707.69,	-768.89,	1834850000,},
	{0x230801,	33292.31,	33488.77,	33203.88,	33476.58,	+304.36,	1678540000,},
	{0x230731,	33128.83,	33402.08,	33025.93,	33172.22,	+412.99,	1997930000,},
	{0x230728,	32444.42,	32846.97,	32037.55,	32759.23,	-131.93,	2456330000,},
	{0x230727,	32523.69,	32938.59,	32503.69,	32891.16,	+222.82,	1337360000,},
	{0x230726,	32704.96,	32724.25,	32488.52,	32668.34,	 -14.17,	1268620000,},
	{0x230725,	32705.39,	32715.56,	32509.94,	32682.51,	 -18.43,	1440790000,},
	{0x230724,	32648.14,	32793.77,	32554.46,	32700.94,	+396.69,	1234480000,},
	{0x230721,	32336.86,	32462.44,	32080.95,	32304.25,	-186.27,	1191190000,},
	{0x230720,	32803.35,	32861.02,	32462.86,	32490.52,	-405.51,	1125160000,},
	{0x230719,	32812.36,	32896.03,	32671.03,	32896.03,	+402.14,	1240330000,},
	{0x230718,	32457.18,	32714.59,	32338.30,	32493.89,	+102.63,	1204300000,},
	{0x230714,	32587.90,	32780.63,	32225.37,	32391.26,	 -28.07,	1336810000,},
	{0x230713,	32106.05,	32484.40,	31952.98,	32419.33,	+475.40,	1199180000,},
	{0x230712,	32280.05,	32312.03,	31791.71,	31943.93,	-259.64,	1324860000,},
	{0x230711,	32434.67,	32468.70,	32084.42,	32203.57,	 +13.84,	1332230000,},
	{0x230710,	32393.46,	32558.98,	32065.63,	32189.73,	-198.69,	1515310000,},
	{0x230707,	32450.64,	32730.25,	32327.90,	32388.42,	-384.60,	1537320000,},
	{0x230706,	33058.40,	33079.45,	32637.72,	32773.02,	-565.68,	1500180000,},
	{0x230705,	33165.06,	33389.22,	33041.14,	33338.70,	 -83.82,	1391000000,},
	{0x230704,	33512.26,	33576.45,	33338.78,	33422.52,	-330.81,	1465560000,},
	{0x230703,	33517.60,	33762.81,	33510.55,	33753.33,	+564.29,	1411920000,},
	{0x230630,	33068.36,	33232.89,	32918.77,	33189.04,	 -45.10,	1597400000,},
	{0x230629,	33306.84,	33527.98,	33185.20,	33234.14,	 +40.15,	1686550000,},
	{0x230628,	32807.84,	33193.99,	32642.87,	33193.99,	+655.66,	1399950000,},
	{0x230627,	32629.96,	32689.10,	32306.99,	32538.33,	-160.48,	1227200000,},
	{0x230626,	32647.08,	32884.73,	32392.72,	32698.81,	 -82.73,	1170240000,},
	{0x230623,	33458.35,	33533.47,	32575.56,	32781.54,	-483.34,	1588450000,},
	{0x230622,	33438.01,	33641.46,	33232.19,	33264.88,	-310.26,	1452730000,},
	{0x230621,	33200.63,	33657.87,	33154.68,	33575.14,	+186.23,	1308600000,},
	{0x230620,	33269.57,	33474.74,	33089.02,	33388.91,	 +18.49,	1318270000,},
	{0x230619,	33768.69,	33772.89,	33231.56,	33370.42,	-335.66,	1313680000,},
	{0x230616,	33399.15,	33772.76,	33186.93,	33706.08,	+220.59,	2015920000,},
	{0x230615,	33493.69,	33767.13,	33386.01,	33485.49,	 -16.93,	1569060000,},
	{0x230614,	33331.47,	33665.52,	33203.95,	33502.42,	+483.77,	1648110000,},
	{0x230613,	32668.95,	33127.36,	32638.21,	33018.65,	+584.65,	1413460000,},
	{0x230612,	32412.12,	32517.68,	32280.54,	32434.00,	+168.83,	1162330000,},
	{0x230609,	31927.38,	32304.04,	31898.75,	32265.17,	+623.90,	1527460000,},
	{0x230608,	31877.79,	32035.95,	31420.45,	31641.27,	-272.47,	1342140000,},
	{0x230607,	32618.78,	32708.53,	31913.74,	31913.74,	-593.04,	1687940000,},
	{0x230606,	31988.37,	32534.47,	31933.87,	32506.78,	+289.35,	1271050000,},
	{0x230605,	31864.12,	32217.43,	31798.72,	32217.43,	+693.21,	1476000000,},
	{0x230602,	31300.72,	31555.54,	31257.01,	31524.22,	+376.21,	1342210000,},
	{0x230601,	30886.01,	31185.05,	30853.44,	31148.01,	+260.13,	1384030000,},
	{0x230531,	31057.09,	31142.78,	30785.98,	30887.88,	-440.28,	2586480000,},
	{0x230530,	31196.24,	31374.83,	31064.19,	31328.16,	 +94.62,	1115400000,},
	{0x230529,	31388.01,	31560.43,	31164.00,	31233.54,	+317.23,	1194140000,},
	{0x230526,	30909.61,	31101.60,	30864.49,	30916.31,	+115.18,	1219440000,},
	{0x230525,	30599.27,	30889.98,	30558.14,	30801.13,	+118.45,	1264730000,},
	{0x230524,	30728.69,	30856.92,	30566.83,	30682.68,	-275.09,	1243220000,},
	{0x230523,	31245.72,	31352.53,	30828.73,	30957.77,	-129.05,	1418190000,},
	{0x230522,	30735.71,	31086.82,	30689.27,	31086.82,	+278.47,	1159800000,},
	{0x230519,	30847.36,	30924.57,	30679.16,	30808.35,	+234.42,	1273830000,},
	{0x230518,	30432.54,	30667.13,	30381.90,	30573.93,	+480.34,	1426330000,},
	{0x230517,	29912.44,	30115.32,	29912.44,	30093.59,	+250.60,	1428040000,},
	{0x230516,	29838.01,	29916.56,	29779.07,	29842.99,	+216.65,	1604190000,},
	{0x230515,	29547.04,	29629.47,	29475.97,	29626.34,	+238.04,	1448440000,},
	{0x230512,	29199.30,	29426.06,	29141.52,	29388.30,	+261.58,	1664970000,},
	{0x230511,	29110.79,	29165.59,	29028.71,	29126.72,	  +4.54,	1301480000,},
	{0x230510,	29189.41,	29195.16,	29070.11,	29122.18,	-120.64,	1315320000,},
	{0x230509,	29020.63,	29262.36,	29020.63,	29242.82,	+292.94,	1347510000,},
	{0x230508,	29095.46,	29144.12,	28931.81,	28949.88,	-208.07,	1189560000,},
	{0x230502,	29278.80,	29278.80,	29083.13,	29157.95,	 +34.77,	1039520000,},
	{0x230501,	29058.05,	29145.89,	29016.83,	29123.18,	+266.74,	1229210000,},
	{0x230428,	28705.91,	28879.24,	28499.51,	28856.44,	+398.76,	1587440000,},
	{0x230427,	28340.59,	28459.73,	28241.67,	28457.68,	 +41.21,	1196520000,},
	{0x230426,	28478.52,	28551.61,	28319.77,	28416.47,	-203.60,	1109900000,},
	{0x230425,	28697.73,	28806.69,	28609.77,	28620.07,	 +26.55,	 962060000,},
	{0x230424,	28631.78,	28680.65,	28567.24,	28593.52,	 +29.15,	 826850000,},
	{0x230421,	28590.55,	28778.37,	28527.80,	28564.37,	 -93.20,	1053030000,},
	{0x230420,	28472.00,	28694.25,	28442.45,	28657.57,	 +50.81,	 922550000,},
	{0x230419,	28619.84,	28677.22,	28531.54,	28606.76,	 -52.07,	 943800000,},
	{0x230418,	28567.54,	28698.22,	28520.76,	28658.83,	+144.05,	1012340000,},
	{0x230417,	28537.99,	28599.75,	28414.98,	28514.78,	 +21.31,	 951290000,},
	{0x230414,	28321.54,	28515.51,	28282.82,	28493.47,	+336.50,	1127940000,},
	{0x230413,	27952.58,	28163.87,	27952.01,	28156.97,	 +74.27,	 972290000,},
	{0x230412,	27985.93,	28121.46,	27983.97,	28082.70,	+159.33,	 998540000,},
	{0x230411,	27895.90,	28068.39,	27854.82,	27923.37,	+289.71,	1046000000,},
	{0x230410,	27658.52,	27737.49,	27597.18,	27633.66,	+115.35,	 820180000,},
	{0x230407,	27554.37,	27591.15,	27456.25,	27518.31,	 +45.68,	 820490000,},
	{0x230406,	27589.14,	27609.86,	27427.66,	27472.63,	-340.63,	1146510000,},
	{0x230405,	28111.04,	28133.57,	27788.77,	27813.26,	-474.16,	1165630000,},
	{0x230404,	28213.93,	28287.42,	28139.12,	28287.42,	 +99.27,	1161470000,},
	{0x230403,	28203.35,	28258.91,	28120.71,	28188.15,	+146.67,	1179750000,},
	{0x230331,	28009.22,	28124.62,	27986.62,	28041.48,	+258.55,	1425270000,},
	{0x230330,	27827.89,	27876.38,	27630.55,	27782.93,	-100.85,	1275270000,},
	{0x230329,	27549.37,	27897.72,	27505.48,	27883.78,	+365.53,	1366740000,},
	{0x230328,	27573.82,	27603.45,	27432.76,	27518.25,	 +41.38,	1054180000,},
	{0x230327,	27482.39,	27543.48,	27359.72,	27476.87,	 +91.62,	 966490000,},
	{0x230324,	27368.62,	27397.29,	27257.44,	27385.25,	 -34.36,	1019220000,},
	{0x230323,	27232.97,	27461.97,	27175.63,	27419.61,	 -47.00,	1041190000,},
	{0x230322,	27298.15,	27520.97,	27267.26,	27466.61,	+520.94,	1251790000,},
	{0x230320,	27253.73,	27367.18,	26945.67,	26945.67,	-388.12,	1360280000,},
	{0x230317,	27232.23,	27356.15,	27071.71,	27333.79,	+323.18,	1641050000,},
	{0x230316,	26796.67,	27057.54,	26632.92,	27010.61,	-218.87,	1654880000,},
	{0x230315,	27421.66,	27424.94,	27105.99,	27229.48,	  +7.44,	1345370000,},
	{0x230314,	27455.95,	27455.95,	27104.75,	27222.04,	-610.92,	1909670000,},
	{0x230313,	27886.21,	27906.97,	27631.53,	27832.96,	-311.01,	1477690000,},
	{0x230310,	28385.29,	28424.24,	28118.74,	28143.97,	-479.18,	1693750000,},
	{0x230309,	28648.11,	28734.79,	28558.88,	28623.15,	+178.96,	1203000000,},
	{0x230308,	28237.21,	28469.41,	28232.68,	28444.19,	+135.03,	1106770000,},
	{0x230307,	28202.59,	28398.27,	28202.59,	28309.16,	 +71.38,	1127200000,},
	{0x230306,	28182.31,	28288.62,	28153.82,	28237.78,	+310.31,	1090540000,},
	{0x230303,	27683.26,	27961.21,	27655.34,	27927.47,	+428.60,	1268640000,},
	{0x230302,	27564.82,	27617.80,	27408.54,	27498.87,	 -17.66,	1116470000,},
	{0x230301,	27363.57,	27530.76,	27305.37,	27516.53,	 +70.97,	1129250000,},
	{0x230228,	27515.34,	27585.17,	27400.36,	27445.56,	 +21.60,	1388070000,},
	{0x230227,	27322.73,	27456.22,	27292.74,	27423.96,	 -29.52,	 988590000,},
	{0x230224,	27144.72,	27465.90,	27128.32,	27453.48,	+349.16,	1234560000,},
	{0x230222,	27265.99,	27300.53,	27046.08,	27104.32,	-368.78,	1201990000,},
	{0x230221,	27486.09,	27538.29,	27359.12,	27473.10,	 -58.84,	1006630000,},
	{0x230220,	27497.13,	27531.94,	27426.48,	27531.94,	 +18.81,	1013080000,},
	{0x230217,	27484.60,	27608.59,	27466.61,	27513.13,	-183.31,	1113210000,},
	{0x230216,	27654.72,	27727.66,	27597.12,	27696.44,	+194.58,	1141740000,},
	{0x230215,	27686.01,	27720.27,	27444.13,	27501.86,	-100.91,	1187910000,},
	{0x230214,	27705.37,	27721.82,	27553.18,	27602.77,	+175.45,	1019530000,},
	{0x230213,	27550.35,	27570.32,	27266.94,	27427.32,	-243.66,	1159250000,},
	{0x230210,	27711.25,	27814.02,	27609.33,	27670.98,	 +86.63,	1396180000,},
	{0x230209,	27453.40,	27635.38,	27424.69,	27584.35,	 -22.11,	1043730000,},
	{0x230208,	27690.74,	27719.45,	27458.53,	27606.46,	 -79.01,	1095000000,},
	{0x230207,	27744.90,	27814.96,	27662.11,	27685.47,	  -8.18,	1126510000,},
	{0x230206,	27764.66,	27821.22,	27656.47,	27693.65,	+184.19,	1315540000,},
	{0x230203,	27455.03,	27612.57,	27445.69,	27509.46,	+107.41,	1396670000,},
	{0x230202,	27453.67,	27472.44,	27338.43,	27402.05,	 +55.17,	1196480000,},
	{0x230201,	27483.41,	27547.67,	27322.79,	27346.88,	 +19.77,	1109000000,},
	{0x230131,	27458.56,	27494.17,	27302.22,	27327.11,	-106.29,	1205420000,},
	{0x230130,	27384.77,	27486.42,	27337.25,	27433.40,	 +50.84,	1130700000,},
	{0x230127,	27428.41,	27452.67,	27326.91,	27382.56,	 +19.81,	1102870000,},
	{0x230126,	27444.64,	27502.15,	27284.08,	27362.75,	 -32.26,	 983700000,},
	{0x230125,	27175.88,	27473.90,	27175.88,	27395.01,	 +95.82,	 990440000,},
	{0x230124,	27150.43,	27381.00,	27150.43,	27299.19,	+393.15,	1119230000,},
	{0x230123,	26880.21,	26938.28,	26788.76,	26906.04,	+352.51,	 977480000,},
	{0x230120,	26346.69,	26553.53,	26320.96,	26553.53,	+148.30,	 952270000,},
	{0x230119,	26541.08,	26592.87,	26368.97,	26405.23,	-385.89,	1054600000,},
	{0x230118,	26251.34,	26816.68,	26211.84,	26791.12,	+652.44,	1409870000,},
	{0x230117,	25915.51,	26198.69,	25895.30,	26138.68,	+316.36,	1065260000,},
	{0x230116,	25836.67,	25938.04,	25748.10,	25822.32,	-297.20,	1140010000,},
	{0x230113,	26391.78,	26409.21,	26090.84,	26119.52,	-330.30,	1479830000,},
	{0x230112,	26524.94,	26547.61,	26381.93,	26449.82,	  +3.82,	1238920000,},
	{0x230111,	26362.21,	26479.99,	26332.05,	26446.00,	+270.44,	1058870000,},
	{0x230110,	26176.61,	26316.66,	26132.80,	26175.56,	+201.71,	1111140000,},
	{0x230106,	25740.08,	26034.06,	25719.61,	25973.85,	+153.05,	1073510000,},
	{0x230105,	25825.50,	25947.10,	25750.46,	25820.80,	+103.94,	1128000000,},
	{0x230104,	25834.93,	25840.68,	25661.89,	25716.86,	-377.64,	1244870000,},
	{0x221230,	26288.00,	26321.37,	26067.92,	26094.50,	  +0.83,	 881800000,},
	{0x221229,	26074.90,	26126.70,	25953.92,	26093.67,	-246.83,	1021780000,},
	{0x221228,	26309.34,	26354.27,	26199.67,	26340.50,	-107.37,	1047960000,},
	{0x221227,	26570.78,	26620.49,	26447.87,	26447.87,	 +42.00,	 889080000,},
	{0x221226,	26299.54,	26438.65,	26294.85,	26405.87,	+170.62,	 820500000,},
	{0x221223,	26207.77,	26291.98,	26106.38,	26235.25,	-272.62,	1163440000,},
	{0x221222,	26552.43,	26585.28,	26399.31,	26507.87,	+120.15,	1150830000,},
	{0x221221,	26547.17,	26616.28,	26269.80,	26387.72,	-180.31,	1779600000,},
	{0x221220,	27257.35,	27339.49,	26416.91,	26568.03,	-669.61,	1843920000,},
	{0x221219,	27279.92,	27349.58,	27165.78,	27237.64,	-289.48,	 971320000,},
	{0x221216,	27706.70,	27713.04,	27488.83,	27527.12,	-524.58,	1384130000,},
	{0x221215,	27991.14,	28163.17,	27987.54,	28051.70,	-104.51,	 913760000,},
	{0x221214,	28005.03,	28195.69,	27993.78,	28156.21,	+201.36,	 985580000,},
	{0x221213,	28067.37,	28116.56,	27907.49,	27954.85,	+112.52,	 968680000,},
	{0x221212,	27741.10,	27865.72,	27734.66,	27842.33,	 -58.68,	 921880000,},
	{0x221209,	27633.96,	27952.80,	27633.96,	27901.01,	+326.58,	1125880000,},
	{0x221208,	27622.30,	27643.64,	27415.66,	27574.43,	-111.97,	1091110000,},
	{0x221207,	27670.29,	27786.25,	27646.78,	27686.40,	-199.47,	1045700000,},
	{0x221206,	27704.06,	27934.07,	27698.31,	27885.87,	 +65.47,	1016220000,},
	{0x221205,	27752.99,	27854.11,	27700.86,	27820.40,	 +42.50,	1069250000,},
	{0x221202,	27983.18,	27983.18,	27662.12,	27777.90,	-448.18,	1333290000,},
	{0x221201,	28273.13,	28423.46,	28226.08,	28226.08,	+257.09,	1244980000,},
	{0x221130,	27886.67,	27972.89,	27802.71,	27968.99,	 -58.85,	1664500000,},
	{0x221129,	27991.50,	28055.91,	27899.98,	28027.84,	-134.99,	1156650000,},
	{0x221128,	28220.56,	28238.50,	28046.32,	28162.83,	-120.20,	1132760000,},
	{0x221125,	28398.77,	28399.88,	28263.60,	28283.03,	-100.06,	 999150000,},
	{0x221124,	28373.72,	28502.29,	28363.66,	28383.09,	+267.35,	1311100000,},
	{0x221122,	28059.51,	28203.35,	28038.16,	28115.74,	+170.95,	1204280000,},
	{0x221121,	27982.00,	28007.06,	27846.30,	27944.79,	 +45.02,	 965300000,},
	{0x221118,	28009.82,	28045.44,	27877.78,	27899.77,	 -30.80,	1126250000,},
	{0x221117,	27952.21,	28029.62,	27910.01,	27930.57,	 -97.73,	1069050000,},
	{0x221116,	28020.49,	28069.25,	27743.15,	28028.30,	 +38.13,	1225490000,},
	{0x221115,	27940.26,	28038.63,	27903.27,	27990.17,	 +26.70,	1211300000,},
	{0x221114,	28277.64,	28305.04,	27963.47,	27963.47,	-300.10,	1460350000,},
	{0x221111,	27868.69,	28329.54,	27837.09,	28263.57,	+817.47,	1743680000,},
	{0x221110,	27459.08,	27485.38,	27370.62,	27446.10,	-270.33,	1270370000,},
	{0x221109,	27884.55,	27926.52,	27688.86,	27716.43,	-155.68,	1281770000,},
	{0x221108,	27718.84,	27943.27,	27704.64,	27872.11,	+344.47,	1344690000,},
	{0x221107,	27406.78,	27578.01,	27357.53,	27527.64,	+327.90,	1233590000,},
	{0x221104,	27371.89,	27389.30,	27032.02,	27199.74,	-463.65,	1639160000,},
	{0x221102,	27562.30,	27692.55,	27546.88,	27663.39,	 -15.53,	1430690000,},
	{0x221101,	27614.64,	27682.97,	27526.18,	27678.92,	 +91.46,	1232550000,},
	{0x221031,	27404.30,	27602.99,	27392.99,	27587.46,	+482.26,	1228500000,},
	{0x221028,	27097.38,	27265.46,	26981.08,	27105.20,	-240.04,	2410340000,},
	{0x221027,	27407.23,	27450.26,	27330.79,	27345.24,	 -86.60,	1078640000,},
	{0x221026,	27410.64,	27578.05,	27404.90,	27431.84,	+181.56,	1044710000,},
	{0x221025,	27113.20,	27337.80,	27073.18,	27250.28,	+275.38,	1040080000,},
	{0x221024,	27233.00,	27308.97,	26974.90,	26974.90,	 +84.32,	1030970000,},
	{0x221021,	26903.50,	26985.38,	26869.38,	26890.58,	-116.38,	1026660000,},
	{0x221020,	26981.75,	27092.55,	26872.45,	27006.96,	-250.42,	1044530000,},
	{0x221019,	27225.17,	27371.38,	27192.79,	27257.38,	+101.24,	 957040000,},
	{0x221018,	27167.73,	27229.88,	26910.10,	27156.14,	+380.35,	1106720000,},
	{0x221017,	26785.02,	26814.92,	26649.13,	26775.79,	-314.97,	1057210000,},
	{0x221014,	26599.32,	27180.16,	26595.35,	27090.76,	+853.34,	1319310000,},
	{0x221013,	26398.29,	26408.31,	26237.42,	26237.42,	-159.41,	1042870000,},
	{0x221012,	26353.22,	26495.75,	26313.41,	26396.83,	  -4.42,	1164940000,},
	{0x221011,	26757.12,	26759.62,	26369.56,	26401.25,	-714.86,	1296460000,},
	{0x221007,	26975.92,	27198.91,	26921.90,	27116.11,	-195.19,	1111960000,},
	{0x221006,	27137.98,	27399.19,	27137.98,	27311.30,	+190.77,	1139430000,},
	{0x221005,	27211.32,	27216.80,	27030.55,	27120.53,	+128.32,	1185700000,},
	{0x221004,	26653.49,	26994.44,	26633.52,	26992.21,	+776.42,	1378660000,},
	{0x221003,	25778.95,	26223.84,	25621.96,	26215.79,	+278.58,	1269340000,},
	{0x220930,	26240.00,	26273.65,	25805.59,	25937.21,	-484.84,	1520290000,},
	{0x220929,	26280.50,	26458.67,	26221.78,	26422.05,	+248.07,	1403610000,},
	{0x220928,	26422.86,	26516.32,	25938.36,	26173.98,	-397.89,	1554740000,},
	{0x220927,	26585.38,	26680.20,	26523.77,	26571.87,	+140.32,	1145570000,},
	{0x220926,	26779.44,	26779.44,	26424.60,	26431.55,	-722.28,	1526630000,},
	{0x220922,	27053.58,	27197.07,	26955.18,	27153.83,	-159.30,	1144750000,},
	{0x220921,	27440.84,	27467.34,	27297.50,	27313.13,	-375.29,	1068750000,},
	{0x220920,	27788.68,	27907.45,	27627.86,	27688.42,	+120.77,	1034410000,},
	{0x220916,	27631.39,	27654.99,	27525.68,	27567.65,	-308.26,	1417560000,},
	{0x220915,	27873.96,	27946.20,	27801.44,	27875.91,	 +57.29,	 897540000,},
	{0x220914,	28132.70,	28141.92,	27795.64,	27818.62,	-796.01,	1200480000,},
	{0x220913,	28556.21,	28659.76,	28530.36,	28614.63,	 +72.52,	 931590000,},
	{0x220912,	28483.59,	28612.89,	28438.37,	28542.11,	+327.36,	 925870000,},
	{0x220909,	28204.71,	28286.02,	28091.38,	28214.75,	+149.47,	1224700000,},
	{0x220908,	27732.68,	28083.79,	27718.30,	28065.28,	+634.98,	1207650000,},
	{0x220907,	27546.01,	27546.01,	27268.70,	27430.30,	-196.21,	1115040000,},
	{0x220906,	27650.15,	27813.78,	27557.99,	27626.51,	  +6.90,	 850210000,},
	{0x220905,	27567.29,	27673.44,	27511.68,	27619.61,	 -31.23,	 811920000,},
	{0x220902,	27755.60,	27772.37,	27570.74,	27650.84,	 -10.63,	1030610000,},
	{0x220901,	27797.00,	27832.78,	27589.70,	27661.47,	-430.06,	1100420000,},
	{0x220831,	27928.09,	28104.80,	27906.17,	28091.53,	-104.05,	1332180000,},
	{0x220830,	28086.72,	28233.80,	27944.25,	28195.58,	+316.62,	 998380000,},
	{0x220829,	28161.06,	28179.09,	27788.12,	27878.96,	-762.42,	1073660000,},
	{0x220826,	28639.47,	28792.93,	28608.70,	28641.38,	+162.37,	 855510000,},
	{0x220825,	28415.11,	28534.71,	28357.03,	28479.01,	+165.54,	 906450000,},
	{0x220824,	28481.34,	28515.61,	28282.21,	28313.47,	-139.28,	1022930000,},
	{0x220823,	28580.20,	28580.20,	28395.30,	28452.75,	-341.75,	 974310000,},
	{0x220822,	28654.07,	28828.21,	28586.36,	28794.50,	-135.83,	 920870000,},
	{0x220819,	29095.71,	29150.80,	28913.05,	28930.33,	 -11.81,	1022400000,},
	{0x220818,	28957.40,	28999.64,	28846.52,	28942.14,	-280.63,	 987930000,},
	{0x220817,	28952.65,	29222.77,	28944.71,	29222.77,	   0.00,	1135290000,},
};
