/*------------------------------------------------------------------------------
	インクルード
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <stdarg.h>

/*------------------------------------------------------------------------------
	デファイン
------------------------------------------------------------------------------*/
#define CNT   389
#define OUT   9
#define DAYS  21
#define RANGE 100

/*------------------------------------------------------------------------------
	マクロ
------------------------------------------------------------------------------*/
#define PRINT(x, ...)  fprintf_crlf((char *)x, ##__VA_ARGS__)

/*------------------------------------------------------------------------------
	型定義
------------------------------------------------------------------------------*/
typedef char INT8;
typedef int  INT32;

/*------------------------------------------------------------------------------
	構造体
------------------------------------------------------------------------------*/
typedef struct Field {
	INT32  date;
	double sta;
	double max;
	double min;
	double end;
	double ratio;
	INT32  trade;
} Field;

/*------------------------------------------------------------------------------
	ローカル変数
------------------------------------------------------------------------------*/
FILE *fp;

/*------------------------------------------------------------------------------
	内部参照
------------------------------------------------------------------------------*/
extern Field field[CNT];

/*------------------------------------------------------------------------------
	プロトタイプ
------------------------------------------------------------------------------*/
void difinition(void);
void fixed(void);
void value(void);
void fprintf_crlf(char *pStr, ...);

/*------------------------------------------------------------------------------
	書式：int main(void)
	引数：-
	戻値：int  -
	機能：スタートアップ
------------------------------------------------------------------------------*/
int main(void)
{
	fp = fopen("full.txt", "wb");
	if (fp == NULL) {printf("open error\r\n");}
	
	difinition();
	fixed();
	value();
	
	fclose(fp);
}

/*------------------------------------------------------------------------------
	書式：void difinition(void)
	機能：定義部分を出力
------------------------------------------------------------------------------*/
void difinition(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  色");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, RGB_BLACK,  000000");
	PRINT("DEFINE, RGB_GRAY,   C0C0C0");
	PRINT("DEFINE, RGB_RED,    F00000");
	PRINT("DEFINE, RGB_GREEN,  00F000");
	PRINT("DEFINE, RGB_BLUE,   0000F0");
	PRINT("DEFINE, RGB_MAZENTA,F000F0");
	PRINT("DEFINE, RGB_YELLOW, F0F000");
	PRINT("DEFINE, RGB_CYAN,   00F0F0");
	PRINT("DEFINE, RGB_AVE100, F0F0F0");
	PRINT("DEFINE, RGB_AVE75,  A0A0F0");
	PRINT("DEFINE, RGB_AVE25,  F0A0A0");
	PRINT("DEFINE, RGB_AVE5,   A0F0A0");
	PRINT("");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  座標");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, DAYS,      %2d", DAYS);
	PRINT("DEFINE, MAX,       350");
	PRINT("DEFINE, MIN,       250");
	PRINT("DEFINE, RANGE,     %d", RANGE);
	PRINT("DEFINE, X1,        77");
	PRINT("DEFINE, Y1,        255");
	PRINT("DEFINE, X2,        767");
	PRINT("DEFINE, Y2,        863");
	PRINT("DEFINE, W,         (X2-X1)");
	PRINT("DEFINE, H,         (Y2-Y1)");
	PRINT("DEFINE, X_SCALE,   41");
	PRINT("DEFINE, Y_WEEKEND, (Y2+5)");
	PRINT("DEFINE, Y_350,     (((H* 0)/40)+Y1)");
	PRINT("DEFINE, Y_345,     (((H* 2)/40)+Y1)");
	PRINT("DEFINE, Y_340,     (((H* 4)/40)+Y1)");
	PRINT("DEFINE, Y_335,     (((H* 6)/40)+Y1)");
	PRINT("DEFINE, Y_330,     (((H* 8)/40)+Y1)");
	PRINT("DEFINE, Y_325,     (((H*10)/40)+Y1)");
	PRINT("DEFINE, Y_320,     (((H*12)/40)+Y1)");
	PRINT("DEFINE, Y_315,     (((H*14)/40)+Y1)");
	PRINT("DEFINE, Y_310,     (((H*16)/40)+Y1)");
	PRINT("DEFINE, Y_305,     (((H*18)/40)+Y1)");
	PRINT("DEFINE, Y_300,     (((H*20)/40)+Y1)");
	PRINT("DEFINE, Y_295,     (((H*22)/40)+Y1)");
	PRINT("DEFINE, Y_290,     (((H*24)/40)+Y1)");
	PRINT("DEFINE, Y_285,     (((H*26)/40)+Y1)");
	PRINT("DEFINE, Y_280,     (((H*28)/40)+Y1)");
	PRINT("DEFINE, Y_275,     (((H*30)/40)+Y1)");
	PRINT("DEFINE, Y_270,     (((H*32)/40)+Y1)");
	PRINT("DEFINE, Y_265,     (((H*34)/40)+Y1)");
	PRINT("DEFINE, Y_260,     (((H*36)/40)+Y1)");
	PRINT("DEFINE, Y_255,     (((H*38)/40)+Y1)");
	PRINT("DEFINE, Y_250,     (((H*40)/40)+Y1)");
	PRINT("DEFINE, gX,        (X1+18)");
	PRINT("DEFINE, gW,        (W-18*2)");
	PRINT("DEFINE, tX1,       X1");
	PRINT("DEFINE, tY1,       910");
	PRINT("DEFINE, tX2,       X2");
	PRINT("DEFINE, tY2,       1030");
	PRINT("DEFINE, tW,        W");
	PRINT("DEFINE, tH,        (tY2-tY1)");
	PRINT("DEFINE, tMAX,      1500");
	PRINT("DEFINE, tMIN,      0");
	PRINT("DEFINE, tRANGE,    15000000");
	PRINT("DEFINE, tX_SCALE,  30");
	PRINT("DEFINE, tY_1500,   (((tH*0)/6)+tY1)");
	PRINT("DEFINE, tY_1250,   (((tH*1)/6)+tY1)");
	PRINT("DEFINE, tY_1000,   (((tH*2)/6)+tY1)");
	PRINT("DEFINE, tY_0750,   (((tH*3)/6)+tY1)");
	PRINT("DEFINE, tY_0500,   (((tH*4)/6)+tY1)");
	PRINT("DEFINE, tY_0250,   (((tH*5)/6)+tY1)");
	PRINT("DEFINE, tY_0000,   (((tH*6)/6)+tY1)");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void fixed(void)
	機能：固定部分を出力
------------------------------------------------------------------------------*/
void fixed(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  固定");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 0, 0, 840, 1050, 000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("");
	PRINT("RECT, 45,  70,  250, 160, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 49,  74,  242, 152, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 320, 120, 220, 110, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("");
	PRINT("LINE, X1, Y1, X2, Y1, RGB_BLACK, 1");
	PRINT("LINE, X1, Y1, X1, Y2, RGB_BLACK, 1");
	PRINT("LINE, X2, Y1, X2, Y2, RGB_BLACK, 1");
	PRINT("LINE, X1, Y2, X2, Y2, RGB_BLACK, 1");
	PRINT("");
	PRINT("LINE, X1+1, Y_325, X2-1, Y_325, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_300, X2-1, Y_300, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_275, X2-1, Y_275, RGB_GRAY, 1");
	PRINT("");
	PRINT("LINE, X1, Y_345, X1+4, Y_345, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_340, X1+4, Y_340, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_335, X1+4, Y_335, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_330, X1+4, Y_330, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_325, X1+4, Y_325, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_320, X1+4, Y_320, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_315, X1+4, Y_315, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_310, X1+4, Y_310, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_305, X1+4, Y_305, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_300, X1+4, Y_300, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_295, X1+4, Y_295, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_290, X1+4, Y_290, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_285, X1+4, Y_285, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_280, X1+4, Y_280, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_275, X1+4, Y_275, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_270, X1+4, Y_270, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_265, X1+4, Y_265, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_260, X1+4, Y_260, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_255, X1+4, Y_255, RGB_BLACK, 1");
	PRINT("");
	PRINT("TEXT, X_SCALE,(Y_350-8),350, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_345-8),345, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_340-8),340, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_335-8),335, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_330-8),330, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_325-8),325, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_320-8),320, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_315-8),315, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_310-8),310, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_305-8),305, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_300-8),300, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_295-8),295, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_290-8),290, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_285-8),285, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_280-8),280, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_275-8),275, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_270-8),270, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_265-8),265, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_260-8),260, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_255-8),255, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_250-8),250, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("");
	PRINT("DEFINE, Y_3.25, (Y2-((H*(338.46-MIN))/RANGE))");
	PRINT("DEFINE, Y_3.50, (Y2-((H*(314.29-MIN))/RANGE))");
	PRINT("DEFINE, Y_3.75, (Y2-((H*(293.33-MIN))/RANGE))");
	PRINT("DEFINE, Y_4.00, (Y2-((H*(275.00-MIN))/RANGE))");
	PRINT("DEFINE, Y_4.25, (Y2-((H*(258.82-MIN))/RANGE))");
	PRINT("LINE, X2-4, Y_3.25, X2, Y_3.25, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_3.50, X2, Y_3.50, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_3.75, X2, Y_3.75, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_4.00, X2, Y_4.00, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_4.25, X2, Y_4.25, RGB_BLACK, 1");
	PRINT("TEXT, 775,(Y_3.25-6),3.25, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_3.50-6),3.50, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_3.75-6),3.75, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_4.00-6),4.00, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_4.25-6),4.25, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("");
	PRINT("LINE, X1,   tY_1500, X2,   tY_1500, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_1000, X2,   tY_1000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0500, X2,   tY_0500, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0000, X2,   tY_0000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_1250, X1+4, tY_1250, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0750, X1+4, tY_0750, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0250, X1+4, tY_0250, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_1250, X2,   tY_1250, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_0750, X2,   tY_0750, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_0250, X2,   tY_0250, RGB_GRAY, 1");
	PRINT("");
	PRINT("TEXT, tX_SCALE,    (tY_1500-10),1500, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_1000-10),1000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE+9,  (tY_0500-10),500,  RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE+27, (tY_0000-10),0,    RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void value(void)
	機能：値部分を出力
------------------------------------------------------------------------------*/
void value(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  値");
	PRINT(":-------------------------------------------------------------------------------");
	
	INT32 i, j;
	INT32 cnt;
	double ave5 [CNT];
	double ave25[CNT];
	double ave75[CNT];
	double ave100[CNT];
	Field tmp[CNT];
	
	for (i = 0; i < CNT; i++) {tmp[i] = field[CNT-1-i];}
	
	for (i = 0; i < CNT; i++) {
		ave5 [i] = 0.0;
		ave25[i] = 0.0;
		ave75[i] = 0.0;
		ave100[i] = 0.0;
		
		if (4 <= i) {
			for (j = 0; j < 5; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= 5;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= cnt;
		}
		
		if (24 <= i) {
			for (j = 0; j < 25; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= 25;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= cnt;
		}
		
		if (74 <= i) {
			for (j = 0; j < 75; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= 75;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= cnt;
		}
		
		if (99 <= i) {
			for (j = 0; j < 100; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= 100;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= cnt;
		}
	}
	
	char fmt1_1[100+1] = "TEXT, 319, 25 ,8410 セブン銀行 20%02X年%2X月, RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_2[100+1] = "TEXT, 95,  100,%.1f,                      RGB_BLACK, 000000, TRUE, Arial, 70, FALSE";
	char fmt1_3[100+1] = "TEXT, 75,  185,20%02X/%02X/%02X 15:00 現在,      RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_4[100+1] = "TEXT, 333, 130,%s,         RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_5[100+1] = "TEXT, 333, 162,%s,         RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_6[100+1] = "TEXT, 455, 193,%.2f%,                      RGB_BLACK, 000000, TRUE, Arial, 30, FALSE";
	
	if (tmp[CNT-1].end == 0) {printf("0 div error\r\n");}
	
	PRINT(fmt1_1, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8);
	PRINT(fmt1_2, tmp[CNT-1].end);
	PRINT(fmt1_3, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8,
	              (tmp[CNT-1].date & 0x000000FF)>> 0);
	PRINT(fmt1_4, "5.5円　2023年3月末");
	PRINT(fmt1_5, "5.5円　2023年9月末");
	PRINT(fmt1_6, (11/tmp[CNT-1].end)*100);
	
	PRINT("");
	
	INT8 fmt2_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE), %s";
	INT8 fmt2_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE)";
	INT8 fmt2_3[150+1] = "DEFINE, GY%02X_%s, (Y2-((H*(%.1f-MIN))/RANGE))";
	INT8 fmt2_4[150+1] = "DEFINE, GH%02X,     ((H*(%.1f-%.1f))/RANGE)";
	INT8 fmt2_5[150+1] = "DEFINE, GH%02X,     %d";
	INT8 fmt2_6[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), GY%02X_%s, 7, GH%02X, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT8 fmt2_7[150+1] = "LINE, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MAX, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MIN, %s 1";
	INT8 fmt2_8[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), tY2, 6, -(tH*%8d)/tRANGE, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT32 dt;
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave100[i], "RGB_AVE100, 7");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave100[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave75[i], "RGB_AVE75, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave75[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave25[i], "RGB_AVE25, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave25[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave5[i], "RGB_AVE5, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave5[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			PRINT(fmt2_3, dt, "STA", tmp[i].sta);
			PRINT(fmt2_3, dt, "MAX", tmp[i].max);
			PRINT(fmt2_3, dt, "MIN", tmp[i].min);
			PRINT(fmt2_3, dt, "END", tmp[i].end);
			
			if (tmp[i].end >= tmp[i].sta) {
				if ((INT32)((608*(tmp[i].end-tmp[i].sta))/RANGE) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].end, tmp[i].sta);
				}
			}
			else {
				if ((INT32)((608*(tmp[i].sta-tmp[i].end))/RANGE) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].sta, tmp[i].end);
				}
			}
			PRINT("");
		}
	}
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "END", dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "STA", dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (tmp[i].ratio > 0) {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_RED, ");
			}
			else {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_BLUE,");
			}
		}
	}
	PRINT("");
	
	INT32 rate[21] = {0};
	INT32 pos;
	INT32 max = 0;
	INT8 fmt3_1[200] = "RECT, 62+6-%d, (Y_%d-%d), %d*2, %d*2, 000000, RGB_BLACK, 1, 0, FALSE, TRUE, TRUE, FALSE";
	
	for (i = 0; i < CNT; i++) {
		pos = (tmp[i].end - 250) / 5;
		
		if (pos < 0)  {continue;}
		if (pos > 20) {continue;}
		
		rate[pos]++;
	}
	
	for (i = 0; i < 21; i++) {
		if (rate[i] >max) {max = rate[i];}
	}
	
	for (i = 0; i < 21; i++) {
		pos = 250+i*5;
		
		if (rate[i] == 0) {
		}
		else if (rate[i] <= ((max*1)/6)) {
			PRINT(fmt3_1, 1, pos, 1, 1, 1);
		}
		else if (rate[i] <= ((max*2)/6)) {
			PRINT(fmt3_1, 2, pos, 2, 2, 2);
		}
		else if (rate[i] <= ((max*3)/6)) {
			PRINT(fmt3_1, 3, pos, 3, 3, 3);
		}
		else if (rate[i] <= ((max*4)/6)) {
			PRINT(fmt3_1, 4, pos, 4, 4, 4);
		}
		else if (rate[i] <= ((max*5)/6)) {
			PRINT(fmt3_1, 5, pos, 5, 5, 5);
		}
		else if (rate[i] <= ((max*6)/6)) {
			PRINT(fmt3_1, 6, pos, 6, 6, 6);
		}
	}
	PRINT("");
	
	INT8 fmt4_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f* 1-MIN))/RANGE), %s";
	INT8 fmt4_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f*%2d-MIN))/RANGE)";
	
	PRINT(fmt4_1, OUT+1, ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], "RGB_AVE100, 7");
	PRINT(fmt4_2, DAYS,  ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], "RGB_AVE75, 2");
	PRINT(fmt4_2, DAYS,  ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], "RGB_AVE25, 2");
	PRINT(fmt4_2, DAYS,  ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], "RGB_AVE5, 2");
	PRINT(fmt4_2, DAYS,  ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], DAYS-OUT);
}

/*------------------------------------------------------------------------------
	書式：void fprintf_crlf(char *pStr, ...)
	引数：char *  -
	      ...     -
	機能：出力
------------------------------------------------------------------------------*/
void fprintf_crlf(char *pStr, ...)
{
	va_list args;
	
	va_start(args, pStr);
	
	vfprintf(fp, pStr, args);
	fprintf(fp, "\r\n");
	
	va_end(args); 
}

/*------------------------------------------------------------------------------
	実体
------------------------------------------------------------------------------*/
Field field[CNT] = {
	{0x231114,	299.0,	299.4,	292.6,	294.9,	 -0.5,	 5022000,},
	{0x231113,	296.9,	300.6,	293.2,	295.4,	 +1.0,	 5977700,},
	{0x231110,	293.6,	295.5,	289.3,	294.4,	 +2.8,	 5113100,},
	{0x231109,	292.4,	293.0,	287.5,	291.6,	 -0.8,	 4450900,},
	{0x231108,	297.8,	298.1,	286.5,	292.4,	 -5.6,	 8243500,},
	{0x231107,	302.2,	302.4,	297.0,	298.0,	 -5.1,	 5688400,},
	{0x231106,	305.9,	306.9,	300.6,	303.1,	 -1.1,	 7333200,},
	{0x231102,	309.6,	309.6,	303.3,	304.2,	 -2.3,	 6196000,},
	{0x231101,	302.3,	307.7,	301.4,	306.5,	 +8.2,	 8524700,},
	{0x231031,	295.6,	300.7,	293.4,	298.3,	 +6.6,	 6678700,},
	{0x231030,	293.0,	295.3,	288.5,	291.7,	 -4.7,	14996200,},
	{0x231027,	294.0,	296.8,	292.9,	296.4,	 +3.8,	 2734500,},
	{0x231026,	293.1,	294.9,	290.6,	292.6,	 -1.7,	 3379500,},
	{0x231025,	292.2,	297.8,	291.7,	294.3,	 +2.2,	 3101000,},
	{0x231024,	291.7,	292.9,	286.5,	292.1,	 -1.1,	 5071400,},
	{0x231023,	293.8,	296.0,	292.8,	293.2,	 -0.6,	 3544800,},
	{0x231020,	297.0,	298.9,	293.8,	293.8,	 -3.5,	 3229400,},
	{0x231019,	297.1,	298.7,	295.8,	297.3,	 -2.2,	 3079600,},
	{0x231018,	300.4,	303.0,	298.2,	299.5,	 +3.3,	 3993100,},
	{0x231017,	299.3,	300.1,	294.6,	296.2,	 -0.3,	 4656700,},
	{0x231016,	296.2,	298.8,	294.5,	296.5,	 -2.8,	 4986600,},
	{0x231013,	307.0,	307.0,	298.4,	299.3,	 -7.0,	 5616200,},
	{0x231012,	307.8,	308.1,	305.2,	306.3,	 -1.8,	 4028600,},
	{0x231011,	309.9,	310.3,	308.1,	308.1,	 -2.3,	 2596200,},
	{0x231010,	305.2,	310.6,	304.8,	310.4,	 +3.4,	 4112900,},
	{0x231006,	305.8,	309.4,	303.1,	307.0,	 +1.8,	 3114400,},
	{0x231005,	302.6,	308.2,	302.5,	305.2,	 +4.8,	 5098900,},
	{0x231004,	302.8,	305.2,	299.1,	300.4,	 -6.1,	 5168200,},
	{0x231003,	312.4,	313.0,	305.6,	306.5,	 -7.4,	 3989900,},
	{0x231002,	314.0,	319.6,	313.3,	313.9,	 +3.0,	 4588900,},
	{0x230929,	319.0,	320.0,	309.1,	310.9,	-10.3,	 6175200,},
	{0x230928,	321.5,	324.6,	318.3,	321.2,	 -6.4,	 4537300,},
	{0x230927,	326.1,	327.6,	323.7,	327.6,	 -0.7,	 4020900,},
	{0x230926,	324.6,	329.5,	324.3,	328.3,	 +3.8,	 4261100,},
	{0x230925,	326.1,	326.3,	322.7,	324.5,	 -3.5,	 3710700,},
	{0x230922,	325.0,	329.4,	323.3,	328.0,	 +1.7,	 4196300,},
	{0x230921,	324.6,	330.5,	324.5,	326.3,	 +2.4,	 5228800,},
	{0x230920,	327.0,	327.6,	322.7,	323.9,	 -2.1,	 5436300,},
	{0x230919,	325.5,	327.8,	322.4,	326.0,	 +0.5,	 6216300,},
	{0x230915,	327.9,	331.7,	324.6,	325.5,	 -1.5,	 7680100,},
	{0x230914,	325.0,	328.0,	324.6,	327.0,	 +4.0,	 5034400,},
	{0x230913,	323.9,	323.9,	320.4,	323.0,	 +2.0,	 5027600,},
	{0x230912,	322.3,	323.6,	317.2,	321.0,	 -1.0,	 5541000,},
	{0x230911,	318.8,	324.2,	318.7,	322.0,	 +4.8,	 6224900,},
	{0x230908,	316.5,	319.2,	316.2,	317.2,	 -2.2,	 4504800,},
	{0x230907,	318.9,	321.8,	317.1,	319.4,	 +1.4,	 3964900,},
	{0x230906,	317.0,	318.8,	315.2,	318.0,	 +2.1,	 4814700,},
	{0x230905,	321.5,	321.8,	313.9,	315.9,	 -2.1,	 4797900,},
	{0x230904,	314.0,	318.0,	312.2,	318.0,	 +5.2,	 4274700,},
	{0x230901,	309.9,	314.4,	309.3,	312.8,	 +3.0,	 4516500,},
	{0x230831,	306.0,	311.3,	305.1,	309.8,	 +2.4,	 6341700,},
	{0x230830,	306.0,	309.0,	305.4,	307.4,	 +1.2,	 3279500,},
	{0x230829,	305.4,	306.9,	304.4,	306.2,	 +0.1,	 3217500,},
	{0x230827,	306.9,	307.9,	305.1,	306.1,	 -0.1,	 4788200,},
	{0x230825,	309.6,	309.6,	305.5,	306.2,	 -2.8,	 4722600,},
	{0x230824,	306.8,	309.8,	306.2,	309.0,	 +1.8,	 3296400,},
	{0x230823,	307.0,	308.0,	305.3,	307.2,	 -3.6,	 3689100,},
	{0x230822,	307.2,	310.8,	306.1,	310.8,	 +4.6,	 5514900,},
	{0x230821,	306.8,	309.9,	306.0,	306.2,	 -0.1,	 5715800,},
	{0x230818,	306.0,	310.5,	303.9,	306.3,	 +1.9,	 8889100,},
	{0x230817,	299.8,	304.4,	297.3,	304.4,	 +6.2,	 6259200,},
	{0x230816,	298.0,	299.3,	295.1,	298.2,	 -2.0,	 4396300,},
	{0x230815,	301.0,	301.3,	298.3,	300.2,	 +0.4,	 3707600,},
	{0x230814,	304.1,	304.6,	298.0,	299.8,	 +3.7,	 6474200,},
	{0x230810,	294.5,	296.7,	294.0,	296.1,	 +1.1,	 2968500,},
	{0x230809,	297.8,	297.8,	293.5,	295.0,	 -2.8,	 3991400,},
	{0x230808,	299.8,	299.9,	295.4,	297.8,	 -0.2,	 4500700,},
	{0x230807,	293.3,	299.2,	285.1,	298.0,	 +6.0,	 8846800,},
	{0x230804,	295.0,	301.7,	287.0,	292.0,	 -1.5,	12386000,},
	{0x230803,	295.0,	295.4,	292.5,	293.5,	 -1.9,	 5926100,},
	{0x230802,	298.0,	298.8,	294.6,	295.4,	 -6.6,	 9665800,},
	{0x230801,	307.6,	307.7,	300.0,	302.0,	 -6.8,	 7044400,},
	{0x230731,	307.0,	313.3,	305.9,	308.8,	 +7.3,	12190300,},
	{0x230728,	298.6,	305.0,	296.3,	301.5,	 +3.2,	 9541000,},
	{0x230727,	297.0,	299.3,	295.1,	298.3,	 +2.2,	 4475400,},
	{0x230726,	292.9,	296.3,	292.1,	296.1,	 +4.0,	 4389300,},
	{0x230725,	289.1,	293.6,	288.5,	292.1,	 +3.6,	 4352200,},
	{0x230724,	287.6,	289.4,	286.5,	288.5,	 +0.9,	 3098300,},
	{0x230721,	290.2,	290.4,	287.6,	287.6,	 -0.9,	 2376700,},
	{0x230720,	289.8,	291.1,	288.5,	288.5,	 +0.4,	 3010800,},
	{0x230719,	289.6,	289.9,	287.0,	288.1,	 +1.4,	 3022600,},
	{0x230718,	285.1,	289.7,	285.0,	286.7,	 +1.1,	 2857700,},
	{0x230714,	287.9,	288.4,	284.9,	285.6,	 -1.4,	 2855700,},
	{0x230713,	288.7,	289.5,	285.6,	287.0,	 -2.3,	 4012700,},
	{0x230712,	289.7,	290.5,	288.6,	289.3,	 +0.9,	 2489700,},
	{0x230711,	290.0,	290.6,	287.5,	288.4,	 -1.2,	 2347300,},
	{0x230710,	290.2,	293.3,	288.5,	289.6,	 +0.7,	 4930400,},
	{0x230707,	287.4,	290.7,	285.8,	288.9,	 +0.6,	 3723000,},
	{0x230706,	292.0,	292.6,	288.0,	288.3,	 -3.2,	 3830600,},
	{0x230705,	294.9,	295.1,	291.0,	291.5,	 -3.7,	 4311800,},
	{0x230704,	286.9,	295.8,	286.6,	295.2,	 +9.7,	 8211600,},
	{0x230703,	284.5,	287.7,	284.2,	285.5,	 +2.4,	 4971000,},
	{0x230630,	285.9,	286.5,	282.2,	283.1,	 -1.8,	 3323900,},
	{0x230629,	287.5,	287.9,	284.1,	284.9,	 -2.3,	 3039200,},
	{0x230628,	283.1,	287.2,	282.8,	287.2,	 +4.2,	 4478800,},
	{0x230627,	283.2,	284.2,	281.6,	283.0,	 +0.8,	 2610200,},
	{0x230626,	283.0,	283.9,	280.4,	282.2,	 -1.5,	 2619200,},
	{0x230623,	284.2,	285.2,	282.2,	283.7,	 -0.7,	 4015400,},
	{0x230622,	283.6,	284.9,	283.5,	284.4,	 +1.3,	 3876300,},
	{0x230621,	284.5,	284.8,	280.8,	283.1,	 -0.7,	 4343600,},
	{0x230620,	287.5,	287.5,	283.1,	283.8,	 -3.4,	 3223200,},
	{0x230619,	287.8,	288.8,	286.1,	287.2,	 +0.1,	 4637000,},
	{0x230616,	287.0,	287.4,	285.2,	287.1,	  0.0,	 5993200,},
	{0x230615,	284.0,	287.9,	282.8,	287.1,	 +3.4,	 5598900,},
	{0x230614,	284.5,	284.9,	282.0,	283.7,	 +0.3,	 4977300,},
	{0x230613,	282.0,	284.6,	281.6,	283.4,	 +1.1,	 5608800,},
	{0x230612,	282.1,	283.2,	281.3,	282.3,	 -1.2,	 2979700,},
	{0x230609,	278.9,	284.5,	278.5,	283.5,	 +4.6,	 8160900,},
	{0x230608,	280.0,	281.7,	278.2,	278.9,	 +0.7,	 3167900,},
	{0x230607,	282.0,	283.5,	278.1,	278.2,	 -2.2,	 4964900,},
	{0x230606,	280.0,	281.0,	277.3,	280.4,	 -1.6,	 4748200,},
	{0x230605,	281.0,	283.0,	279.7,	282.0,	 +3.0,	 6557200,},
	{0x230602,	274.0,	281.0,	274.0,	279.0,	 +6.0,	 8001300,},
	{0x230601,	272.0,	274.0,	270.0,	273.0,	  0.0,	 7372600,},
	{0x230531,	276.0,	278.0,	273.0,	273.0,	 -4.0,	 5972700,},
	{0x230530,	276.0,	278.0,	275.0,	277.0,	 +1.0,	 2984100,},
	{0x230529,	276.0,	279.0,	275.0,	276.0,	 +1.0,	 5145000,},
	{0x230526,	274.0,	276.0,	272.0,	275.0,	 +2.0,	 5972000,},
	{0x230525,	273.0,	275.0,	272.0,	273.0,	 -1.0,	 3612000,},
	{0x230524,	272.0,	276.0,	271.0,	274.0,	 +4.0,	 4514400,},
	{0x230523,	272.0,	272.0,	269.0,	270.0,	  0.0,	 5187300,},
	{0x230522,	271.0,	273.0,	269.0,	270.0,	 -2.0,	 5480800,},
	{0x230519,	277.0,	277.0,	272.0,	272.0,	 -6.0,	 6403900,},
	{0x230518,	281.0,	282.0,	277.0,	278.0,	 -1.0,	 6432800,},
	{0x230517,	278.0,	281.0,	278.0,	279.0,	  0.0,	 3797200,},
	{0x230516,	279.0,	281.0,	278.0,	279.0,	 +2.0,	 3681600,},
	{0x230515,	274.0,	279.0,	273.0,	277.0,	 +4.0,	 7617300,},
	{0x230512,	290.0,	293.0,	270.0,	273.0,	-16.0,	16918500,},
	{0x230511,	283.0,	290.0,	283.0,	289.0,	 +7.0,	 6118300,},
	{0x230510,	282.0,	285.0,	281.0,	282.0,	  0.0,	 3983200,},
	{0x230509,	278.0,	282.0,	277.0,	282.0,	 +5.0,	 6518200,},
	{0x230508,	277.0,	279.0,	276.0,	277.0,	 +1.0,	 5937400,},
	{0x230502,	277.0,	278.0,	275.0,	276.0,	  0.0,	 4609900,},
	{0x230501,	278.0,	278.0,	275.0,	276.0,	 -2.0,	 4784300,},
	{0x230428,	279.0,	281.0,	275.0,	278.0,	 +1.0,	 7483200,},
	{0x230427,	275.0,	278.0,	273.0,	277.0,	 +2.0,	 5356600,},
	{0x230426,	277.0,	277.0,	274.0,	275.0,	 -3.0,	 4022600,},
	{0x230425,	277.0,	280.0,	277.0,	278.0,	  0.0,	 4670500,},
	{0x230424,	279.0,	280.0,	276.0,	278.0,	 +1.0,	 2997900,},
	{0x230421,	278.0,	280.0,	277.0,	277.0,	 -3.0,	 3992400,},
	{0x230420,	280.0,	282.0,	278.0,	280.0,	  0.0,	 5481300,},
	{0x230419,	279.0,	280.0,	277.0,	280.0,	  0.0,	 5926200,},
	{0x230418,	278.0,	282.0,	278.0,	280.0,	 +1.0,	 5914800,},
	{0x230417,	274.0,	280.0,	273.0,	279.0,	 +8.0,	10970200,},
	{0x230414,	271.0,	272.0,	269.0,	271.0,	 +2.0,	 4729700,},
	{0x230413,	272.0,	273.0,	268.0,	269.0,	 -3.0,	 4610000,},
	{0x230412,	273.0,	274.0,	271.0,	272.0,	  0.0,	 3364400,},
	{0x230411,	274.0,	275.0,	271.0,	272.0,	 -2.0,	 3683500,},
	{0x230410,	269.0,	274.0,	269.0,	274.0,	 +5.0,	 6176900,},
	{0x230407,	268.0,	271.0,	267.0,	269.0,	 +6.0,	 9583400,},
	{0x230406,	265.0,	266.0,	262.0,	263.0,	 -1.0,	 5991600,},
	{0x230405,	266.0,	266.0,	264.0,	264.0,	 -2.0,	 4832500,},
	{0x230404,	268.0,	268.0,	265.0,	266.0,	 -3.0,	 4327400,},
	{0x230403,	267.0,	270.0,	266.0,	269.0,	 +4.0,	 5759300,},
	{0x230331,	264.0,	267.0,	263.0,	265.0,	  0.0,	 5605400,},
	{0x230330,	265.0,	266.0,	263.0,	265.0,	 -5.0,	 4864200,},
	{0x230329,	268.0,	270.0,	266.0,	270.0,	 +5.0,	 5189800,},
	{0x230328,	265.0,	268.0,	262.0,	265.0,	  0.0,	 6626800,},
	{0x230327,	267.0,	267.0,	264.0,	265.0,	 -1.0,	 6119500,},
	{0x230324,	265.0,	266.0,	263.0,	266.0,	  0.0,	 4009200,},
	{0x230323,	264.0,	266.0,	261.0,	266.0,	 +2.0,	 6484800,},
	{0x230322,	267.0,	268.0,	264.0,	264.0,	 -1.0,	 9162900,},
	{0x230320,	263.0,	266.0,	261.0,	265.0,	 -1.0,	 7817900,},
	{0x230317,	266.0,	267.0,	263.0,	266.0,	 +3.0,	 8410500,},
	{0x230316,	260.0,	263.0,	258.0,	263.0,	 -3.0,	10072600,},
	{0x230315,	268.0,	269.0,	264.0,	266.0,	 +4.0,	 8195100,},
	{0x230314,	266.0,	268.0,	259.0,	262.0,	 -8.0,	15957700,},
	{0x230313,	272.0,	274.0,	268.0,	270.0,	 -4.0,	10655100,},
	{0x230310,	282.0,	283.0,	274.0,	274.0,	-11.0,	10972800,},
	{0x230309,	278.0,	286.0,	278.0,	285.0,	 +7.0,	 6576400,},
	{0x230308,	277.0,	278.0,	275.0,	278.0,	 +1.0,	 3553300,},
	{0x230307,	275.0,	277.0,	275.0,	277.0,	 +3.0,	 2692900,},
	{0x230306,	276.0,	276.0,	273.0,	274.0,	 -2.0,	 4749600,},
	{0x230303,	274.0,	277.0,	273.0,	276.0,	 +2.0,	 5234900,},
	{0x230302,	277.0,	278.0,	273.0,	274.0,	 -1.0,	 6714100,},
	{0x230301,	275.0,	278.0,	273.0,	275.0,	 +1.0,	 7518500,},
	{0x230228,	275.0,	277.0,	274.0,	274.0,	 -2.0,	 4673500,},
	{0x230227,	273.0,	276.0,	273.0,	276.0,	 +3.0,	 3369600,},
	{0x230224,	272.0,	276.0,	271.0,	273.0,	 +1.0,	 8446400,},
	{0x230222,	271.0,	274.0,	270.0,	272.0,	  0.0,	 5112200,},
	{0x230221,	270.0,	272.0,	269.0,	272.0,	 +3.0,	 4609100,},
	{0x230220,	268.0,	270.0,	267.0,	269.0,	 +2.0,	 2741200,},
	{0x230217,	267.0,	269.0,	266.0,	267.0,	 +2.0,	 3140100,},
	{0x230216,	269.0,	269.0,	265.0,	265.0,	 -4.0,	 6095200,},
	{0x230215,	269.0,	271.0,	268.0,	269.0,	  0.0,	 3877200,},
	{0x230214,	268.0,	271.0,	267.0,	269.0,	 +1.0,	 3350900,},
	{0x230213,	267.0,	272.0,	266.0,	268.0,	 +2.0,	 5513700,},
	{0x230210,	265.0,	267.0,	264.0,	266.0,	 +2.0,	 3810900,},
	{0x230209,	264.0,	266.0,	263.0,	264.0,	  0.0,	 3796800,},
	{0x230208,	263.0,	265.0,	262.0,	264.0,	 +2.0,	 3382000,},
	{0x230207,	262.0,	264.0,	261.0,	262.0,	 +1.0,	 3166400,},
	{0x230206,	263.0,	263.0,	259.0,	261.0,	  0.0,	 5997900,},
	{0x230203,	263.0,	264.0,	260.0,	261.0,	 -2.0,	 4944300,},
	{0x230202,	265.0,	266.0,	262.0,	263.0,	 -2.0,	 3877900,},
	{0x230201,	268.0,	271.0,	265.0,	265.0,	 -2.0,	 4787200,},
	{0x230131,	270.0,	270.0,	265.0,	267.0,	 -1.0,	 4679900,},
	{0x230130,	267.0,	269.0,	266.0,	268.0,	 +2.0,	 3844600,},
	{0x230127,	264.0,	266.0,	262.0,	266.0,	 +2.0,	 5116800,},
	{0x230126,	264.0,	265.0,	263.0,	264.0,	  0.0,	 2512300,},
	{0x230125,	265.0,	266.0,	262.0,	264.0,	 -1.0,	 3662800,},
	{0x230124,	263.0,	265.0,	262.0,	265.0,	 +3.0,	 3563800,},
	{0x230123,	265.0,	266.0,	262.0,	262.0,	 -2.0,	 4135100,},
	{0x230120,	262.0,	264.0,	261.0,	264.0,	 +2.0,	 2803100,},
	{0x230119,	265.0,	267.0,	261.0,	262.0,	 -4.0,	 4774100,},
	{0x230118,	266.0,	269.0,	258.0,	266.0,	 +1.0,	 8890900,},
	{0x230117,	267.0,	268.0,	263.0,	265.0,	 -1.0,	 5097800,},
	{0x230116,	273.0,	274.0,	265.0,	266.0,	 -7.0,	 6135500,},
	{0x230113,	264.0,	275.0,	264.0,	273.0,	+10.0,	11801900,},
	{0x230112,	259.0,	266.0,	259.0,	263.0,	 +3.0,	 8325100,},
	{0x230111,	259.0,	261.0,	258.0,	260.0,	 +2.0,	 2952100,},
	{0x230110,	258.0,	261.0,	257.0,	258.0,	  0.0,	 3984600,},
	{0x230106,	259.0,	262.0,	257.0,	258.0,	 -1.0,	 6082200,},
	{0x230105,	262.0,	264.0,	259.0,	259.0,	 -4.0,	 6641700,},
	{0x230104,	263.0,	264.0,	259.0,	263.0,	 +1.0,	 6715400,},
	{0x221230,	262.0,	264.0,	260.0,	262.0,	  0.0,	 3175600,},
	{0x221229,	268.0,	268.0,	261.0,	262.0,	 -5.0,	 4857100,},
	{0x221228,	267.0,	269.0,	265.0,	267.0,	 +2.0,	 5460400,},
	{0x221227,	264.0,	267.0,	263.0,	265.0,	 +2.0,	 4436300,},
	{0x221226,	263.0,	264.0,	260.0,	263.0,	 -1.0,	 3280500,},
	{0x221223,	259.0,	264.0,	258.0,	264.0,	 +5.0,	 4329000,},
	{0x221222,	261.0,	261.0,	256.0,	259.0,	 -2.0,	 5194900,},
	{0x221221,	265.0,	273.0,	259.0,	261.0,	 -3.0,	12413300,},
	{0x221220,	260.0,	267.0,	258.0,	264.0,	 +5.0,	 8068000,},
	{0x221219,	258.0,	260.0,	257.0,	259.0,	 +1.0,	 3638500,},
	{0x221216,	258.0,	260.0,	257.0,	258.0,	  0.0,	 3731800,},
	{0x221215,	261.0,	261.0,	257.0,	258.0,	 -1.0,	 2115800,},
	{0x221214,	257.0,	261.0,	257.0,	259.0,	 +2.0,	 2916600,},
	{0x221213,	258.0,	259.0,	256.0,	257.0,	 +1.0,	 3847500,},
	{0x221212,	255.0,	257.0,	254.0,	256.0,	 +2.0,	 1712300,},
	{0x221209,	254.0,	256.0,	254.0,	254.0,	  0.0,	 1724400,},
	{0x221208,	255.0,	255.0,	252.0,	254.0,	 -1.0,	 2794000,},
	{0x221207,	255.0,	258.0,	254.0,	255.0,	 -2.0,	 5193600,},
	{0x221206,	255.0,	257.0,	254.0,	257.0,	 +3.0,	 2484500,},
	{0x221205,	257.0,	257.0,	253.0,	254.0,	 -3.0,	 4406700,},
	{0x221202,	257.0,	259.0,	253.0,	257.0,	  0.0,	 5510600,},
	{0x221201,	262.0,	263.0,	257.0,	257.0,	 -4.0,	 4431300,},
	{0x221130,	266.0,	266.0,	261.0,	261.0,	 -4.0,	 5221400,},
	{0x221129,	264.0,	267.0,	262.0,	265.0,	 +1.0,	 5306000,},
	{0x221128,	265.0,	266.0,	262.0,	264.0,	  0.0,	 5412300,},
	{0x221125,	263.0,	264.0,	261.0,	264.0,	 +2.0,	 3167600,},
	{0x221124,	263.0,	265.0,	261.0,	262.0,	 -1.0,	 6199600,},
	{0x221122,	258.0,	264.0,	258.0,	263.0,	 +5.0,	 4567500,},
	{0x221121,	257.0,	259.0,	256.0,	258.0,	 +4.0,	 2657400,},
	{0x221118,	255.0,	257.0,	254.0,	254.0,	  0.0,	 4040700,},
	{0x221117,	251.0,	254.0,	251.0,	254.0,	 +2.0,	 2884100,},
	{0x221116,	250.0,	252.0,	249.0,	252.0,	 +2.0,	 3273000,},
	{0x221115,	251.0,	253.0,	250.0,	250.0,	 -2.0,	 3394000,},
	{0x221114,	251.0,	254.0,	249.0,	252.0,	 +1.0,	 5342600,},
	{0x221111,	254.0,	256.0,	250.0,	251.0,	 -2.0,	 6163800,},
	{0x221110,	253.0,	255.0,	252.0,	253.0,	 -1.0,	 5165300,},
	{0x221109,	252.0,	255.0,	251.0,	254.0,	 +1.0,	 5228500,},
	{0x221108,	254.0,	255.0,	252.0,	253.0,	 -1.0,	 3992800,},
	{0x221107,	262.0,	263.0,	253.0,	254.0,	 -7.0,	 6056300,},
	{0x221104,	263.0,	266.0,	260.0,	261.0,	 -5.0,	 3779200,},
	{0x221102,	263.0,	267.0,	262.0,	266.0,	 +1.0,	 6918700,},
	{0x221101,	267.0,	268.0,	264.0,	265.0,	 -3.0,	 3228300,},
	{0x221031,	266.0,	269.0,	265.0,	268.0,	 +3.0,	 2496600,},
	{0x221028,	266.0,	269.0,	264.0,	265.0,	 -2.0,	 8426700,},
	{0x221027,	272.0,	273.0,	266.0,	267.0,	 -6.0,	 5283600,},
	{0x221026,	275.0,	278.0,	273.0,	273.0,	 -2.0,	 4002600,},
	{0x221025,	277.0,	279.0,	275.0,	275.0,	 +2.0,	 4895800,},
	{0x221024,	276.0,	276.0,	270.0,	273.0,	 -2.0,	 4550900,},
	{0x221021,	272.0,	276.0,	272.0,	275.0,	 +3.0,	 5729300,},
	{0x221020,	270.0,	274.0,	269.0,	272.0,	 +3.0,	 5782800,},
	{0x221019,	268.0,	269.0,	266.0,	269.0,	 +3.0,	 2904400,},
	{0x221018,	268.0,	269.0,	265.0,	266.0,	 +1.0,	 4204200,},
	{0x221017,	273.0,	274.0,	264.0,	265.0,	 -7.0,	 4890300,},
	{0x221014,	271.0,	273.0,	267.0,	272.0,	 +3.0,	 6891900,},
	{0x221013,	260.0,	269.0,	259.0,	269.0,	+11.0,	 8710300,},
	{0x221012,	257.0,	263.0,	256.0,	258.0,	 +1.0,	 4830800,},
	{0x221011,	255.0,	259.0,	254.0,	257.0,	 +2.0,	 2349400,},
	{0x221007,	257.0,	258.0,	254.0,	255.0,	 -2.0,	 2419600,},
	{0x221006,	257.0,	260.0,	256.0,	257.0,	 -1.0,	 2413800,},
	{0x221005,	259.0,	261.0,	257.0,	258.0,	  0.0,	 2887300,},
	{0x221004,	255.0,	260.0,	255.0,	258.0,	 +5.0,	 3430700,},
	{0x221003,	256.0,	257.0,	252.0,	253.0,	 -6.0,	 3343800,},
	{0x220930,	262.0,	263.0,	256.0,	259.0,	 -1.0,	 4177300,},
	{0x220929,	257.0,	261.0,	256.0,	260.0,	  0.0,	 3215100,},
	{0x220928,	258.0,	261.0,	254.0,	260.0,	 +1.0,	 5486900,},
	{0x220927,	258.0,	262.0,	258.0,	259.0,	  0.0,	 3356000,},
	{0x220926,	260.0,	262.0,	258.0,	259.0,	 -2.0,	 3334900,},
	{0x220922,	263.0,	263.0,	260.0,	261.0,	 -3.0,	 3691400,},
	{0x220921,	265.0,	267.0,	264.0,	264.0,	 -1.0,	 2401700,},
	{0x220920,	265.0,	268.0,	265.0,	265.0,	  0.0,	 4122100,},
	{0x220916,	263.0,	265.0,	263.0,	265.0,	 +3.0,	 5973000,},
	{0x220915,	261.0,	263.0,	260.0,	262.0,	 -1.0,	 3898000,},
	{0x220914,	263.0,	265.0,	261.0,	263.0,	  0.0,	 3361600,},
	{0x220913,	262.0,	264.0,	260.0,	263.0,	 +1.0,	 3068500,},
	{0x220912,	261.0,	262.0,	260.0,	262.0,	 -1.0,	 4339000,},
	{0x220909,	262.0,	264.0,	261.0,	263.0,	 +2.0,	 3332100,},
	{0x220908,	261.0,	264.0,	260.0,	261.0,	 +2.0,	 3868600,},
	{0x220907,	260.0,	262.0,	256.0,	259.0,	 -3.0,	 4693200,},
	{0x220906,	262.0,	263.0,	260.0,	262.0,	  0.0,	 3484200,},
	{0x220905,	261.0,	263.0,	260.0,	262.0,	 +1.0,	 2450100,},
	{0x220902,	261.0,	262.0,	259.0,	261.0,	  0.0,	 2084500,},
	{0x220901,	263.0,	264.0,	260.0,	261.0,	 -3.0,	 3176000,},
	{0x220831,	263.0,	265.0,	262.0,	264.0,	 +2.0,	 4164200,},
	{0x220830,	263.0,	264.0,	262.0,	262.0,	 -2.0,	 1447400,},
	{0x220829,	263.0,	264.0,	261.0,	264.0,	  0.0,	 2482000,},
	{0x220826,	264.0,	266.0,	262.0,	264.0,	 -2.0,	 3458600,},
	{0x220825,	264.0,	267.0,	264.0,	266.0,	 +2.0,	 2795600,},
	{0x220824,	264.0,	265.0,	262.0,	264.0,	 +2.0,	 3256500,},
	{0x220823,	264.0,	264.0,	261.0,	262.0,	 -3.0,	 2357000,},
	{0x220822,	262.0,	265.0,	261.0,	265.0,	 +5.0,	 3791300,},
	{0x220819,	261.0,	262.0,	259.0,	260.0,	  0.0,	 3076400,},
	{0x220818,	260.0,	261.0,	259.0,	260.0,	  0.0,	 2350800,},
	{0x220817,	260.0,	260.0,	258.0,	260.0,	 +2.0,	 2325100,},
	{0x220816,	260.0,	260.0,	257.0,	258.0,	 -2.0,	 2509800,},
	{0x220815,	260.0,	261.0,	258.0,	260.0,	  0.0,	 1871200,},
	{0x220812,	261.0,	263.0,	258.0,	260.0,	  0.0,	 3796900,},
	{0x220810,	257.0,	261.0,	256.0,	260.0,	 +4.0,	 3293400,},
	{0x220809,	257.0,	259.0,	255.0,	256.0,	 -2.0,	 3471700,},
	{0x220808,	259.0,	261.0,	256.0,	258.0,	 +1.0,	 2776800,},
	{0x220805,	257.0,	259.0,	256.0,	257.0,	 -1.0,	 2476900,},
	{0x220804,	260.0,	260.0,	256.0,	258.0,	 -2.0,	 3064100,},
	{0x220803,	259.0,	261.0,	257.0,	260.0,	 -1.0,	 3218200,},
	{0x220802,	263.0,	264.0,	257.0,	261.0,	 -4.0,	 4306900,},
	{0x220801,	265.0,	265.0,	262.0,	265.0,	 +1.0,	 1752200,},
	{0x220729,	264.0,	266.0,	263.0,	264.0,	 -2.0,	 2043400,},
	{0x220728,	267.0,	267.0,	263.0,	266.0,	 -1.0,	 2918300,},
	{0x220727,	267.0,	268.0,	265.0,	267.0,	 -1.0,	 2466300,},
	{0x220726,	268.0,	270.0,	267.0,	268.0,	 +1.0,	 4256800,},
	{0x220725,	264.0,	267.0,	264.0,	267.0,	 +3.0,	 3062000,},
	{0x220722,	260.0,	264.0,	259.0,	264.0,	 +2.0,	 4770700,},
	{0x220721,	262.0,	264.0,	261.0,	262.0,	 +1.0,	 3589400,},
	{0x220720,	262.0,	264.0,	260.0,	261.0,	 +2.0,	 3928400,},
	{0x220719,	257.0,	260.0,	256.0,	259.0,	 +3.0,	 2758500,},
	{0x220715,	257.0,	257.0,	253.0,	256.0,	 -3.0,	 3398300,},
	{0x220714,	259.0,	260.0,	257.0,	259.0,	 -1.0,	 2803600,},
	{0x220713,	262.0,	262.0,	260.0,	260.0,	 -2.0,	 2212300,},
	{0x220712,	262.0,	263.0,	260.0,	262.0,	  0.0,	 2304800,},
	{0x220711,	260.0,	262.0,	258.0,	262.0,	 +4.0,	 2672800,},
	{0x220708,	259.0,	261.0,	257.0,	258.0,	  0.0,	 4139600,},
	{0x220707,	258.0,	261.0,	254.0,	258.0,	 +3.0,	 3842600,},
	{0x220706,	262.0,	262.0,	254.0,	255.0,	 -8.0,	 4191300,},
	{0x220705,	260.0,	263.0,	259.0,	263.0,	 +3.0,	 4493900,},
	{0x220704,	259.0,	260.0,	258.0,	260.0,	 +3.0,	 2273000,},
	{0x220701,	256.0,	259.0,	255.0,	257.0,	 -2.0,	 3711500,},
	{0x220630,	256.0,	259.0,	254.0,	259.0,	 +2.0,	 4617200,},
	{0x220629,	258.0,	260.0,	254.0,	257.0,	 +1.0,	 5634200,},
	{0x220628,	257.0,	259.0,	255.0,	256.0,	 +1.0,	 3588300,},
	{0x220627,	256.0,	257.0,	255.0,	255.0,	  0.0,	 2809100,},
	{0x220624,	253.0,	256.0,	253.0,	255.0,	 +2.0,	 6511900,},
	{0x220623,	251.0,	253.0,	250.0,	253.0,	 +2.0,	 3025000,},
	{0x220622,	249.0,	252.0,	247.0,	251.0,	  0.0,	 4518500,},
	{0x220621,	248.0,	251.0,	248.0,	251.0,	 +2.0,	 2602100,},
	{0x220620,	247.0,	250.0,	246.0,	249.0,	 +2.0,	 3965600,},
	{0x220617,	250.0,	251.0,	246.0,	247.0,	 -4.0,	 5468000,},
	{0x220616,	250.0,	253.0,	249.0,	251.0,	 +1.0,	 4228100,},
	{0x220615,	249.0,	253.0,	248.0,	250.0,	 +1.0,	 6576800,},
	{0x220614,	246.0,	251.0,	245.0,	249.0,	 -1.0,	 7511800,},
	{0x220613,	246.0,	250.0,	246.0,	250.0,	 +3.0,	 4195300,},
	{0x220610,	246.0,	247.0,	244.0,	247.0,	  0.0,	 4144000,},
	{0x220609,	245.0,	249.0,	244.0,	247.0,	 +2.0,	 4253100,},
	{0x220608,	244.0,	246.0,	243.0,	245.0,	 +1.0,	 3699300,},
	{0x220607,	244.0,	246.0,	244.0,	244.0,	 +1.0,	 3486900,},
	{0x220606,	244.0,	245.0,	243.0,	243.0,	  0.0,	 1523200,},
	{0x220603,	244.0,	245.0,	243.0,	243.0,	 -1.0,	 1597100,},
	{0x220602,	246.0,	246.0,	243.0,	244.0,	 -2.0,	 2403200,},
	{0x220601,	244.0,	247.0,	244.0,	246.0,	 +4.0,	 3766200,},
	{0x220531,	244.0,	245.0,	241.0,	242.0,	 -2.0,	 3967300,},
	{0x220530,	243.0,	245.0,	243.0,	244.0,	 +2.0,	 3780900,},
	{0x220527,	244.0,	245.0,	241.0,	242.0,	 -2.0,	 2617400,},
	{0x220526,	241.0,	246.0,	241.0,	244.0,	 +3.0,	 3558200,},
	{0x220525,	242.0,	243.0,	241.0,	241.0,	  0.0,	 2471800,},
	{0x220524,	242.0,	243.0,	241.0,	241.0,	 -1.0,	 3017300,},
	{0x220523,	241.0,	244.0,	241.0,	242.0,	 +1.0,	 2714400,},
	{0x220520,	242.0,	243.0,	240.0,	241.0,	 -3.0,	 2855800,},
	{0x220519,	242.0,	244.0,	240.0,	244.0,	 +1.0,	 3696600,},
	{0x220518,	240.0,	243.0,	239.0,	243.0,	 +4.0,	 4416400,},
	{0x220517,	240.0,	241.0,	239.0,	239.0,	  0.0,	 3035100,},
	{0x220516,	242.0,	243.0,	239.0,	239.0,	 -3.0,	 4463900,},
	{0x220513,	242.0,	244.0,	240.0,	242.0,	 +1.0,	 3944800,},
	{0x220512,	246.0,	247.0,	241.0,	241.0,	 -3.0,	 4236100,},
	{0x220511,	248.0,	248.0,	243.0,	244.0,	 -5.0,	 4182200,},
	{0x220510,	246.0,	249.0,	245.0,	249.0,	 +3.0,	 5540000,},
	{0x220509,	244.0,	246.0,	243.0,	246.0,	 +2.0,	 4065400,},
	{0x220506,	244.0,	246.0,	243.0,	244.0,	  0.0,	 6288000,},
	{0x220502,	243.0,	244.0,	242.0,	244.0,	 +1.0,	 3235700,},
	{0x220428,	239.0,	243.0,	239.0,	243.0,	 +7.0,	 5743000,},
	{0x220427,	238.0,	240.0,	236.0,	236.0,	 -2.0,	 5158000,},
	{0x220426,	240.0,	241.0,	238.0,	238.0,	 -3.0,	 3809000,},
	{0x220425,	241.0,	242.0,	239.0,	241.0,	 -3.0,	 3712200,},
	{0x220422,	244.0,	244.0,	242.0,	244.0,	 +1.0,	 1247100,},
	{0x220421,	245.0,	246.0,	243.0,	243.0,	 -2.0,	 2720200,},
	{0x220420,	241.0,	245.0,	241.0,	245.0,	 +4.0,	 5098400,},
	{0x220419,	242.0,	242.0,	240.0,	241.0,	  0.0,	 1383900,},
	{0x220418,	242.0,	243.0,	239.0,	241.0,	 -1.0,	 2636000,},
	{0x220415,	241.0,	243.0,	240.0,	242.0,	  0.0,	 3562500,},
};
