/*------------------------------------------------------------------------------
	インクルード
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <stdarg.h>

/*------------------------------------------------------------------------------
	デファイン
------------------------------------------------------------------------------*/
#define CNT   342
#define OUT   9
#define DAYS  21
#define RANGE 40

/*------------------------------------------------------------------------------
	マクロ
------------------------------------------------------------------------------*/
#define PRINT(x, ...)  fprintf_crlf((char *)x, ##__VA_ARGS__)

/*------------------------------------------------------------------------------
	型定義
------------------------------------------------------------------------------*/
typedef char INT8;
typedef int  INT32;

/*------------------------------------------------------------------------------
	構造体
------------------------------------------------------------------------------*/
typedef struct Field {
	INT32  date;
	double sta;
	double max;
	double min;
	double end;
	double ratio;
	INT32  trade;
} Field;

/*------------------------------------------------------------------------------
	ローカル変数
------------------------------------------------------------------------------*/
FILE *fp;

/*------------------------------------------------------------------------------
	内部参照
------------------------------------------------------------------------------*/
extern Field field[CNT];

/*------------------------------------------------------------------------------
	プロトタイプ
------------------------------------------------------------------------------*/
void difinition(void);
void fixed(void);
void value(void);
void fprintf_crlf(char *pStr, ...);

/*------------------------------------------------------------------------------
	書式：int main(void)
	引数：-
	戻値：int  -
	機能：スタートアップ
------------------------------------------------------------------------------*/
int main(void)
{
	fp = fopen("full.txt", "wb");
	if (fp == NULL) {printf("open error\r\n");}
	
	difinition();
	fixed();
	value();
	
	fclose(fp);
}

/*------------------------------------------------------------------------------
	書式：void difinition(void)
	機能：定義部分を出力
------------------------------------------------------------------------------*/
void difinition(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  色");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, RGB_BLACK,  000000");
	PRINT("DEFINE, RGB_GRAY,   C0C0C0");
	PRINT("DEFINE, RGB_RED,    F00000");
	PRINT("DEFINE, RGB_GREEN,  00F000");
	PRINT("DEFINE, RGB_BLUE,   0000F0");
	PRINT("DEFINE, RGB_MAZENTA,F000F0");
	PRINT("DEFINE, RGB_YELLOW, F0F000");
	PRINT("DEFINE, RGB_CYAN,   00F0F0");
	PRINT("DEFINE, RGB_AVE100, F0F0F0");
	PRINT("DEFINE, RGB_AVE75,  A0A0F0");
	PRINT("DEFINE, RGB_AVE25,  F0A0A0");
	PRINT("DEFINE, RGB_AVE5,   A0F0A0");
	PRINT("");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  座標");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, DAYS,      %2d", DAYS);
	PRINT("DEFINE, MAX,       190");
	PRINT("DEFINE, MIN,       150");
	PRINT("DEFINE, RANGE,     %d", RANGE);
	PRINT("DEFINE, X1,        77");
	PRINT("DEFINE, Y1,        255");
	PRINT("DEFINE, X2,        767");
	PRINT("DEFINE, Y2,        863");
	PRINT("DEFINE, W,         (X2-X1)");
	PRINT("DEFINE, H,         (Y2-Y1)");
	PRINT("DEFINE, X_SCALE,   38");
	PRINT("DEFINE, Y_WEEKEND, (Y2+5)");
	PRINT("DEFINE, Y_190,     (((H* 0)/40)+Y1)");
	PRINT("DEFINE, Y_185,     (((H* 5)/40)+Y1)");
	PRINT("DEFINE, Y_180,     (((H*10)/40)+Y1)");
	PRINT("DEFINE, Y_175,     (((H*15)/40)+Y1)");
	PRINT("DEFINE, Y_170,     (((H*20)/40)+Y1)");
	PRINT("DEFINE, Y_165,     (((H*25)/40)+Y1)");
	PRINT("DEFINE, Y_160,     (((H*30)/40)+Y1)");
	PRINT("DEFINE, Y_155,     (((H*35)/40)+Y1)");
	PRINT("DEFINE, Y_150,     (((H*40)/40)+Y1)");
	PRINT("DEFINE, gX,        (X1+18)");
	PRINT("DEFINE, gW,        (W-18*2)");
	PRINT("DEFINE, tX1,       X1");
	PRINT("DEFINE, tY1,       910");
	PRINT("DEFINE, tX2,       X2");
	PRINT("DEFINE, tY2,       1030");
	PRINT("DEFINE, tW,        W");
	PRINT("DEFINE, tH,        (tY2-tY1)");
	PRINT("DEFINE, tMAX,      30000");
	PRINT("DEFINE, tMIN,      0");
	PRINT("DEFINE, tRANGE,    300000000");
	PRINT("DEFINE, tX_SCALE,  20");
	PRINT("DEFINE, tY_30000,  (((tH*0)/6)+tY1)");
	PRINT("DEFINE, tY_25000,  (((tH*1)/6)+tY1)");
	PRINT("DEFINE, tY_20000,  (((tH*2)/6)+tY1)");
	PRINT("DEFINE, tY_15000,  (((tH*3)/6)+tY1)");
	PRINT("DEFINE, tY_10000,  (((tH*4)/6)+tY1)");
	PRINT("DEFINE, tY_05000,  (((tH*5)/6)+tY1)");
	PRINT("DEFINE, tY_00000,  (((tH*6)/6)+tY1)");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void fixed(void)
	機能：固定部分を出力
------------------------------------------------------------------------------*/
void fixed(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  固定");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 0, 0, 840, 1050, 000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("");
	PRINT("RECT, 45,  70,  250, 160, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 49,  74,  242, 152, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 320, 120, 220, 110, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("");
	PRINT("LINE, X1, Y1, X2, Y1, RGB_BLACK, 1");
	PRINT("LINE, X1, Y1, X1, Y2, RGB_BLACK, 1");
	PRINT("LINE, X2, Y1, X2, Y2, RGB_BLACK, 1");
	PRINT("LINE, X1, Y2, X2, Y2, RGB_BLACK, 1");
	PRINT("");
	PRINT("LINE, X1+1, Y_180, X2-1, Y_180, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_170, X2-1, Y_170, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_160, X2-1, Y_160, RGB_GRAY, 1");
	PRINT("");
	PRINT("LINE, X1, Y_185, X1+4, Y_185, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_180, X1+4, Y_180, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_175, X1+4, Y_175, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_170, X1+4, Y_170, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_165, X1+4, Y_165, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_160, X1+4, Y_160, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_155, X1+4, Y_155, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_150, X1+4, Y_150, RGB_BLACK, 1");
	PRINT("");
	PRINT("TEXT, X_SCALE,(Y_190-8),190, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_185-8),185, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_180-8),180, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_175-8),175, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_170-8),170, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_165-8),165, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_160-8),160, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_155-8),155, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_150-8),150, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("");
	PRINT("DEFINE, Y_2.75, (Y2-((H*(181.81-MIN))/RANGE))");
	PRINT("DEFINE, Y_3.00, (Y2-((H*(166.66-MIN))/RANGE))");
	PRINT("DEFINE, Y_3.25, (Y2-((H*(153.84-MIN))/RANGE))");
	PRINT("LINE, X2-4, Y_2.75, X2, Y_2.75, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_3.00, X2, Y_3.00, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_3.25, X2, Y_3.25, RGB_BLACK, 1");
	PRINT("TEXT, 775,(Y_2.75-6),2.75, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_3.00-6),3.00, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_3.25-6),3.25, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("");
	PRINT("LINE, X1,   tY_30000, X2,   tY_30000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_20000, X2,   tY_20000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_10000, X2,   tY_10000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_00000, X2,   tY_00000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_25000, X1+4, tY_25000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_15000, X1+4, tY_15000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_05000, X1+4, tY_05000, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_25000, X2,   tY_25000, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_15000, X2,   tY_15000, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_05000, X2,   tY_05000, RGB_GRAY, 1");
	PRINT("");
	PRINT("TEXT, tX_SCALE,    (tY_30000-10),30000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_20000-10),20000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_10000-10),10000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE+36, (tY_00000-10),0,     RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void value(void)
	機能：値部分を出力
------------------------------------------------------------------------------*/
void value(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  値");
	PRINT(":-------------------------------------------------------------------------------");
	
	INT32 i, j;
	INT32 cnt;
	double ave5 [CNT];
	double ave25[CNT];
	double ave75[CNT];
	double ave100[CNT];
	Field tmp[CNT];
	
	for (i = 0; i < CNT; i++) {tmp[i] = field[CNT-1-i];}
	
	for (i = 0; i < CNT; i++) {
		ave5 [i] = 0.0;
		ave25[i] = 0.0;
		ave75[i] = 0.0;
		ave100[i] = 0.0;
		
		if (4 <= i) {
			for (j = 0; j < 5; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= 5;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= cnt;
		}
		
		if (24 <= i) {
			for (j = 0; j < 25; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= 25;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= cnt;
		}
		
		if (74 <= i) {
			for (j = 0; j < 75; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= 75;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= cnt;
		}
		
		if (99 <= i) {
			for (j = 0; j < 100; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= 100;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= cnt;
		}
	}
	
	char fmt1_1[100+1] = "TEXT, 319, 25 ,9432 日本電信電話 20%02X年%2X月, RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_2[100+1] = "TEXT, 95,  100,%.1f,                        RGB_BLACK, 000000, TRUE, Arial, 70, FALSE";
	char fmt1_3[100+1] = "TEXT, 75,  185,20%02X/%02X/%02X 15:00 現在,        RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_4[100+1] = "TEXT, 333, 130,%s,           RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_5[100+1] = "TEXT, 333, 162,%s,           RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_6[100+1] = "TEXT, 455, 193,%.2f%,                        RGB_BLACK, 000000, TRUE, Arial, 30, FALSE";
	
	if (tmp[CNT-1].end == 0) {printf("0 div error\r\n");}
	
	PRINT(fmt1_1, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8);
	PRINT(fmt1_2, tmp[CNT-1].end);
	PRINT(fmt1_3, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8,
	              (tmp[CNT-1].date & 0x000000FF)>> 0);
	PRINT(fmt1_4, "2.4円　2023年3月末");
	PRINT(fmt1_5, "2.5円　2023年9月末");
	PRINT(fmt1_6, (5/tmp[CNT-1].end)*100);
	
	PRINT("");
	
	INT8 fmt2_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE), %s";
	INT8 fmt2_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE)";
	INT8 fmt2_3[150+1] = "DEFINE, GY%02X_%s, (Y2-((H*(%.1f-MIN))/RANGE))";
	INT8 fmt2_4[150+1] = "DEFINE, GH%02X,     ((H*(%.1f-%.1f))/RANGE)";
	INT8 fmt2_5[150+1] = "DEFINE, GH%02X,     %d";
	INT8 fmt2_6[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), GY%02X_%s, 7, GH%02X, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT8 fmt2_7[150+1] = "LINE, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MAX, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MIN, %s 1";
	INT8 fmt2_8[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), tY2, 6, -(tH*%8d)/tRANGE, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT32 dt;
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave100[i], "RGB_AVE100, 7");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave100[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave75[i], "RGB_AVE75, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave75[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave25[i], "RGB_AVE25, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave25[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave5[i], "RGB_AVE5, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave5[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			PRINT(fmt2_3, dt, "STA", tmp[i].sta);
			PRINT(fmt2_3, dt, "MAX", tmp[i].max);
			PRINT(fmt2_3, dt, "MIN", tmp[i].min);
			PRINT(fmt2_3, dt, "END", tmp[i].end);
			
			if (tmp[i].end >= tmp[i].sta) {
				if ((INT32)((608*(tmp[i].end-tmp[i].sta))/40) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].end, tmp[i].sta);
				}
			}
			else {
				if ((INT32)((608*(tmp[i].sta-tmp[i].end))/40) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].sta, tmp[i].end);
				}
			}
			PRINT("");
		}
	}
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "END", dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "STA", dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (tmp[i].ratio > 0) {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_RED, ");
			}
			else {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_BLUE,");
			}
		}
	}
	PRINT("");
	
	INT32 rate[9] = {0};
	INT32 pos;
	INT32 max = 0;
	INT8 fmt3_1[200] = "RECT, 62+6-%d, (Y_%d-%d), %d*2, %d*2, 000000, RGB_BLACK, 1, 0, FALSE, TRUE, TRUE, FALSE";
	
	for (i = 0; i < CNT; i++) {
		pos = (tmp[i].end - 150) / 5;
		
		if (pos < 0) {continue;}
		if (pos > 8) {continue;}
		
		rate[pos]++;
	}
	
	for (i = 0; i < 9; i++) {
		if (rate[i] >max) {max = rate[i];}
	}
	
	for (i = 0; i < 9; i++) {
		pos = 150+i*5;
		
		if (rate[i] == 0) {
		}
		else if (rate[i] <= ((max*1)/6)) {
			PRINT(fmt3_1, 1, pos, 1, 1, 1);
		}
		else if (rate[i] <= ((max*2)/6)) {
			PRINT(fmt3_1, 2, pos, 2, 2, 2);
		}
		else if (rate[i] <= ((max*3)/6)) {
			PRINT(fmt3_1, 3, pos, 3, 3, 3);
		}
		else if (rate[i] <= ((max*4)/6)) {
			PRINT(fmt3_1, 4, pos, 4, 4, 4);
		}
		else if (rate[i] <= ((max*5)/6)) {
			PRINT(fmt3_1, 5, pos, 5, 5, 5);
		}
		else if (rate[i] <= ((max*6)/6)) {
			PRINT(fmt3_1, 6, pos, 6, 6, 6);
		}
	}
	PRINT("");
	
	INT8 fmt4_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f* 1-MIN))/RANGE), %s";
	INT8 fmt4_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f*%2d-MIN))/RANGE)";
	
	PRINT(fmt4_1, OUT+1, ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], "RGB_AVE100, 7");
	PRINT(fmt4_2, DAYS,  ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], "RGB_AVE75, 2");
	PRINT(fmt4_2, DAYS,  ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], "RGB_AVE25, 2");
	PRINT(fmt4_2, DAYS,  ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], "RGB_AVE5, 2");
	PRINT(fmt4_2, DAYS,  ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], DAYS-OUT);
}

/*------------------------------------------------------------------------------
	書式：void fprintf_crlf(char *pStr, ...)
	引数：char *  -
	      ...     -
	機能：出力
------------------------------------------------------------------------------*/
void fprintf_crlf(char *pStr, ...)
{
	va_list args;
	
	va_start(args, pStr);
	
	vfprintf(fp, pStr, args);
	fprintf(fp, "\r\n");
	
	va_end(args); 
}

/*------------------------------------------------------------------------------
	実体
------------------------------------------------------------------------------*/
Field field[CNT] = {
	{0x231114,	175.6,	176.0,	174.3,	174.8,	+0.7,	 87972200,},
	{0x231113,	173.4,	174.3,	172.6,	174.1,	+1.3,	113936000,},
	{0x231110,	169.1,	173.7,	169.1,	172.8,	+3.1,	157788900,},
	{0x231109,	168.5,	170.7,	167.8,	169.7,	+1.4,	167375100,},
	{0x231108,	171.8,	172.9,	168.0,	168.3,	-6.6,	303025100,},
	{0x231107,	177.0,	178.5,	173.6,	174.9,	-2.0,	199026100,},
	{0x231106,	178.2,	179.2,	176.9,	176.9,	-0.7,	198864800,},
	{0x231102,	178.6,	179.5,	177.5,	177.6,	-0.7,	127479500,},
	{0x231101,	177.3,	178.8,	176.8,	178.3,	+1.5,	176553500,},
	{0x231031,	176.2,	177.8,	174.8,	176.8,	+3.1,	200560800,},
	{0x231030,	173.5,	174.2,	172.4,	173.7,	-1.7,	588903200,},
	{0x231027,	173.7,	176.0,	173.7,	175.4,	+1.9,	128695300,},
	{0x231026,	174.7,	174.7,	172.7,	173.5,	-1.3,	130434800,},
	{0x231025,	173.9,	175.7,	173.6,	174.8,	+1.3,	125001700,},
	{0x231024,	173.3,	174.1,	171.4,	173.5,	+0.2,	137788600,},
	{0x231023,	173.5,	174.1,	172.8,	173.3,	-0.3,	111431600,},
	{0x231020,	172.9,	174.5,	172.6,	173.6,	+0.3,	102739100,},
	{0x231019,	171.5,	173.7,	171.4,	173.3,	+1.0,	118259700,},
	{0x231018,	173.0,	173.3,	171.6,	172.3,	-1.1,	117869600,},
	{0x231017,	172.1,	174.0,	172.0,	173.4,	+1.2,	111911400,},
	{0x231016,	175.0,	175.3,	171.8,	172.2,	-3.7,	149271500,},
	{0x231013,	175.9,	177.0,	175.3,	175.9,	 0.0,	132534300,},
	{0x231012,	177.0,	177.1,	175.0,	175.9,	-0.4,	153005800,},
	{0x231011,	176.1,	177.4,	175.9,	176.3,	-0.2,	137002100,},
	{0x231010,	173.4,	177.9,	173.4,	176.5,	+3.4,	174318600,},
	{0x231006,	174.0,	175.1,	172.5,	173.1,	-0.9,	172903100,},
	{0x231005,	172.0,	175.3,	172.0,	174.0,	+2.7,	170782900,},
	{0x231004,	173.0,	173.8,	170.8,	171.3,	-3.7,	193493500,},
	{0x231003,	174.9,	175.4,	173.1,	175.0,	 0.0,	152808200,},
	{0x231002,	176.6,	178.6,	175.0,	175.0,	-1.6,	181446100,},
	{0x230929,	179.8,	180.5,	176.1,	176.6,	-2.5,	223658500,},
	{0x230928,	181.3,	182.4,	178.5,	179.1,	-4.1,	220089400,},
	{0x230927,	181.5,	183.4,	180.3,	183.2,	+1.9,	195525900,},
	{0x230926,	182.0,	182.0,	180.5,	181.3,	-0.2,	150313600,},
	{0x230925,	181.7,	182.3,	181.0,	181.5,	+0.3,	134393600,},
	{0x230922,	179.3,	181.5,	178.9,	181.2,	+1.2,	188951100,},
	{0x230921,	179.5,	181.9,	179.4,	180.0,	-0.6,	171839200,},
	{0x230920,	180.5,	181.6,	180.1,	180.6,	-0.4,	188662900,},
	{0x230919,	178.0,	181.0,	177.4,	181.0,	+1.9,	205538600,},
	{0x230915,	175.6,	180.0,	175.1,	179.1,	+4.5,	270838700,},
	{0x230914,	175.0,	175.6,	174.3,	174.6,	+0.3,	176197500,},
	{0x230913,	172.9,	174.9,	172.4,	174.3,	+1.4,	154576500,},
	{0x230912,	171.6,	173.0,	171.3,	172.9,	+1.8,	122963300,},
	{0x230911,	172.1,	172.4,	170.4,	171.1,	-0.2,	118177700,},
	{0x230908,	170.4,	172.9,	170.3,	171.3,	-0.3,	213009600,},
	{0x230907,	168.9,	172.1,	168.8,	171.6,	+2.5,	189425100,},
	{0x230906,	167.9,	169.3,	167.4,	169.1,	+1.1,	122616800,},
	{0x230905,	169.0,	169.5,	167.5,	168.0,	-1.3,	150431700,},
	{0x230904,	168.1,	169.5,	167.9,	169.3,	+0.7,	129810300,},
	{0x230901,	167.8,	169.5,	167.4,	168.6,	+0.3,	133126100,},
	{0x230831,	167.7,	168.8,	167.1,	168.3,	+0.7,	172197700,},
	{0x230830,	166.9,	168.3,	166.6,	167.6,	+1.1,	163101900,},
	{0x230829,	166.8,	167.2,	165.8,	166.5,	 0.0,	111240700,},
	{0x230828,	166.1,	166.9,	165.8,	166.5,	+1.4,	 89884300,},
	{0x230825,	165.0,	165.6,	163.9,	165.1,	-0.5,	 89491900,},
	{0x230824,	164.1,	166.0,	164.0,	165.6,	+1.3,	105884600,},
	{0x230823,	163.0,	164.3,	162.8,	164.3,	+0.9,	 75961200,},
	{0x230822,	162.0,	163.4,	161.3,	163.4,	+1.7,	 91966100,},
	{0x230821,	162.2,	163.2,	161.5,	161.7,	-0.6,	107195800,},
	{0x230818,	162.1,	162.6,	161.3,	162.3,	-0.9,	103919600,},
	{0x230817,	163.0,	164.1,	162.6,	163.2,	+0.3,	 90398300,},
	{0x230816,	163.5,	163.7,	162.4,	162.9,	-1.1,	 99291400,},
	{0x230815,	164.7,	165.0,	163.6,	164.0,	-0.2,	112998600,},
	{0x230814,	164.7,	165.8,	164.0,	164.2,	+0.6,	134431800,},
	{0x230810,	163.7,	164.3,	161.6,	163.6,	+0.7,	166958900,},
	{0x230809,	162.1,	164.1,	161.1,	162.9,	+1.1,	179479700,},
	{0x230808,	160.4,	162.4,	160.1,	161.8,	+1.8,	125788900,},
	{0x230807,	158.0,	160.4,	158.0,	160.0,	+1.5,	124126600,},
	{0x230804,	159.7,	160.1,	157.6,	158.5,	-0.7,	155700300,},
	{0x230803,	160.0,	160.1,	159.0,	159.2,	-1.1,	162794200,},
	{0x230802,	161.0,	161.8,	160.1,	160.3,	-2.0,	151818200,},
	{0x230801,	162.8,	162.8,	161.7,	162.3,	-0.6,	118098900,},
	{0x230731,	162.5,	164.3,	162.2,	162.9,	+2.3,	170080500,},
	{0x230728,	160.2,	160.9,	159.1,	160.6,	-0.2,	248444200,},
	{0x230727,	160.7,	161.9,	160.1,	160.8,	 0.0,	124334300,},
	{0x230726,	162.0,	162.4,	160.0,	160.8,	-2.2,	216438300,},
	{0x230725,	169.0,	169.1,	162.5,	163.0,	-4.4,	262073400,},
	{0x230724,	166.1,	168.0,	166.0,	167.4,	+2.3,	 89708000,},
	{0x230721,	165.0,	167.2,	164.7,	165.1,	+1.5,	154885800,},
	{0x230720,	164.0,	164.9,	163.1,	163.6,	+1.1,	 98174300,},
	{0x230719,	162.8,	163.6,	161.9,	162.5,	+1.0,	100715500,},
	{0x230718,	161.3,	163.6,	161.0,	161.5,	-1.0,	 93133500,},
	{0x230714,	162.0,	164.2,	161.2,	162.5,	-0.6,	111158700,},
	{0x230713,	163.0,	163.7,	161.7,	163.1,	+0.1,	 94563300,},
	{0x230712,	163.5,	164.5,	162.7,	163.0,	 0.0,	131204300,},
	{0x230711,	166.2,	166.3,	163.0,	163.0,	-3.9,	184363800,},
	{0x230710,	166.3,	168.3,	166.2,	166.9,	+0.7,	153163300,},
	{0x230707,	165.6,	167.6,	164.6,	166.2,	-0.8,	198847800,},
	{0x230706,	167.7,	168.0,	165.8,	167.0,	-1.7,	157454800,},
	{0x230705,	169.6,	169.9,	168.0,	168.7,	-1.0,	141152000,},
	{0x230704,	171.0,	171.2,	169.3,	169.7,	-1.5,	150755000,},
	{0x230703,	172.0,	173.4,	170.8,	171.2,	+0.7,	160644300,},
	{0x230630,	172.7,	172.7,	167.5,	170.5,	-0.7,	224327300,},
	{0x230629,	178.9,	178.9,	169.0,	171.2,	-5.0,	264059300,},
	{0x230628,	169.7,	177.0,	169.6,	176.2,	+8.8,	537092500,},
	{0x230627,	165.4,	167.9,	165.1,	167.4,	+2.2,	201980000,},
	{0x230626,	165.0,	166.6,	164.3,	165.2,	+0.4,	174235000,},
	{0x230623,	166.8,	166.9,	164.3,	164.8,	-0.6,	193727500,},
	{0x230622,	165.0,	166.9,	165.0,	165.4,	+0.8,	178362500,},
	{0x230621,	163.0,	165.0,	162.6,	164.6,	+2.2,	172467500,},
	{0x230620,	163.0,	163.2,	162.0,	162.4,	-1.2,	176835000,},
	{0x230619,	164.4,	164.4,	162.7,	163.6,	+0.3,	148082500,},
	{0x230616,	163.1,	163.8,	162.0,	163.3,	+0.1,	266042500,},
	{0x230615,	164.0,	165.3,	163.2,	163.2,	-0.7,	216467500,},
	{0x230614,	163.6,	164.8,	163.2,	163.9,	-0.5,	223335000,},
	{0x230613,	163.6,	165.7,	163.4,	164.4,	-0.3,	206260000,},
	{0x230612,	166.2,	166.3,	164.4,	164.7,	-0.6,	140807500,},
	{0x230609,	163.8,	166.6,	162.7,	165.3,	+3.0,	272557500,},
	{0x230608,	164.0,	165.0,	162.0,	162.3,	-1.9,	179130000,},
	{0x230607,	165.5,	166.7,	163.6,	164.2,	-1.0,	225967500,},
	{0x230606,	161.7,	165.5,	161.4,	165.2,	+2.7,	149990000,},
	{0x230605,	162.5,	163.1,	161.8,	162.5,	+0.9,	157757500,},
	{0x230602,	160.0,	161.8,	159.4,	161.6,	+2.0,	151012500,},
	{0x230601,	159.8,	160.4,	158.8,	159.6,	+1.4,	166262500,},
	{0x230531,	160.0,	160.5,	158.0,	158.2,	-2.4,	309405000,},
	{0x230530,	161.8,	162.4,	160.6,	160.6,	-2.1,	166245000,},
	{0x230529,	163.6,	164.0,	162.5,	162.7,	-0.4,	142117500,},
	{0x230526,	164.2,	164.7,	163.1,	163.1,	-1.6,	164505000,},
	{0x230525,	164.0,	165.5,	164.0,	164.7,	-0.5,	134072500,},
	{0x230524,	165.0,	165.8,	164.6,	165.2,	-1.5,	152897500,},
	{0x230523,	168.6,	169.0,	165.4,	166.7,	-1.4,	198815000,},
	{0x230522,	164.0,	168.2,	163.8,	168.1,	+3.2,	155712500,},
	{0x230519,	166.0,	166.1,	164.4,	164.9,	-1.3,	136475000,},
	{0x230518,	167.0,	167.7,	166.0,	166.2,	-0.4,	163110000,},
	{0x230517,	166.7,	167.6,	165.8,	166.6,	+0.2,	180447500,},
	{0x230516,	170.0,	171.1,	166.4,	166.4,	-1.5,	294782500,},
	{0x230515,	168.3,	173.3,	167.5,	167.9,	+3.6,	390832500,},
	{0x230512,	168.4,	169.9,	161.5,	164.3,	-3.2,	329805000,},
	{0x230511,	167.6,	168.3,	167.0,	167.5,	-0.1,	 92537500,},
	{0x230510,	169.0,	169.3,	167.4,	167.6,	-1.0,	104432500,},
	{0x230509,	166.9,	169.2,	166.9,	168.6,	+1.5,	110565000,},
	{0x230508,	166.7,	167.8,	166.2,	167.1,	-0.3,	114640000,},
	{0x230502,	168.0,	168.8,	167.4,	167.4,	+0.2,	115200000,},
	{0x230501,	166.5,	167.3,	165.9,	167.2,	+1.3,	 87687500,},
	{0x230428,	164.9,	165.9,	164.6,	165.9,	+2.0,	128635000,},
	{0x230427,	163.6,	164.1,	162.8,	163.9,	+0.6,	 90170000,},
	{0x230426,	162.8,	164.1,	162.8,	163.3,	 0.0,	121245000,},
	{0x230425,	162.8,	163.8,	162.4,	163.3,	+1.7,	128082500,},
	{0x230424,	161.4,	162.3,	161.0,	161.6,	+1.2,	104877500,},
	{0x230421,	160.5,	161.8,	160.3,	160.4,	-0.5,	 79557500,},
	{0x230420,	160.0,	161.2,	159.6,	160.9,	-1.1,	 92060000,},
	{0x230419,	162.0,	162.5,	161.0,	162.0,	 0.0,	 84030000,},
	{0x230418,	160.0,	162.0,	159.8,	162.0,	+3.2,	125712500,},
	{0x230417,	159.0,	159.4,	158.6,	158.8,	-0.7,	 71072500,},
	{0x230414,	159.2,	159.5,	158.6,	159.5,	+0.3,	 97515000,},
	{0x230413,	159.8,	160.1,	158.8,	159.2,	 0.0,	 95372500,},
	{0x230412,	159.3,	159.8,	158.7,	159.2,	+1.4,	103060000,},
	{0x230411,	158.0,	158.8,	157.8,	157.8,	+0.7,	 91572500,},
	{0x230410,	157.6,	158.2,	156.6,	157.1,	 0.0,	 61135000,},
	{0x230407,	158.1,	158.1,	157.0,	157.1,	-0.4,	 72535000,},
	{0x230406,	157.4,	158.2,	156.5,	157.5,	-0.5,	126662500,},
	{0x230405,	160.0,	160.0,	157.7,	158.0,	-1.5,	111275000,},
	{0x230404,	158.5,	159.9,	158.3,	159.5,	+0.9,	162355000,},
	{0x230403,	157.9,	158.6,	156.8,	158.6,	+0.2,	112565000,},
	{0x230331,	158.2,	159.5,	158.0,	158.4,	-0.6,	176227500,},
	{0x230330,	160.0,	160.4,	158.4,	159.0,	-2.8,	105225000,},
	{0x230329,	160.6,	161.8,	159.6,	161.8,	+1.9,	162587500,},
	{0x230328,	160.2,	160.7,	159.6,	159.9,	+0.2,	 91010000,},
	{0x230327,	159.6,	160.4,	159.4,	159.7,	+1.0,	 95135000,},
	{0x230324,	158.8,	159.5,	158.6,	158.7,	-0.8,	 97772500,},
	{0x230323,	160.4,	160.7,	159.5,	159.5,	-2.2,	126080000,},
	{0x230322,	160.3,	163.2,	159.9,	161.7,	+2.1,	177355000,},
	{0x230320,	160.2,	160.8,	159.4,	159.6,	-0.6,	104967500,},
	{0x230317,	160.0,	160.8,	159.6,	160.2,	 0.0,	143542500,},
	{0x230316,	155.8,	160.6,	155.8,	160.2,	+2.4,	195332500,},
	{0x230315,	158.4,	159.3,	157.2,	157.8,	+0.7,	136897500,},
	{0x230314,	158.4,	158.5,	154.8,	157.1,	-1.4,	186532500,},
	{0x230313,	159.7,	160.0,	157.8,	158.5,	-0.9,	119870000,},
	{0x230310,	160.6,	160.9,	159.4,	159.4,	-1.6,	160855000,},
	{0x230309,	161.2,	162.2,	161.0,	161.0,	+0.4,	119150000,},
	{0x230308,	160.0,	161.0,	160.0,	160.6,	+0.9,	109642500,},
	{0x230307,	158.2,	160.8,	158.1,	159.7,	+0.6,	144562500,},
	{0x230306,	159.4,	159.8,	158.8,	159.1,	-0.3,	101190000,},
	{0x230303,	157.8,	160.0,	157.4,	159.4,	+2.7,	168602500,},
	{0x230302,	157.2,	158.6,	156.5,	156.7,	-0.3,	134865000,},
	{0x230301,	157.8,	158.4,	157.0,	157.0,	-0.8,	 97510000,},
	{0x230228,	158.1,	159.0,	157.8,	157.8,	-0.8,	120227500,},
	{0x230227,	159.6,	159.7,	158.4,	158.6,	-0.6,	 93310000,},
	{0x230224,	157.6,	159.5,	157.5,	159.2,	+1.2,	139812500,},
	{0x230222,	158.6,	158.8,	157.3,	158.0,	-0.6,	105985000,},
	{0x230221,	158.8,	159.6,	158.4,	158.6,	-0.2,	 93487500,},
	{0x230220,	156.4,	159.1,	156.2,	158.8,	+3.3,	124452500,},
	{0x230217,	154.4,	155.7,	154.1,	155.5,	 0.0,	 69102500,},
	{0x230216,	154.3,	156.0,	154.1,	155.5,	+0.2,	 83230000,},
	{0x230215,	156.2,	156.7,	155.2,	155.3,	+0.3,	 87792500,},
	{0x230214,	154.4,	155.6,	154.2,	155.0,	+0.6,	 83267500,},
	{0x230213,	153.6,	154.8,	153.4,	154.4,	+0.8,	 81170000,},
	{0x230210,	152.4,	154.1,	151.2,	153.6,	 0.0,	166637500,},
	{0x230209,	154.8,	155.5,	153.5,	153.6,	-1.2,	139375000,},
	{0x230208,	153.6,	155.4,	153.6,	154.8,	+0.6,	105985000,},
	{0x230207,	154.2,	154.8,	154.0,	154.2,	+0.3,	105780000,},
	{0x230206,	153.5,	154.2,	153.3,	153.9,	+0.7,	116927500,},
	{0x230203,	153.6,	153.8,	152.6,	153.2,	-0.5,	141257500,},
	{0x230202,	154.2,	154.8,	153.6,	153.7,	-1.7,	116472500,},
	{0x230201,	155.9,	156.5,	155.4,	155.4,	-0.2,	109852500,},
	{0x230131,	156.8,	157.1,	155.6,	155.6,	+0.1,	114077500,},
	{0x230130,	154.7,	155.7,	154.4,	155.5,	+0.4,	104652500,},
	{0x230127,	155.2,	155.9,	154.1,	155.1,	-1.1,	 99805000,},
	{0x230126,	156.8,	156.9,	156.2,	156.2,	+0.3,	 99240000,},
	{0x230125,	155.8,	156.4,	155.3,	155.9,	+0.1,	 97432500,},
	{0x230124,	153.4,	155.9,	153.1,	155.8,	+2.6,	140235000,},
	{0x230123,	151.8,	153.5,	151.4,	153.2,	+1.2,	122190000,},
	{0x230120,	150.8,	152.4,	150.4,	152.0,	+1.9,	115222500,},
	{0x230119,	149.8,	150.5,	149.4,	150.1,	-0.3,	117455000,},
	{0x230118,	150.2,	150.8,	148.7,	150.4,	+0.7,	142922500,},
	{0x230117,	149.4,	150.1,	148.6,	149.7,	+0.7,	110382500,},
	{0x230116,	149.9,	150.8,	148.9,	149.0,	-0.6,	118755000,},
	{0x230113,	149.2,	150.0,	149.0,	149.6,	-0.1,	108687500,},
	{0x230112,	148.0,	149.8,	147.8,	149.7,	+0.7,	108240000,},
	{0x230111,	148.4,	149.6,	148.2,	149.0,	+1.2,	116355000,},
	{0x230110,	149.0,	150.4,	147.8,	147.8,	-1.8,	223885000,},
	{0x230106,	150.5,	150.9,	149.6,	149.6,	-0.9,	143885000,},
	{0x230105,	151.4,	152.2,	149.7,	150.5,	+0.1,	150515000,},
	{0x230104,	150.4,	151.8,	150.4,	150.4,	 0.0,	149722500,},
	{0x221230,	150.7,	152.2,	150.4,	150.4,	-0.7,	 74032500,},
	{0x221229,	151.6,	151.6,	150.2,	151.1,	-0.8,	 71935000,},
	{0x221228,	152.5,	152.8,	151.4,	151.9,	+0.5,	 59540000,},
	{0x221227,	152.2,	152.3,	151.4,	151.4,	+0.2,	 43727500,},
	{0x221226,	151.8,	152.2,	151.0,	151.2,	-1.0,	 50442500,},
	{0x221223,	152.0,	152.5,	151.6,	152.2,	+0.8,	102652500,},
	{0x221222,	150.4,	151.8,	149.8,	151.4,	+2.1,	124632500,},
	{0x221221,	149.4,	150.6,	149.1,	149.3,	+0.3,	164797500,},
	{0x221220,	149.4,	150.6,	147.6,	149.0,	-1.2,	180212500,},
	{0x221219,	149.2,	150.7,	149.2,	150.2,	+1.0,	101347500,},
	{0x221216,	150.2,	150.5,	148.8,	149.2,	-1.6,	234357500,},
	{0x221215,	150.3,	151.0,	150.0,	150.8,	+0.5,	 91560000,},
	{0x221214,	150.2,	150.7,	149.6,	150.3,	+0.1,	 81437500,},
	{0x221213,	149.4,	150.4,	149.2,	150.2,	+1.0,	 89007500,},
	{0x221212,	149.4,	149.9,	149.0,	149.2,	-0.9,	 85800000,},
	{0x221209,	150.0,	151.5,	149.5,	150.1,	+2.3,	167037500,},
	{0x221208,	149.2,	149.8,	147.8,	147.8,	-1.0,	139517500,},
	{0x221207,	149.4,	149.4,	148.5,	148.8,	-0.8,	111290000,},
	{0x221206,	150.0,	150.3,	149.1,	149.6,	+1.1,	120687500,},
	{0x221205,	149.9,	150.0,	147.4,	148.5,	-0.4,	162205000,},
	{0x221202,	150.3,	150.3,	148.6,	148.9,	-3.8,	210677500,},
	{0x221201,	152.8,	153.5,	152.4,	152.7,	-0.1,	107975000,},
	{0x221130,	154.2,	154.2,	152.8,	152.8,	-0.7,	185190000,},
	{0x221129,	154.5,	154.7,	153.0,	153.5,	-1.6,	118767500,},
	{0x221128,	156.2,	156.2,	154.8,	155.1,	-0.3,	 84580000,},
	{0x221125,	156.0,	156.0,	154.9,	155.4,	+0.2,	101210000,},
	{0x221124,	156.8,	157.3,	155.1,	155.2,	-1.0,	191240000,},
	{0x221122,	155.2,	156.8,	155.1,	156.2,	+2.5,	132630000,},
	{0x221121,	154.5,	154.8,	153.2,	153.7,	-0.1,	 91800000,},
	{0x221118,	151.0,	154.4,	150.8,	153.8,	+3.4,	150092500,},
	{0x221117,	151.9,	152.2,	150.4,	150.4,	+0.4,	139815000,},
	{0x221116,	149.2,	150.7,	148.7,	150.0,	-0.3,	171822500,},
	{0x221115,	151.7,	152.6,	150.3,	150.3,	-0.9,	137135000,},
	{0x221114,	153.7,	153.9,	151.2,	151.2,	-3.7,	223300000,},
	{0x221111,	158.0,	158.2,	154.8,	154.9,	-2.3,	202182500,},
	{0x221110,	155.6,	157.6,	155.6,	157.2,	+0.5,	116187500,},
	{0x221109,	160.1,	160.4,	156.6,	156.7,	-5.3,	168785000,},
	{0x221108,	161.0,	162.2,	159.9,	162.0,	+1.9,	168927500,},
	{0x221107,	161.0,	161.3,	159.7,	160.1,	-0.1,	104652500,},
	{0x221104,	162.6,	163.2,	160.1,	160.2,	-1.8,	175952500,},
	{0x221102,	162.0,	162.4,	161.0,	162.0,	-0.4,	132590000,},
	{0x221101,	163.9,	165.1,	161.9,	162.4,	-1.3,	114905000,},
	{0x221031,	162.5,	164.5,	162.5,	163.7,	+0.2,	123802500,},
	{0x221028,	162.2,	164.2,	161.6,	163.5,	+1.5,	346885000,},
	{0x221027,	163.2,	163.5,	161.4,	162.0,	-2.2,	135180000,},
	{0x221026,	163.3,	165.0,	163.2,	164.2,	+1.3,	109160000,},
	{0x221025,	161.0,	163.3,	160.1,	162.9,	+3.3,	 99430000,},
	{0x221024,	161.3,	162.5,	159.6,	159.6,	-1.7,	102820000,},
	{0x221021,	164.2,	165.1,	161.3,	161.3,	-2.4,	118910000,},
	{0x221020,	161.1,	163.9,	160.8,	163.7,	+2.8,	190500000,},
	{0x221019,	160.8,	161.9,	160.1,	160.9,	+0.3,	123582500,},
	{0x221018,	160.6,	160.6,	159.0,	160.6,	+1.8,	124867500,},
	{0x221017,	159.5,	159.9,	158.2,	158.8,	+0.1,	115937500,},
	{0x221014,	157.6,	160.2,	157.6,	158.7,	+2.3,	142942500,},
	{0x221013,	156.6,	157.5,	155.8,	156.4,	-1.6,	144867500,},
	{0x221012,	159.1,	160.7,	158.0,	158.0,	-2.0,	178680000,},
	{0x221011,	158.1,	160.5,	158.0,	160.0,	+1.3,	180235000,},
	{0x221007,	157.8,	159.2,	157.6,	158.7,	-0.7,	119272500,},
	{0x221006,	159.7,	160.4,	159.0,	159.4,	+0.3,	145330000,},
	{0x221005,	159.3,	160.7,	158.6,	159.1,	+0.4,	157757500,},
	{0x221004,	155.6,	158.8,	154.5,	158.7,	+5.3,	160012500,},
	{0x221003,	155.2,	155.6,	152.8,	153.4,	-2.8,	117497500,},
	{0x220930,	157.1,	158.1,	156.1,	156.2,	-0.7,	197240000,},
	{0x220929,	152.0,	157.1,	151.7,	156.9,	+3.1,	175430000,},
	{0x220928,	152.2,	154.0,	151.6,	153.8,	-1.2,	177265000,},
	{0x220927,	154.2,	156.1,	153.8,	155.0,	-0.5,	109817500,},
	{0x220926,	155.9,	156.8,	155.0,	155.5,	+0.9,	176015000,},
	{0x220922,	154.4,	155.0,	153.4,	154.6,	-0.2,	105552500,},
	{0x220921,	157.4,	157.4,	154.5,	154.8,	-1.8,	131285000,},
	{0x220920,	155.6,	157.1,	155.2,	156.6,	+2.8,	139160000,},
	{0x220916,	154.1,	154.4,	153.0,	153.8,	-0.7,	147482500,},
	{0x220915,	154.0,	154.8,	153.7,	154.5,	-0.5,	102585000,},
	{0x220914,	156.8,	156.8,	154.8,	155.0,	-2.4,	145632500,},
	{0x220913,	157.2,	158.0,	156.4,	157.4,	-1.0,	115910000,},
	{0x220912,	158.2,	159.5,	158.0,	158.4,	+0.2,	 91075000,},
	{0x220909,	157.8,	158.2,	156.2,	158.2,	+1.1,	184492500,},
	{0x220908,	154.4,	157.4,	153.9,	157.1,	+6.5,	265460000,},
	{0x220907,	151.1,	151.4,	149.4,	150.6,	+1.6,	144592500,},
	{0x220906,	148.4,	149.2,	148.4,	149.0,	-0.9,	 97787500,},
	{0x220905,	150.8,	150.9,	149.6,	149.9,	-0.9,	 76442500,},
	{0x220902,	150.9,	151.3,	149.6,	150.8,	+1.2,	117307500,},
	{0x220901,	149.4,	150.3,	149.0,	149.6,	-1.1,	117922500,},
	{0x220831,	150.6,	152.0,	150.5,	150.7,	-1.7,	229340000,},
	{0x220830,	150.7,	152.9,	150.3,	152.4,	+2.3,	215505000,},
	{0x220829,	150.5,	150.6,	148.9,	150.1,	-0.5,	118482500,},
	{0x220826,	150.6,	151.6,	149.8,	150.6,	-0.6,	124967500,},
	{0x220825,	151.4,	152.0,	150.8,	151.2,	-0.1,	 84987500,},
	{0x220824,	151.1,	151.5,	150.6,	151.3,	-0.4,	 96917500,},
	{0x220823,	151.8,	152.0,	150.6,	151.7,	+0.1,	105385000,},
	{0x220822,	150.7,	151.6,	149.6,	151.6,	+1.2,	111060000,},
	{0x220819,	149.1,	150.5,	149.1,	150.4,	+0.9,	 88225000,},
	{0x220818,	150.6,	150.7,	148.8,	149.5,	+0.3,	108530000,},
	{0x220817,	147.0,	149.7,	146.9,	149.2,	+1.8,	134912500,},
	{0x220816,	147.8,	148.6,	147.4,	147.4,	-1.2,	 78947500,},
	{0x220815,	147.6,	149.1,	147.3,	148.6,	+0.7,	109580000,},
	{0x220812,	150.3,	151.1,	147.8,	147.9,	-1.8,	205285000,},
	{0x220810,	149.2,	150.8,	148.5,	149.7,	+0.9,	 93010000,},
	{0x220809,	152.6,	152.6,	148.8,	148.8,	-2.8,	138142500,},
	{0x220808,	150.6,	152.9,	150.2,	151.6,	+0.3,	 96970000,},
	{0x220805,	149.3,	151.5,	149.2,	151.3,	+1.5,	 80695000,},
	{0x220804,	150.7,	151.0,	149.3,	149.8,	 0.0,	100507500,},
	{0x220803,	150.6,	151.1,	149.0,	149.8,	 0.0,	 87270000,},
	{0x220802,	150.9,	151.8,	149.7,	149.8,	-2.2,	118255000,},
	{0x220801,	152.0,	152.3,	150.8,	152.0,	-0.2,	111500000,},
	{0x220729,	154.7,	154.9,	152.2,	152.2,	-3.2,	148452500,},
	{0x220728,	155.4,	155.4,	154.4,	155.4,	+0.3,	112150000,},
	{0x220727,	155.4,	155.8,	154.6,	155.1,	+0.2,	 90357500,},
	{0x220726,	155.2,	155.5,	154.7,	154.9,	-0.5,	 86747500,},
	{0x220725,	155.0,	156.4,	155.0,	155.4,	-1.2,	 90325000,},
	{0x220722,	155.8,	157.2,	155.8,	156.6,	+0.4,	 93022500,},
	{0x220721,	155.0,	156.6,	154.7,	156.2,	+0.4,	111935000,},
	{0x220720,	155.1,	155.8,	154.6,	155.8,	+0.9,	106247500,},
	{0x220719,	156.1,	157.0,	154.9,	154.9,	-1.7,	110290000,},
	{0x220715,	157.3,	157.8,	155.6,	156.6,	+0.4,	 88825000,},
	{0x220714,	155.6,	156.3,	155.0,	156.2,	 0.0,	 98722500,},
	{0x220713,	156.8,	157.8,	155.3,	156.2,	-0.4,	101770000,},
	{0x220712,	158.0,	158.5,	156.2,	156.6,	+0.1,	119600000,},
	{0x220711,	154.8,	156.6,	154.6,	156.5,	+3.3,	101155000,},
	{0x220708,	153.2,	155.0,	153.0,	153.2,	-0.6,	154242500,},
	{0x220707,	153.9,	154.7,	153.2,	153.8,	+0.8,	112585000,},
	{0x220706,	153.8,	154.4,	152.6,	153.0,	-2.8,	141005000,},
	{0x220705,	156.5,	156.7,	155.5,	155.8,	-0.7,	115725000,},
	{0x220704,	155.2,	156.5,	154.8,	156.5,	+1.1,	 84617500,},
	{0x220701,	157.3,	157.5,	154.4,	155.4,	-0.4,	119077500,},
	{0x220630,	155.8,	157.4,	155.7,	155.8,	-1.0,	159695000,},
	{0x220629,	158.7,	159.0,	156.0,	156.8,	-1.8,	438362500,},
	{0x220628,	156.6,	159.7,	156.2,	158.6,	+3.1,	171825000,},
	{0x220627,	156.0,	157.1,	154.2,	155.5,	 0.0,	163825000,},
};
