/*------------------------------------------------------------------------------
	インクルード
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <stdarg.h>

/*------------------------------------------------------------------------------
	デファイン
------------------------------------------------------------------------------*/
#define CNT   321
#define OUT   9
#define DAYS  21
#define RANGE 1500

/*------------------------------------------------------------------------------
	マクロ
------------------------------------------------------------------------------*/
#define PRINT(x, ...)  fprintf_crlf((char *)x, ##__VA_ARGS__)

/*------------------------------------------------------------------------------
	型定義
------------------------------------------------------------------------------*/
typedef char INT8;
typedef int  INT32;

/*------------------------------------------------------------------------------
	構造体
------------------------------------------------------------------------------*/
typedef struct Field {
	INT32  date;
	double sta;
	double max;
	double min;
	double end;
	double ratio;
	INT32  trade;
} Field;

/*------------------------------------------------------------------------------
	ローカル変数
------------------------------------------------------------------------------*/
FILE *fp;

/*------------------------------------------------------------------------------
	内部参照
------------------------------------------------------------------------------*/
extern Field field[CNT];

/*------------------------------------------------------------------------------
	プロトタイプ
------------------------------------------------------------------------------*/
void difinition(void);
void fixed(void);
void value(void);
void fprintf_crlf(char *pStr, ...);

/*------------------------------------------------------------------------------
	書式：int main(void)
	引数：-
	戻値：int  -
	機能：スタートアップ
------------------------------------------------------------------------------*/
int main(void)
{
	fp = fopen("full.txt", "wb");
	if (fp == NULL) {printf("open error\r\n");}
	
	difinition();
	fixed();
	value();
	
	fclose(fp);
}

/*------------------------------------------------------------------------------
	書式：void difinition(void)
	機能：定義部分を出力
------------------------------------------------------------------------------*/
void difinition(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  色");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, RGB_BLACK,  000000");
	PRINT("DEFINE, RGB_GRAY,   C0C0C0");
	PRINT("DEFINE, RGB_RED,    F00000");
	PRINT("DEFINE, RGB_GREEN,  00F000");
	PRINT("DEFINE, RGB_BLUE,   0000F0");
	PRINT("DEFINE, RGB_MAZENTA,F000F0");
	PRINT("DEFINE, RGB_YELLOW, F0F000");
	PRINT("DEFINE, RGB_CYAN,   00F0F0");
	PRINT("DEFINE, RGB_AVE100, F0F0F0");
	PRINT("DEFINE, RGB_AVE75,  A0A0F0");
	PRINT("DEFINE, RGB_AVE25,  F0A0A0");
	PRINT("DEFINE, RGB_AVE5,   A0F0A0");
	PRINT("");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  座標");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, DAYS,      %2d", DAYS);
	PRINT("DEFINE, MAX,       4000");
	PRINT("DEFINE, MIN,       2500");
	PRINT("DEFINE, RANGE,     %d", RANGE);
	PRINT("DEFINE, X1,        77");
	PRINT("DEFINE, Y1,        255");
	PRINT("DEFINE, X2,        767");
	PRINT("DEFINE, Y2,        863");
	PRINT("DEFINE, W,         (X2-X1)");
	PRINT("DEFINE, H,         (Y2-Y1)");
	PRINT("DEFINE, X_SCALE,   28");
	PRINT("DEFINE, Y_WEEKEND, (Y2+5)");
	PRINT("DEFINE, Y_4000,    (((H* 0)/30)+Y1)");
	PRINT("DEFINE, Y_3950,    (((H* 1)/30)+Y1)");
	PRINT("DEFINE, Y_3900,    (((H* 2)/30)+Y1)");
	PRINT("DEFINE, Y_3850,    (((H* 3)/30)+Y1)");
	PRINT("DEFINE, Y_3800,    (((H* 4)/30)+Y1)");
	PRINT("DEFINE, Y_3750,    (((H* 5)/30)+Y1)");
	PRINT("DEFINE, Y_3700,    (((H* 6)/30)+Y1)");
	PRINT("DEFINE, Y_3650,    (((H* 7)/30)+Y1)");
	PRINT("DEFINE, Y_3600,    (((H* 8)/30)+Y1)");
	PRINT("DEFINE, Y_3550,    (((H* 9)/30)+Y1)");
	PRINT("DEFINE, Y_3500,    (((H*10)/30)+Y1)");
	PRINT("DEFINE, Y_3450,    (((H*11)/30)+Y1)");
	PRINT("DEFINE, Y_3400,    (((H*12)/30)+Y1)");
	PRINT("DEFINE, Y_3350,    (((H*13)/30)+Y1)");
	PRINT("DEFINE, Y_3300,    (((H*14)/30)+Y1)");
	PRINT("DEFINE, Y_3250,    (((H*15)/30)+Y1)");
	PRINT("DEFINE, Y_3200,    (((H*16)/30)+Y1)");
	PRINT("DEFINE, Y_3150,    (((H*17)/30)+Y1)");
	PRINT("DEFINE, Y_3100,    (((H*18)/30)+Y1)");
	PRINT("DEFINE, Y_3050,    (((H*19)/30)+Y1)");
	PRINT("DEFINE, Y_3000,    (((H*20)/30)+Y1)");
	PRINT("DEFINE, Y_2950,    (((H*21)/30)+Y1)");
	PRINT("DEFINE, Y_2900,    (((H*22)/30)+Y1)");
	PRINT("DEFINE, Y_2850,    (((H*23)/30)+Y1)");
	PRINT("DEFINE, Y_2800,    (((H*24)/30)+Y1)");
	PRINT("DEFINE, Y_2750,    (((H*25)/30)+Y1)");
	PRINT("DEFINE, Y_2700,    (((H*26)/30)+Y1)");
	PRINT("DEFINE, Y_2650,    (((H*27)/30)+Y1)");
	PRINT("DEFINE, Y_2600,    (((H*28)/30)+Y1)");
	PRINT("DEFINE, Y_2550,    (((H*29)/30)+Y1)");
	PRINT("DEFINE, Y_2500,    (((H*30)/30)+Y1)");
	PRINT("DEFINE, gX,        (X1+18)");
	PRINT("DEFINE, gW,        (W-18*2)");
	PRINT("DEFINE, tX1,       X1");
	PRINT("DEFINE, tY1,       910");
	PRINT("DEFINE, tX2,       X2");
	PRINT("DEFINE, tY2,       1030");
	PRINT("DEFINE, tW,        W");
	PRINT("DEFINE, tH,        (tY2-tY1)");
	PRINT("DEFINE, tMAX,      1500");
	PRINT("DEFINE, tMIN,      0");
	PRINT("DEFINE, tRANGE,    15000000");
	PRINT("DEFINE, tX_SCALE,  20");
	PRINT("DEFINE, tY_1500,   (((tH*0)/6)+tY1)");
	PRINT("DEFINE, tY_1250,   (((tH*1)/6)+tY1)");
	PRINT("DEFINE, tY_1000,   (((tH*2)/6)+tY1)");
	PRINT("DEFINE, tY_0750,   (((tH*3)/6)+tY1)");
	PRINT("DEFINE, tY_0500,   (((tH*4)/6)+tY1)");
	PRINT("DEFINE, tY_0250,   (((tH*5)/6)+tY1)");
	PRINT("DEFINE, tY_0000,   (((tH*6)/6)+tY1)");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void fixed(void)
	機能：固定部分を出力
------------------------------------------------------------------------------*/
void fixed(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  固定");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 0, 0, 840, 1050, 000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("");
	PRINT("RECT, 45,  70,  250, 160, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 49,  74,  242, 152, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 320, 120, 220, 110, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("");
	PRINT("LINE, X1, Y1, X2, Y1, RGB_BLACK, 1");
	PRINT("LINE, X1, Y1, X1, Y2, RGB_BLACK, 1");
	PRINT("LINE, X2, Y1, X2, Y2, RGB_BLACK, 1");
	PRINT("LINE, X1, Y2, X2, Y2, RGB_BLACK, 1");
	PRINT("");
	PRINT("LINE, X1+1, Y_3900, X2-1, Y_3900, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3800, X2-1, Y_3800, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3700, X2-1, Y_3700, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3600, X2-1, Y_3600, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3500, X2-1, Y_3500, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3400, X2-1, Y_3400, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3300, X2-1, Y_3300, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3200, X2-1, Y_3200, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3100, X2-1, Y_3100, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_3000, X2-1, Y_3000, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_2900, X2-1, Y_2900, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_2800, X2-1, Y_2800, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_2700, X2-1, Y_2700, RGB_GRAY, 1");
	PRINT("LINE, X1+1, Y_2600, X2-1, Y_2600, RGB_GRAY, 1");
	PRINT("");
	PRINT("LINE, X1, Y_3950, X1+4, Y_3950, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3850, X1+4, Y_3850, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3750, X1+4, Y_3750, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3650, X1+4, Y_3650, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3550, X1+4, Y_3550, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3450, X1+4, Y_3450, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3350, X1+4, Y_3350, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3250, X1+4, Y_3250, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3150, X1+4, Y_3150, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_3050, X1+4, Y_3050, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_2950, X1+4, Y_2950, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_2850, X1+4, Y_2850, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_2750, X1+4, Y_2750, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_2650, X1+4, Y_2650, RGB_BLACK, 1");
	PRINT("LINE, X1, Y_2550, X1+4, Y_2550, RGB_BLACK, 1");
	PRINT("");
	PRINT("TEXT, X_SCALE,(Y_4000-8),4000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3950-8),3950, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3900-8),3900, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3850-8),3850, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3800-8),3800, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3750-8),3750, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3700-8),3700, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3650-8),3650, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3600-8),3600, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3550-8),3550, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3500-8),3500, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3450-8),3450, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3400-8),3400, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3350-8),3350, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3300-8),3300, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3250-8),3250, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3200-8),3200, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3150-8),3150, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3100-8),3100, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3050-8),3050, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_3000-8),3000, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2950-8),2950, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2900-8),2900, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2850-8),2850, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2800-8),2800, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2750-8),2750, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2700-8),2700, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2650-8),2650, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2600-8),2600, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2550-8),2550, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("TEXT, X_SCALE,(Y_2500-8),2500, RGB_BLACK, 000000, TRUE, ＭＳ ゴシック, 16, FALSE");
	PRINT("");
	PRINT("DEFINE, Y_4.75, (Y2-((H*(3957.89-MIN))/RANGE))");
	PRINT("DEFINE, Y_5.00, (Y2-((H*(3760.00-MIN))/RANGE))");
	PRINT("DEFINE, Y_5.25, (Y2-((H*(3580.95-MIN))/RANGE))");
	PRINT("DEFINE, Y_5.50, (Y2-((H*(3418.18-MIN))/RANGE))");
	PRINT("DEFINE, Y_5.75, (Y2-((H*(3269.56-MIN))/RANGE))");
	PRINT("DEFINE, Y_6.00, (Y2-((H*(3133.33-MIN))/RANGE))");
	PRINT("DEFINE, Y_6.25, (Y2-((H*(3008.00-MIN))/RANGE))");
	PRINT("DEFINE, Y_6.50, (Y2-((H*(2892.30-MIN))/RANGE))");
	PRINT("DEFINE, Y_6.75, (Y2-((H*(2785.18-MIN))/RANGE))");
	PRINT("DEFINE, Y_7.00, (Y2-((H*(2685.71-MIN))/RANGE))");
	PRINT("DEFINE, Y_7.25, (Y2-((H*(2593.10-MIN))/RANGE))");
	PRINT("DEFINE, Y_7.50, (Y2-((H*(2506.66-MIN))/RANGE))");
	PRINT("LINE, X2-4, Y_4.75, X2, Y_4.75, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_5.00, X2, Y_5.00, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_5.25, X2, Y_5.25, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_5.50, X2, Y_5.50, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_5.75, X2, Y_5.75, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_6.00, X2, Y_6.00, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_6.25, X2, Y_6.25, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_6.50, X2, Y_6.50, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_6.75, X2, Y_6.75, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_7.00, X2, Y_7.00, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_7.25, X2, Y_7.25, RGB_BLACK, 1");
	PRINT("LINE, X2-4, Y_7.50, X2, Y_7.50, RGB_BLACK, 1");
	PRINT("TEXT, 775,(Y_4.75-6),4.75, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_5.00-6),5.00, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_5.25-6),5.25, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_5.50-6),5.50, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_5.75-6),5.75, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_6.00-6),6.00, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_6.25-6),6.25, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_6.50-6),6.50, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_6.75-6),6.75, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_7.00-6),7.00, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_7.25-6),7.25, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("TEXT, 775,(Y_7.50-6),7.50, RGB_BLACK, 000000, TRUE, Arial, 12, FALSE");
	PRINT("");
	PRINT("LINE, X1,   tY_1500, X2,   tY_1500, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_1000, X2,   tY_1000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0500, X2,   tY_0500, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0000, X2,   tY_0000, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_1250, X1+4, tY_1250, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0750, X1+4, tY_0750, RGB_GRAY, 1");
	PRINT("LINE, X1,   tY_0250, X1+4, tY_0250, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_1250, X2,   tY_1250, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_0750, X2,   tY_0750, RGB_GRAY, 1");
	PRINT("LINE, X2-4, tY_0250, X2,   tY_0250, RGB_GRAY, 1");
	PRINT("");
	PRINT("TEXT, tX_SCALE,    (tY_1500-10),1500, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_1000-10),1000, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE,    (tY_0500-10),0500, RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("TEXT, tX_SCALE+36, (tY_0000-10),0,    RGB_BLACK, 000000, TRUE, Arial, 18, FALSE");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void value(void)
	機能：値部分を出力
------------------------------------------------------------------------------*/
void value(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  値");
	PRINT(":-------------------------------------------------------------------------------");
	
	INT32 i, j;
	INT32 cnt;
	double ave5 [CNT];
	double ave25[CNT];
	double ave75[CNT];
	double ave100[CNT];
	Field tmp[CNT];
	
	for (i = 0; i < CNT; i++) {tmp[i] = field[CNT-1-i];}
	
	for (i = 0; i < CNT; i++) {
		ave5 [i] = 0.0;
		ave25[i] = 0.0;
		ave75[i] = 0.0;
		ave100[i] = 0.0;
		
		if (4 <= i) {
			for (j = 0; j < 5; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= 5;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= cnt;
		}
		
		if (24 <= i) {
			for (j = 0; j < 25; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= 25;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= cnt;
		}
		
		if (74 <= i) {
			for (j = 0; j < 75; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= 75;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= cnt;
		}
		
		if (99 <= i) {
			for (j = 0; j < 100; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= 100;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= cnt;
		}
	}
	
	char fmt1_1[100+1] = "TEXT, 319, 25 ,2914 日本たばこ産業 20%02X年%2X月, RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_2[100+1] = "TEXT, 105, 100,%4.0f,                           RGB_BLACK, 000000, TRUE, Arial, 70, FALSE";
	char fmt1_3[100+1] = "TEXT, 75,  185,20%02X/%02X/%02X 15:00 現在,          RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_4[100+1] = "TEXT, 333, 130,%s,            RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_5[100+1] = "TEXT, 333, 162,%s,            RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt1_6[100+1] = "TEXT, 455, 193,%.2f%,                          RGB_BLACK, 000000, TRUE, Arial, 30, FALSE";
	
	if (tmp[CNT-1].end == 0) {printf("0 div error\r\n");}
	
	PRINT(fmt1_1, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8);
	PRINT(fmt1_2, tmp[CNT-1].end);
	PRINT(fmt1_3, (tmp[CNT-1].date & 0x00FF0000)>>16,
	              (tmp[CNT-1].date & 0x0000FF00)>> 8,
	              (tmp[CNT-1].date & 0x000000FF)>> 0);
	PRINT(fmt1_4, "113円　2023年12月末");
	PRINT(fmt1_5, " 94円　2023年 6月末");
	PRINT(fmt1_6, (188/tmp[CNT-1].end)*100);
	
	PRINT("");
	
	INT8 fmt2_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE), %s";
	INT8 fmt2_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE)";
	INT8 fmt2_3[150+1] = "DEFINE, GY%02X_%s, (Y2-((H*(%.1f-MIN))/RANGE))";
	INT8 fmt2_4[150+1] = "DEFINE, GH%02X,     ((H*(%.1f-%.1f))/RANGE)";
	INT8 fmt2_5[150+1] = "DEFINE, GH%02X,     %d";
	INT8 fmt2_6[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), GY%02X_%s, 7, GH%02X, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT8 fmt2_7[150+1] = "LINE, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MAX, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MIN, %s 1";
	INT8 fmt2_8[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), tY2, 6, -(tH*%8d)/tRANGE, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT32 dt;
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave100[i], "RGB_AVE100, 7");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave100[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave75[i], "RGB_AVE75, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave75[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave25[i], "RGB_AVE25, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave25[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (i == (CNT - OUT)) {
				PRINT(fmt2_1, i-(CNT-OUT)+1, ave5[i], "RGB_AVE5, 2");
			}
			else {
				PRINT(fmt2_2, i-(CNT-OUT)+1, ave5[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			PRINT(fmt2_3, dt, "STA", tmp[i].sta);
			PRINT(fmt2_3, dt, "MAX", tmp[i].max);
			PRINT(fmt2_3, dt, "MIN", tmp[i].min);
			PRINT(fmt2_3, dt, "END", tmp[i].end);
			
			if (tmp[i].end >= tmp[i].sta) {
				if ((INT32)((608*(tmp[i].end-tmp[i].sta))/RANGE) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].end, tmp[i].sta);
				}
			}
			else {
				if ((INT32)((608*(tmp[i].sta-tmp[i].end))/RANGE) == 0) {
					PRINT(fmt2_5, dt, 1);
				}
				else {
					PRINT(fmt2_4, dt, tmp[i].sta, tmp[i].end);
				}
			}
			PRINT("");
		}
	}
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "END", dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_6, i-(CNT-OUT)+1, dt, "STA", dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_RED, ");}
			else                          {PRINT(fmt2_7, i-(CNT-OUT)+1, dt, i-(CNT-OUT)+1, dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			if (tmp[i].ratio > 0) {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_RED, ");
			}
			else {
				PRINT(fmt2_8, i-(CNT-OUT)+1, tmp[i].trade, "RGB_BLUE,");
			}
		}
	}
	PRINT("");
	
	INT32 rate[31] = {0};
	INT32 pos;
	INT32 max = 0;
	INT8 fmt3_1[200] = "RECT, 62+6-%d, (Y_%d-%d), %d*2, %d*2, 000000, RGB_BLACK, 1, 0, FALSE, TRUE, TRUE, FALSE";
	
	for (i = 0; i < CNT; i++) {
		pos = (tmp[i].end - 2500) / 50;
		
		if (pos < 0)  {continue;}
		if (pos > 30) {continue;}
		
		rate[pos]++;
	}
	
	for (i = 0; i < 31; i++) {
		if (rate[i] >max) {max = rate[i];}
	}
	
	for (i = 0; i < 31; i++) {
		pos = 2500+i*50;
		
		if (rate[i] == 0) {
		}
		else if (rate[i] <= ((max*1)/6)) {
			PRINT(fmt3_1, 1, pos, 1, 1, 1);
		}
		else if (rate[i] <= ((max*2)/6)) {
			PRINT(fmt3_1, 2, pos, 2, 2, 2);
		}
		else if (rate[i] <= ((max*3)/6)) {
			PRINT(fmt3_1, 3, pos, 3, 3, 3);
		}
		else if (rate[i] <= ((max*4)/6)) {
			PRINT(fmt3_1, 4, pos, 4, 4, 4);
		}
		else if (rate[i] <= ((max*5)/6)) {
			PRINT(fmt3_1, 5, pos, 5, 5, 5);
		}
		else if (rate[i] <= ((max*6)/6)) {
			PRINT(fmt3_1, 6, pos, 6, 6, 6);
		}
	}
	PRINT("");
	
	INT8 fmt4_1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f* 1-MIN))/RANGE), %s";
	INT8 fmt4_2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f*%2d-MIN))/RANGE)";
	
	PRINT(fmt4_1, OUT+1, ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], "RGB_AVE100, 7");
	PRINT(fmt4_2, DAYS,  ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], "RGB_AVE75, 2");
	PRINT(fmt4_2, DAYS,  ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], "RGB_AVE25, 2");
	PRINT(fmt4_2, DAYS,  ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], DAYS-OUT);
	PRINT("");
	PRINT(fmt4_1, OUT+1, ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], "RGB_AVE5, 2");
	PRINT(fmt4_2, DAYS,  ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], DAYS-OUT);
}

/*------------------------------------------------------------------------------
	書式：void fprintf_crlf(char *pStr, ...)
	引数：char *  -
	      ...     -
	機能：出力
------------------------------------------------------------------------------*/
void fprintf_crlf(char *pStr, ...)
{
	va_list args;
	
	va_start(args, pStr);
	
	vfprintf(fp, pStr, args);
	fprintf(fp, "\r\n");
	
	va_end(args); 
}

/*------------------------------------------------------------------------------
	実体
------------------------------------------------------------------------------*/
Field field[CNT] = {
	{0x231114,	3757,	3795,	3757,	3787,	 +45,	 7138200,},
	{0x231113,	3735,	3751,	3722,	3742,	 +22,	 6079700,},
	{0x231110,	3670,	3725,	3666,	3720,	 +44,	 7005600,},
	{0x231109,	3657,	3679,	3633,	3676,	 +19,	 4927600,},
	{0x231108,	3697,	3704,	3625,	3657,	 -18,	 9046200,},
	{0x231107,	3697,	3735,	3668,	3675,	  -6,	 8229200,},
	{0x231106,	3700,	3717,	3662,	3681,	 +21,	10458800,},
	{0x231102,	3672,	3683,	3641,	3660,	  -2,	 8850600,},
	{0x231101,	3559,	3665,	3557,	3662,	+141,	19204500,},
	{0x231031,	3470,	3532,	3456,	3521,	 +66,	11632600,},
	{0x231030,	3484,	3484,	3438,	3455,	 -30,	 7732400,},
	{0x231027,	3463,	3489,	3449,	3485,	 +30,	 7190700,},
	{0x231026,	3453,	3475,	3442,	3455,	 -13,	 5288000,},
	{0x231025,	3448,	3486,	3444,	3468,	 +39,	 7894400,},
	{0x231024,	3434,	3449,	3384,	3429,	   0,	 7877000,},
	{0x231023,	3426,	3443,	3421,	3429,	  +6,	 4153700,},
	{0x231020,	3429,	3448,	3419,	3423,	  -8,	 5015600,},
	{0x231019,	3420,	3444,	3405,	3431,	 -19,	 5482700,},
	{0x231018,	3419,	3455,	3404,	3450,	 +51,	 7634300,},
	{0x231017,	3408,	3423,	3388,	3399,	 +11,	 4578600,},
	{0x231016,	3396,	3403,	3372,	3388,	 -18,	 4865700,},
	{0x231013,	3401,	3420,	3388,	3406,	 -14,	 5337500,},
	{0x231012,	3407.0,	3423.0,	3395.0,	3420.0,	 +34.0,	 5948700,},
	{0x231011,	3370.0,	3403.0,	3349.0,	3386.0,	 +21.0,	 6166300,},
	{0x231010,	3324.0,	3374.0,	3324.0,	3365.0,	 +62.0,	 7412600,},
	{0x231006,	3242.0,	3321.0,	3211.0,	3303.0,	 +64.0,	 9046200,},
	{0x231005,	3315.0,	3315.0,	3228.0,	3239.0,	 -33.0,	18831900,},
	{0x231004,	3385.0,	3389.0,	3270.0,	3272.0,	-157.0,	17495300,},
	{0x231003,	3449.0,	3449.0,	3404.0,	3429.0,	 -20.0,	 7198500,},
	{0x231002,	3449.0,	3487.0,	3432.0,	3449.0,	  +9.0,	 6723400,},
	{0x230929,	3466.0,	3474.0,	3430.0,	3440.0,	 -27.0,	 7328600,},
	{0x230928,	3446.0,	3483.0,	3435.0,	3467.0,	 +35.0,	 9451900,},
	{0x230927,	3435.0,	3436.0,	3380.0,	3432.0,	  -3.0,	 8648800,},
	{0x230926,	3479.0,	3479.0,	3421.0,	3435.0,	 -38.0,	 8715700,},
	{0x230925,	3442.0,	3480.0,	3433.0,	3473.0,	 +47.0,	 7238500,},
	{0x230922,	3420.0,	3434.0,	3385.0,	3426.0,	  -3.0,	 7534300,},
	{0x230921,	3444.0,	3464.0,	3423.0,	3429.0,	  -1.0,	 7894000,},
	{0x230920,	3412.0,	3438.0,	3405.0,	3430.0,	 +46.0,	 9208100,},
	{0x230919,	3340.0,	3388.0,	3335.0,	3384.0,	 +51.0,	 7653400,},
	{0x230915,	3326.0,	3348.0,	3319.0,	3333.0,	 +20.0,	 9254000,},
	{0x230914,	3260.0,	3315.0,	3259.0,	3313.0,	 +62.0,	 8782100,},
	{0x230913,	3242.0,	3256.0,	3232.0,	3251.0,	 +13.0,	 5102300,},
	{0x230912,	3238.0,	3253.0,	3224.0,	3238.0,	  +8.0,	 4159900,},
	{0x230911,	3251.0,	3253.0,	3225.0,	3230.0,	  -8.0,	 3892400,},
	{0x230908,	3241.0,	3251.0,	3232.0,	3238.0,	 -16.0,	 5145400,},
	{0x230907,	3216.0,	3256.0,	3209.0,	3254.0,	 +43.0,	 9173400,},
	{0x230906,	3221.0,	3224.0,	3211.0,	3211.0,	  -1.0,	 4113100,},
	{0x230905,	3226.0,	3226.0,	3197.0,	3212.0,	 -13.0,	 5989800,},
	{0x230904,	3208.0,	3225.0,	3202.0,	3225.0,	 +23.0,	 5540300,},
	{0x230901,	3186.0,	3204.0,	3184.0,	3202.0,	 +11.0,	 4780100,},
	{0x230831,	3200.0,	3202.0,	3185.0,	3191.0,	  -7.0,	 6064100,},
	{0x230830,	3168.0,	3209.0,	3163.0,	3198.0,	 +31.0,	 6692300,},
	{0x230829,	3183.0,	3185.0,	3163.0,	3167.0,	  -3.0,	 3851400,},
	{0x230828,	3127.0,	3175.0,	3127.0,	3170.0,	 +35.0,	 6616400,},
	{0x230825,	3139.0,	3153.0,	3121.0,	3135.0,	 -13.0,	 4886900,},
	{0x230824,	3124.0,	3152.0,	3114.0,	3148.0,	 +24.0,	 6259100,},
	{0x230823,	3101.0,	3127.0,	3101.0,	3124.0,	 +13.0,	 3977400,},
	{0x230822,	3090.0,	3117.0,	3086.0,	3111.0,	 +29.0,	 6085400,},
	{0x230821,	3090.0,	3103.0,	3082.0,	3082.0,	  -7.0,	 4837000,},
	{0x230818,	3078.0,	3098.0,	3074.0,	3089.0,	  +4.0,	 3643600,},
	{0x230817,	3095.0,	3098.0,	3072.0,	3085.0,	 -13.0,	 5892100,},
	{0x230816,	3100.0,	3120.0,	3093.0,	3098.0,	  -5.0,	 5547700,},
	{0x230815,	3115.0,	3117.0,	3099.0,	3103.0,	 -12.0,	 4612300,},
	{0x230814,	3115.0,	3124.0,	3110.0,	3115.0,	  +5.0,	 3902600,},
	{0x230810,	3098.0,	3118.0,	3094.0,	3110.0,	 +13.0,	 5401000,},
	{0x230809,	3104.0,	3106.0,	3093.0,	3097.0,	  -7.0,	 3719700,},
	{0x230808,	3099.0,	3110.0,	3089.0,	3104.0,	 +14.0,	 5210100,},
	{0x230807,	3099.0,	3108.0,	3084.0,	3090.0,	 -16.0,	 5073600,},
	{0x230804,	3076.0,	3106.0,	3073.0,	3106.0,	 +18.0,	 5400800,},
	{0x230803,	3089.0,	3095.0,	3078.0,	3088.0,	  -4.0,	 5650200,},
	{0x230802,	3092.0,	3105.0,	3082.0,	3092.0,	 -13.0,	 6544300,},
	{0x230801,	3137.0,	3145.0,	3090.0,	3105.0,	 -48.0,	13405900,},
	{0x230731,	3125.0,	3162.0,	3110.0,	3153.0,	 +56.0,	11636600,},
	{0x230728,	3096.0,	3107.0,	3060.0,	3097.0,	  -9.0,	16871700,},
	{0x230727,	3092.0,	3109.0,	3088.0,	3106.0,	  +3.0,	 4306400,},
	{0x230726,	3109.0,	3109.0,	3091.0,	3103.0,	  -5.0,	 4160300,},
	{0x230725,	3120.0,	3120.0,	3099.0,	3108.0,	  -5.0,	 4669200,},
	{0x230724,	3106.0,	3118.0,	3098.0,	3113.0,	 +21.0,	 4810000,},
	{0x230721,	3090.0,	3097.0,	3071.0,	3092.0,	  +4.0,	 4545100,},
	{0x230720,	3080.0,	3095.0,	3076.0,	3088.0,	 +14.0,	 5051700,},
	{0x230719,	3085.0,	3086.0,	3064.0,	3074.0,	 +15.0,	 5518500,},
	{0x230718,	3022.0,	3067.0,	3020.0,	3059.0,	 +43.0,	 5416600,},
	{0x230714,	3012.0,	3033.0,	2997.0,	3016.0,	 -10.0,	 8043200,},
	{0x230713,	3016.0,	3034.0,	3000.0,	3026.0,	 +11.0,	 5204400,},
	{0x230712,	3038.0,	3047.0,	3014.0,	3015.0,	 -23.0,	 6312500,},
	{0x230711,	3049.0,	3066.0,	3038.0,	3038.0,	 -13.0,	 5828600,},
	{0x230710,	3088.0,	3089.0,	3041.0,	3051.0,	 -45.0,	10205800,},
	{0x230707,	3120.0,	3121.0,	3093.0,	3096.0,	 -31.0,	 8504700,},
	{0x230706,	3140.0,	3154.0,	3124.0,	3127.0,	  -8.0,	 7113000,},
	{0x230705,	3135.0,	3139.0,	3126.0,	3135.0,	  -6.0,	 5308000,},
	{0x230704,	3140.0,	3146.0,	3123.0,	3141.0,	  -8.0,	 7118400,},
	{0x230703,	3160.0,	3171.0,	3140.0,	3149.0,	  -4.0,	 8689700,},
	{0x230630,	3112.0,	3159.0,	3111.0,	3153.0,	 +49.0,	12498600,},
	{0x230629,	3100.0,	3136.0,	3091.0,	3104.0,	-118.0,	19182800,},
	{0x230628,	3214.0,	3231.0,	3191.0,	3222.0,	  +8.0,	17928700,},
	{0x230627,	3250.0,	3252.0,	3203.0,	3214.0,	 -25.0,	13857900,},
	{0x230626,	3205.0,	3243.0,	3195.0,	3239.0,	 +36.0,	10741600,},
	{0x230623,	3216.0,	3229.0,	3193.0,	3203.0,	  -2.0,	12000500,},
	{0x230622,	3208.0,	3223.0,	3201.0,	3205.0,	  +1.0,	 8298100,},
	{0x230621,	3190.0,	3204.0,	3188.0,	3204.0,	 +15.0,	 7148200,},
	{0x230620,	3184.0,	3191.0,	3177.0,	3189.0,	  +2.0,	 5010600,},
	{0x230619,	3212.0,	3213.0,	3172.0,	3187.0,	 -14.0,	 7566100,},
	{0x230616,	3214.0,	3216.0,	3184.0,	3201.0,	 -13.0,	10598300,},
	{0x230615,	3200.0,	3222.0,	3185.0,	3214.0,	 +14.0,	 8451000,},
	{0x230614,	3195.0,	3204.0,	3184.0,	3200.0,	 +22.0,	 8193600,},
	{0x230613,	3158.0,	3182.0,	3150.0,	3178.0,	 +30.0,	 7175100,},
	{0x230612,	3155.0,	3174.0,	3148.0,	3148.0,	  +7.0,	 7032700,},
	{0x230609,	3124.0,	3145.0,	3115.0,	3141.0,	 +26.0,	 7326800,},
	{0x230608,	3122.0,	3128.0,	3105.0,	3115.0,	  -5.0,	 7126300,},
	{0x230607,	3145.0,	3153.0,	3117.0,	3120.0,	 -19.0,	 8583900,},
	{0x230606,	3110.0,	3139.0,	3106.0,	3139.0,	 +22.0,	 6452500,},
	{0x230605,	3111.0,	3133.0,	3105.0,	3117.0,	 +33.0,	 7429200,},
	{0x230602,	3067.0,	3084.0,	3061.0,	3084.0,	 +23.0,	 4859400,},
	{0x230601,	3048.0,	3070.0,	3044.0,	3061.0,	 +21.0,	 4343100,},
	{0x230531,	3065.0,	3066.0,	3037.0,	3040.0,	 -37.0,	 8302300,},
	{0x230530,	3080.0,	3081.0,	3061.0,	3077.0,	  -6.0,	 5078000,},
	{0x230529,	3088.0,	3094.0,	3079.0,	3083.0,	 +11.0,	 3874500,},
	{0x230526,	3080.0,	3088.0,	3071.0,	3072.0,	  -8.0,	 4262900,},
	{0x230525,	3080.0,	3093.0,	3068.0,	3080.0,	  -8.0,	 3925400,},
	{0x230524,	3092.0,	3102.0,	3081.0,	3088.0,	  -1.0,	 4886500,},
	{0x230523,	3109.0,	3112.0,	3072.0,	3089.0,	 -14.0,	 8045300,},
	{0x230522,	3053.0,	3109.0,	3051.0,	3103.0,	 +57.0,	10092300,},
	{0x230519,	3060.0,	3061.0,	3041.0,	3046.0,	 -18.0,	 5082400,},
	{0x230518,	3055.0,	3064.0,	3033.0,	3064.0,	 +17.0,	 6374500,},
	{0x230517,	3066.0,	3069.0,	3043.0,	3047.0,	 -15.0,	 7667300,},
	{0x230516,	3036.0,	3064.0,	3031.0,	3062.0,	 +30.0,	 7951000,},
	{0x230515,	3038.0,	3043.0,	3015.0,	3032.0,	 +17.0,	 5367000,},
	{0x230512,	2975.5,	3020.0,	2975.0,	3015.0,	 +51.0,	 8428300,},
	{0x230511,	2982.0,	2988.5,	2962.0,	2964.0,	 -21.5,	 6535800,},
	{0x230510,	3001.0,	3013.0,	2980.0,	2985.5,	  -1.5,	 7629200,},
	{0x230509,	2985.0,	2994.0,	2970.5,	2987.0,	  +7.5,	 6891600,},
	{0x230508,	2970.0,	3049.0,	2965.5,	2979.5,	 +45.5,	14265500,},
	{0x230502,	2956.5,	2958.0,	2930.0,	2934.0,	 -17.5,	 7267100,},
	{0x230501,	2940.0,	2963.5,	2936.0,	2951.5,	 +28.0,	 7547900,},
	{0x230428,	2922.0,	2928.0,	2907.5,	2923.5,	  +7.0,	 5944500,},
	{0x230427,	2895.0,	2916.5,	2887.0,	2916.5,	 +21.0,	 5165500,},
	{0x230426,	2895.5,	2907.5,	2892.5,	2895.5,	  -3.5,	 4386600,},
	{0x230425,	2879.5,	2908.0,	2873.5,	2899.0,	 +30.0,	 6494900,},
	{0x230424,	2889.0,	2894.5,	2867.5,	2869.0,	  -3.5,	 4808900,},
	{0x230421,	2874.5,	2878.0,	2851.0,	2872.5,	  -7.0,	 4109700,},
	{0x230420,	2882.5,	2886.5,	2865.0,	2879.5,	  -9.5,	 4576500,},
	{0x230419,	2852.0,	2889.5,	2850.5,	2889.0,	 +37.5,	 6984800,},
	{0x230418,	2842.5,	2859.0,	2838.0,	2851.5,	 +24.0,	 5972700,},
	{0x230417,	2815.0,	2834.0,	2805.5,	2827.5,	 +20.0,	 6232500,},
	{0x230414,	2807.0,	2808.5,	2792.5,	2807.5,	 +14.0,	 4689900,},
	{0x230413,	2793.5,	2798.0,	2777.0,	2793.5,	  -1.5,	 5016600,},
	{0x230412,	2811.0,	2815.5,	2794.0,	2795.0,	  -5.0,	 6248300,},
	{0x230411,	2800.5,	2811.0,	2795.0,	2800.0,	  +4.0,	 4644400,},
	{0x230410,	2782.0,	2805.5,	2782.0,	2796.0,	 +29.5,	 4365400,},
	{0x230407,	2780.0,	2781.5,	2766.0,	2766.5,	 -13.5,	 4867700,},
	{0x230406,	2785.0,	2801.0,	2763.5,	2780.0,	   0.0,	 6775300,},
	{0x230405,	2800.5,	2804.5,	2780.0,	2780.0,	 -25.0,	 5487900,},
	{0x230404,	2800.0,	2811.5,	2793.5,	2805.0,	 +10.0,	 4813900,},
	{0x230403,	2803.0,	2809.0,	2780.5,	2795.0,	  -3.0,	 5899300,},
	{0x230331,	2848.0,	2875.5,	2792.0,	2798.0,	 -40.5,	10753400,},
	{0x230330,	2800.0,	2839.0,	2795.5,	2838.5,	 +38.5,	 6186500,},
	{0x230329,	2789.0,	2800.0,	2776.0,	2800.0,	 +24.0,	 6107500,},
	{0x230328,	2755.0,	2777.5,	2748.0,	2776.0,	 +38.0,	 5369600,},
	{0x230327,	2745.0,	2746.5,	2730.5,	2738.0,	 +15.0,	 3269700,},
	{0x230324,	2716.0,	2726.5,	2711.0,	2723.0,	  -0.5,	 3354300,},
	{0x230323,	2740.5,	2741.5,	2721.0,	2723.5,	 -19.0,	 3543700,},
	{0x230322,	2729.0,	2752.5,	2697.5,	2742.5,	 +39.0,	 4984600,},
	{0x230320,	2725.0,	2733.5,	2697.0,	2703.5,	 -19.0,	 4933500,},
	{0x230317,	2737.0,	2737.0,	2712.0,	2722.5,	 -15.0,	 5411000,},
	{0x230316,	2709.5,	2738.0,	2702.5,	2737.5,	  -9.5,	 4438500,},
	{0x230315,	2756.0,	2771.5,	2739.5,	2747.0,	 +23.5,	 4301700,},
	{0x230314,	2741.0,	2746.0,	2685.0,	2723.5,	 -45.5,	 6503000,},
	{0x230313,	2755.5,	2772.5,	2740.5,	2769.0,	  -9.5,	 4349700,},
	{0x230310,	2788.5,	2797.0,	2768.5,	2778.5,	 -16.5,	 5380900,},
	{0x230309,	2787.5,	2800.0,	2785.5,	2795.0,	 +14.0,	 4606600,},
	{0x230308,	2765.0,	2785.5,	2763.5,	2781.0,	 +19.5,	 4699200,},
	{0x230307,	2765.5,	2768.0,	2751.0,	2761.5,	  +3.0,	 3423700,},
	{0x230306,	2744.5,	2763.0,	2744.5,	2758.5,	 +23.0,	 4808600,},
	{0x230303,	2728.0,	2744.0,	2720.5,	2735.5,	 +12.5,	 4547900,},
	{0x230302,	2758.0,	2763.5,	2720.5,	2723.0,	 -33.0,	 4546900,},
	{0x230301,	2758.5,	2760.0,	2733.0,	2756.0,	 -13.5,	 4940200,},
	{0x230228,	2795.0,	2796.0,	2757.0,	2769.5,	 -28.0,	 5297900,},
	{0x230227,	2795.0,	2797.5,	2779.5,	2797.5,	  +1.0,	 2723100,},
	{0x230224,	2777.5,	2802.0,	2777.0,	2796.5,	 +23.0,	 4500300,},
	{0x230222,	2781.5,	2784.5,	2768.5,	2773.5,	  -8.5,	 3451500,},
	{0x230221,	2792.0,	2793.0,	2776.0,	2782.0,	  -6.5,	 2733700,},
	{0x230220,	2785.0,	2805.0,	2781.0,	2788.5,	 +17.5,	 5062400,},
	{0x230217,	2768.5,	2775.5,	2752.5,	2771.0,	  -7.5,	 4377000,},
	{0x230216,	2786.0,	2798.0,	2762.5,	2778.5,	  -8.0,	 6121400,},
	{0x230215,	2752.5,	2788.0,	2735.5,	2786.5,	 +66.5,	10071500,},
	{0x230214,	2683.0,	2721.0,	2680.0,	2720.0,	 +52.5,	 6503800,},
	{0x230213,	2654.5,	2670.0,	2642.0,	2667.5,	 +28.0,	 4391600,},
	{0x230210,	2627.0,	2646.0,	2618.0,	2639.5,	  +8.5,	 3467500,},
	{0x230209,	2638.0,	2642.0,	2629.0,	2631.0,	  -9.5,	 2421900,},
	{0x230208,	2645.0,	2652.5,	2634.0,	2640.5,	  -5.0,	 3213100,},
	{0x230207,	2655.0,	2656.0,	2644.0,	2645.5,	  +9.5,	 2632000,},
	{0x230206,	2635.0,	2641.0,	2625.0,	2636.0,	 +20.0,	 2964300,},
	{0x230203,	2621.5,	2625.5,	2611.0,	2616.0,	 -13.0,	 3116400,},
	{0x230202,	2644.0,	2646.0,	2623.5,	2629.0,	 -21.5,	 3013800,},
	{0x230201,	2660.0,	2671.0,	2650.5,	2650.5,	  -4.5,	 3365200,},
	{0x230131,	2660.0,	2667.5,	2650.5,	2655.0,	  +5.5,	 2836000,},
	{0x230130,	2666.5,	2671.0,	2639.0,	2649.5,	 -26.0,	 4345600,},
	{0x230127,	2671.5,	2677.0,	2666.0,	2675.5,	  -1.0,	 3023200,},
	{0x230126,	2672.0,	2679.0,	2667.0,	2676.5,	  +1.0,	 3304200,},
	{0x230125,	2670.0,	2682.0,	2666.5,	2675.5,	  +8.5,	 3875000,},
	{0x230124,	2663.5,	2673.5,	2652.0,	2667.0,	 +18.0,	 4478800,},
	{0x230123,	2654.0,	2657.5,	2640.0,	2649.0,	 +19.0,	 4570400,},
	{0x230120,	2598.0,	2630.0,	2593.0,	2630.0,	 +41.5,	 4983600,},
	{0x230119,	2590.0,	2604.0,	2587.5,	2588.5,	  -6.0,	 4065700,},
	{0x230118,	2575.0,	2608.0,	2572.5,	2594.5,	 +28.0,	 5446100,},
	{0x230117,	2550.0,	2572.5,	2547.0,	2566.5,	 +23.5,	 3524100,},
	{0x230116,	2557.0,	2561.0,	2537.5,	2543.0,	 -20.5,	 4248800,},
	{0x230113,	2561.0,	2579.0,	2555.5,	2563.5,	 -18.0,	 4943400,},
	{0x230112,	2581.0,	2589.0,	2555.5,	2581.5,	  -2.5,	 5244200,},
	{0x230111,	2600.5,	2609.5,	2576.0,	2584.0,	 -21.0,	 6008900,},
	{0x230110,	2611.5,	2625.0,	2601.0,	2605.0,	  -5.5,	 5684000,},
	{0x230106,	2615.0,	2627.0,	2609.0,	2610.5,	  -7.0,	 4832900,},
	{0x230105,	2609.5,	2628.0,	2606.0,	2617.5,	 +10.5,	 4830600,},
	{0x230104,	2641.5,	2647.0,	2601.0,	2607.0,	 -54.0,	 8483700,},
	{0x221230,	2657.5,	2691.0,	2655.5,	2661.0,	 -15.0,	 6082600,},
	{0x221229,	2725.0,	2731.0,	2665.0,	2676.0,	-167.0,	13561700,},
	{0x221228,	2860.0,	2871.5,	2842.0,	2843.0,	  -4.5,	13347400,},
	{0x221227,	2850.0,	2856.0,	2841.5,	2847.5,	  +5.0,	 7290400,},
	{0x221226,	2832.0,	2844.5,	2828.5,	2842.5,	 +17.5,	 5282300,},
	{0x221223,	2827.0,	2828.5,	2811.5,	2825.0,	  -1.0,	 5645200,},
	{0x221222,	2807.5,	2832.5,	2794.0,	2826.0,	 +30.5,	 5859500,},
	{0x221221,	2838.5,	2840.5,	2793.5,	2795.5,	 -37.0,	11181200,},
	{0x221220,	2836.0,	2858.5,	2823.5,	2832.5,	  +7.5,	10502400,},
	{0x221219,	2830.0,	2836.0,	2824.0,	2825.0,	  +2.0,	 4758500,},
	{0x221216,	2820.0,	2840.5,	2815.5,	2823.0,	   0.0,	 7658000,},
	{0x221215,	2821.0,	2838.0,	2812.0,	2823.0,	  +0.5,	 6206400,},
	{0x221214,	2835.0,	2835.0,	2810.0,	2822.5,	 -17.5,	 8401300,},
	{0x221213,	2835.0,	2843.0,	2830.0,	2840.0,	 +16.0,	 4571600,},
	{0x221212,	2820.0,	2831.5,	2805.5,	2824.0,	  -5.0,	 4111300,},
	{0x221209,	2814.5,	2835.5,	2814.0,	2829.0,	 +10.5,	 4491400,},
	{0x221208,	2820.5,	2824.5,	2808.5,	2818.5,	  +0.5,	 4835200,},
	{0x221207,	2809.0,	2838.0,	2803.5,	2818.0,	  +5.5,	 5319300,},
	{0x221206,	2800.0,	2819.5,	2790.0,	2812.5,	 +28.5,	 4827000,},
	{0x221205,	2790.0,	2793.0,	2771.5,	2784.0,	  +6.0,	 3866300,},
	{0x221202,	2800.0,	2800.5,	2761.0,	2778.0,	 -32.5,	 7521400,},
	{0x221201,	2815.5,	2823.5,	2809.0,	2810.5,	  -5.0,	 4508600,},
	{0x221130,	2810.5,	2826.0,	2805.0,	2815.5,	  -1.0,	 6390300,},
	{0x221129,	2831.0,	2834.5,	2814.0,	2816.5,	 -10.5,	 4638600,},
	{0x221128,	2830.0,	2836.0,	2824.5,	2827.0,	  -4.5,	 4030900,},
	{0x221125,	2826.0,	2843.5,	2820.5,	2831.5,	  +4.0,	 4500000,},
	{0x221124,	2829.5,	2848.0,	2822.0,	2827.5,	  -1.0,	 6156200,},
	{0x221122,	2800.0,	2844.5,	2799.0,	2828.5,	 +33.5,	 7143200,},
	{0x221121,	2793.0,	2801.0,	2783.0,	2795.0,	 +13.5,	 4012300,},
	{0x221118,	2771.0,	2795.0,	2765.5,	2781.5,	 +19.5,	 3593800,},
	{0x221117,	2746.5,	2787.0,	2742.5,	2762.0,	 +25.0,	 4205700,},
	{0x221116,	2740.5,	2751.0,	2723.0,	2737.0,	  -8.0,	 4494200,},
	{0x221115,	2761.0,	2776.5,	2744.5,	2745.0,	  +2.5,	 4432100,},
	{0x221114,	2777.0,	2782.0,	2742.0,	2742.5,	 -38.0,	 6563100,},
	{0x221111,	2802.0,	2810.0,	2773.0,	2780.5,	 -36.5,	12000600,},
	{0x221110,	2799.0,	2824.0,	2793.0,	2817.0,	 +18.0,	 5961500,},
	{0x221109,	2805.0,	2806.0,	2781.0,	2799.0,	  -5.0,	 6184900,},
	{0x221108,	2800.0,	2812.5,	2795.5,	2804.0,	  +8.0,	 6308000,},
	{0x221107,	2789.0,	2809.5,	2783.5,	2796.0,	  +1.0,	 8399700,},
	{0x221104,	2781.0,	2795.0,	2753.5,	2795.0,	  -5.0,	10688600,},
	{0x221102,	2694.5,	2800.0,	2673.0,	2800.0,	+102.0,	15920800,},
	{0x221101,	2610.0,	2698.0,	2609.5,	2698.0,	+234.0,	21064300,},
	{0x221031,	2448.0,	2464.0,	2442.0,	2464.0,	 +34.5,	 4203600,},
	{0x221028,	2434.0,	2442.0,	2424.5,	2429.5,	  -3.0,	11592800,},
	{0x221027,	2460.0,	2460.5,	2432.5,	2432.5,	 -25.0,	 3660300,},
	{0x221026,	2448.5,	2462.5,	2442.5,	2457.5,	  +4.0,	 4013700,},
	{0x221025,	2430.0,	2458.5,	2423.0,	2453.5,	 +49.5,	 6280500,},
	{0x221024,	2427.0,	2433.5,	2404.0,	2404.0,	 -20.0,	 4128600,},
	{0x221021,	2426.0,	2435.0,	2422.0,	2424.0,	 -11.5,	 2998800,},
	{0x221020,	2412.0,	2442.0,	2408.5,	2435.5,	 +13.5,	 3336500,},
	{0x221019,	2433.0,	2437.0,	2418.5,	2422.0,	  -2.5,	 3016600,},
	{0x221018,	2436.0,	2437.0,	2424.5,	2424.5,	  -4.5,	 3474200,},
	{0x221017,	2448.0,	2448.0,	2429.0,	2429.0,	  -5.0,	 3565600,},
	{0x221014,	2425.0,	2443.0,	2419.5,	2434.0,	 +28.5,	 5854800,},
	{0x221013,	2409.0,	2415.5,	2398.0,	2405.5,	  -1.0,	 2756700,},
	{0x221012,	2398.0,	2420.5,	2395.0,	2406.5,	  +8.5,	 4348600,},
	{0x221011,	2389.5,	2410.5,	2384.0,	2398.0,	  +7.5,	 4430500,},
	{0x221007,	2387.5,	2393.5,	2378.0,	2390.5,	 -18.5,	 3909600,},
	{0x221006,	2414.0,	2418.5,	2405.0,	2409.0,	  -1.5,	 3370200,},
	{0x221005,	2415.0,	2419.5,	2400.5,	2410.5,	  +5.5,	 4466300,},
	{0x221004,	2384.0,	2406.5,	2378.5,	2405.0,	 +48.5,	 5681300,},
	{0x221003,	2372.0,	2376.5,	2341.0,	2356.5,	 -17.5,	 5003500,},
	{0x220930,	2380.5,	2386.0,	2363.5,	2374.0,	 -22.5,	 6210700,},
	{0x220929,	2349.5,	2403.0,	2345.0,	2396.5,	 +59.0,	 6907400,},
	{0x220928,	2352.5,	2356.0,	2322.0,	2337.5,	 -34.0,	 6158700,},
	{0x220927,	2351.0,	2376.0,	2350.5,	2371.5,	 +26.0,	 3752900,},
	{0x220926,	2383.0,	2384.5,	2345.5,	2345.5,	 -53.5,	 5283100,},
	{0x220922,	2392.0,	2399.0,	2376.0,	2399.0,	 +16.0,	 3629200,},
	{0x220921,	2398.5,	2399.0,	2380.5,	2383.0,	 -30.5,	 3873000,},
	{0x220920,	2366.0,	2415.5,	2365.5,	2413.5,	 +48.0,	 6552200,},
	{0x220916,	2355.0,	2370.0,	2355.0,	2365.5,	  +4.0,	 4370300,},
	{0x220915,	2361.0,	2365.5,	2351.5,	2361.5,	  +5.0,	 2513400,},
	{0x220914,	2375.0,	2382.0,	2356.5,	2356.5,	 -31.5,	 4895400,},
	{0x220913,	2397.5,	2397.5,	2377.0,	2388.0,	  -6.0,	 2282200,},
	{0x220912,	2390.0,	2399.5,	2381.5,	2394.0,	 +11.0,	 2551800,},
	{0x220909,	2387.0,	2402.0,	2382.0,	2383.0,	  -7.0,	 5715500,},
	{0x220908,	2378.0,	2392.0,	2373.5,	2390.0,	 +18.5,	 4977900,},
	{0x220907,	2367.0,	2379.0,	2363.0,	2371.5,	  +6.0,	 3609800,},
	{0x220906,	2370.0,	2382.0,	2363.0,	2365.5,	  +0.5,	 2857000,},
	{0x220905,	2365.0,	2372.5,	2356.5,	2365.0,	  -9.0,	 2613100,},
	{0x220902,	2375.0,	2378.0,	2361.5,	2374.0,	  +2.0,	 2907100,},
	{0x220901,	2357.0,	2377.0,	2353.0,	2372.0,	 +12.0,	 3630000,},
	{0x220831,	2377.0,	2377.5,	2352.0,	2360.0,	 -17.0,	 4555500,},
	{0x220830,	2370.0,	2382.5,	2365.5,	2377.0,	 +13.0,	 2381900,},
	{0x220829,	2352.5,	2373.5,	2350.5,	2364.0,	   0.0,	 3821400,},
	{0x220826,	2368.5,	2383.0,	2364.0,	2364.0,	  +1.0,	 2976800,},
	{0x220825,	2371.0,	2375.0,	2356.0,	2363.0,	  -7.5,	 2672500,},
	{0x220824,	2369.5,	2379.0,	2361.0,	2370.5,	  -1.0,	 2897500,},
	{0x220823,	2381.5,	2384.0,	2371.5,	2371.5,	 -13.5,	 2690500,},
	{0x220822,	2361.5,	2387.0,	2357.5,	2385.0,	 +18.0,	 3400300,},
	{0x220819,	2358.0,	2371.0,	2353.0,	2367.0,	 +21.5,	 3653800,},
	{0x220818,	2356.5,	2356.5,	2342.5,	2345.5,	 -13.0,	 2844600,},
	{0x220817,	2345.5,	2358.5,	2343.0,	2358.5,	 +23.5,	 4590000,},
	{0x220816,	2330.5,	2339.5,	2326.5,	2335.0,	  +7.0,	 3151000,},
	{0x220815,	2329.5,	2330.0,	2318.5,	2328.0,	  +6.0,	 2800400,},
	{0x220812,	2337.0,	2337.0,	2314.5,	2322.0,	  +7.0,	 4892600,},
	{0x220810,	2300.0,	2315.0,	2288.5,	2315.0,	 +26.0,	 3474200,},
	{0x220809,	2309.0,	2315.0,	2287.0,	2289.0,	 -18.0,	 3893100,},
	{0x220808,	2294.0,	2307.0,	2283.0,	2307.0,	 +14.0,	 3666600,},
	{0x220805,	2281.5,	2300.0,	2281.0,	2293.0,	  +8.5,	 3433300,},
	{0x220804,	2304.0,	2305.0,	2275.5,	2284.5,	 -11.5,	 4914000,},
	{0x220803,	2300.5,	2306.5,	2283.5,	2296.0,	  +4.0,	 5263700,},
	{0x220802,	2323.5,	2334.5,	2292.0,	2292.0,	 -39.0,	 8790700,},
	{0x220801,	2370.0,	2373.5,	2321.0,	2331.0,	 -56.5,	11353300,},
	{0x220729,	2428.0,	2429.0,	2377.5,	2387.5,	 -45.5,	 6893300,},
	{0x220728,	2430.0,	2434.5,	2413.5,	2433.0,	  +3.5,	 4921300,},
	{0x220727,	2420.0,	2441.0,	2417.5,	2429.5,	   0.0,	 6204100,},
};
