/*------------------------------------------------------------------------------
	インクルード
------------------------------------------------------------------------------*/
#include <stdio.h>

/*------------------------------------------------------------------------------
	型定義
------------------------------------------------------------------------------*/
typedef char INT8;
typedef int  INT32;

/*------------------------------------------------------------------------------
	デファイン
------------------------------------------------------------------------------*/
#define CNT 27
#define OUT 3

/*------------------------------------------------------------------------------
	構造体
------------------------------------------------------------------------------*/
typedef struct Field {
	INT32 date;
	double stock;
	double ratio;
	INT32 trade;
} Field;

/*------------------------------------------------------------------------------
	ローカル変数
------------------------------------------------------------------------------*/
Field field[CNT] = {
	{0x230502, 1656,  +48,  6440600,},
	{0x230501, 1608,  +24,  6621000,},
	{0x230428, 1584, +139, 21544700,},
	{0x230427, 1445,  -25,  1110200,},
	{0x230426, 1470,   -7,  2264200,},
	{0x230425, 1477,  +27,  1525500,},
	{0x230424, 1450,  -17,  2255600,},
	{0x230421, 1467,  -73,  4185400,},
	{0x230420, 1540,  -57,  3418700,},
	{0x230419, 1597,   -2,  7666900,},
	{0x230418, 1599,  +99, 16470900,},
	{0x230417, 1500, +100,  9657000,},
	{0x230414, 1400,  +30,  2491800,},
	{0x230413, 1370,  -47,  3079600,},
	{0x230412, 1417,  +71,  2762800,},
	{0x230411, 1346,  +12,  3315400,},
	{0x230410, 1334,   -7,  1466900,},
	{0x230407, 1341,    0,  1676700,},
	{0x230406, 1341,  -54,  2761800,},
	{0x230405, 1395,  +31,  2998400,},
	{0x230404, 1364,  -58,  2690600,},
	{0x230403, 1422,  +73,  5421200,},
	{0x230331, 1349,  +23,  4935600,},
	{0x230330, 1303, -142,  9858700,},
	{0x230329, 1450,   -2, 16315200,},
	{0x230328, 1328,  +70, 28404400,},
	{0x230327, 1390,    0, 20063000,},
};

/*------------------------------------------------------------------------------
	書式：int main(void)
	引数：-
	戻値：int  -
	機能：スタートアップ
------------------------------------------------------------------------------*/
int main(void)
{
	INT32 i, j;
	INT32 cnt;
	double ave5 [CNT];
	double ave25[CNT];
	double ave75[CNT];
	Field tmp[CNT];
	
	for (i = 0; i < CNT; i++) {tmp[i] = field[CNT-1-i];}
	
	for (i = 0; i < CNT; i++) {
		ave5 [i] = 0.0;
		ave25[i] = 0.0;
		ave75[i] = 0.0;
		
		if (4 <= i) {
			for (j = 0; j < 5; j++) {
				ave5[i] += tmp[i-j].stock;
			}
			ave5[i] /= 5;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave5[i] += tmp[i-j].stock;
			}
			ave5[i] /= cnt;
		}
		
		if (24 <= i) {
			for (j = 0; j < 25; j++) {
				ave25[i] += tmp[i-j].stock;
			}
			ave25[i] /= 25;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave25[i] += tmp[i-j].stock;
			}
			ave25[i] /= cnt;
		}
		
		if (74 <= i) {
			for (j = 0; j < 75; j++) {
				ave75[i] += tmp[i-j].stock;
			}
			ave75[i] /= 75;
		}
		else {
			cnt = i+1;
			for (j = 0; j < cnt; j++) {
				ave75[i] += tmp[i-j].stock;
			}
			ave75[i] /= cnt;
		}
	}
	
	INT8 fmt1[200] = "LINETO, 95+(670/20)* , 658-(600 / 420)*(%.1f-1220)\r\n";
	INT8 fmt2[200] =   "TEXT, 94+(670/20)* , 40+14*(43-(%.1f-1220)/10) ,%X, 000000, 000000, TRUE, Arial, 12, FALSE\r\n";
	INT8 fmt3[200] =   "RECT, 95+(670/20)* , 831-(%8d/250000), 6, %8d/250000, 000000, %s, 1, 0, FALSE, TRUE, FALSE, FALSE\r\n";
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			printf(fmt1, ave75[i]);
		}
	}
	printf("\r\n");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			printf(fmt1, ave25[i]);
		}
	}
	printf("\r\n");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			printf(fmt1, ave5[i]);
		}
	}
	printf("\r\n");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			printf(fmt2, tmp[i].stock, tmp[i].date & 0x000000FF);
		}
	}
	printf("\r\n");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUT) <= i) {
			
			if (tmp[i].ratio > 0) {
				printf(fmt3, tmp[i].trade, tmp[i].trade, "F00000");
			}
			else {
				printf(fmt3, tmp[i].trade, tmp[i].trade, "0000F0");
			}
		}
	}
	printf("\r\n");
}
